/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.util.PortalUtil;

import com.qti.slayer.service.AssignmentLocalServiceUtil;
import com.qti.slayer.service.persistence.AssignmentPK;

import java.io.Serializable;

import java.lang.reflect.Proxy;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Hector
 */
public class AssignmentClp extends BaseModelImpl<Assignment>
	implements Assignment {
	public AssignmentClp() {
	}

	public Class<?> getModelClass() {
		return Assignment.class;
	}

	public String getModelClassName() {
		return Assignment.class.getName();
	}

	public AssignmentPK getPrimaryKey() {
		return new AssignmentPK(_userId, _uolId);
	}

	public void setPrimaryKey(AssignmentPK primaryKey) {
		setUserId(primaryKey.userId);
		setUolId(primaryKey.uolId);
	}

	public Serializable getPrimaryKeyObj() {
		return new AssignmentPK(_userId, _uolId);
	}

	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey((AssignmentPK)primaryKeyObj);
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("userId", getUserId());
		attributes.put("uolId", getUolId());
		attributes.put("status", getStatus());
		attributes.put("uoltype", getUoltype());
		attributes.put("title", getTitle());
		attributes.put("username", getUsername());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}

		Long uolId = (Long)attributes.get("uolId");

		if (uolId != null) {
			setUolId(uolId);
		}

		Integer status = (Integer)attributes.get("status");

		if (status != null) {
			setStatus(status);
		}

		Integer uoltype = (Integer)attributes.get("uoltype");

		if (uoltype != null) {
			setUoltype(uoltype);
		}

		String title = (String)attributes.get("title");

		if (title != null) {
			setTitle(title);
		}

		String username = (String)attributes.get("username");

		if (username != null) {
			setUsername(username);
		}
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
	}

	public void setUserUuid(String userUuid) {
		_userUuid = userUuid;
	}

	public long getUolId() {
		return _uolId;
	}

	public void setUolId(long uolId) {
		_uolId = uolId;
	}

	public int getStatus() {
		return _status;
	}

	public void setStatus(int status) {
		_status = status;
	}

	public int getUoltype() {
		return _uoltype;
	}

	public void setUoltype(int uoltype) {
		_uoltype = uoltype;
	}

	public String getTitle() {
		return _title;
	}

	public void setTitle(String title) {
		_title = title;
	}

	public String getUsername() {
		return _username;
	}

	public void setUsername(String username) {
		_username = username;
	}

	public BaseModel<?> getAssignmentRemoteModel() {
		return _assignmentRemoteModel;
	}

	public void setAssignmentRemoteModel(BaseModel<?> assignmentRemoteModel) {
		_assignmentRemoteModel = assignmentRemoteModel;
	}

	public void persist() throws SystemException {
		if (this.isNew()) {
			AssignmentLocalServiceUtil.addAssignment(this);
		}
		else {
			AssignmentLocalServiceUtil.updateAssignment(this);
		}
	}

	@Override
	public Assignment toEscapedModel() {
		return (Assignment)Proxy.newProxyInstance(Assignment.class.getClassLoader(),
			new Class[] { Assignment.class }, new AutoEscapeBeanHandler(this));
	}

	@Override
	public Object clone() {
		AssignmentClp clone = new AssignmentClp();

		clone.setUserId(getUserId());
		clone.setUolId(getUolId());
		clone.setStatus(getStatus());
		clone.setUoltype(getUoltype());
		clone.setTitle(getTitle());
		clone.setUsername(getUsername());

		return clone;
	}

	public int compareTo(Assignment assignment) {
		int value = 0;

		if (getUserId() < assignment.getUserId()) {
			value = -1;
		}
		else if (getUserId() > assignment.getUserId()) {
			value = 1;
		}
		else {
			value = 0;
		}

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		AssignmentClp assignment = null;

		try {
			assignment = (AssignmentClp)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		AssignmentPK primaryKey = assignment.getPrimaryKey();

		if (getPrimaryKey().equals(primaryKey)) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return getPrimaryKey().hashCode();
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(13);

		sb.append("{userId=");
		sb.append(getUserId());
		sb.append(", uolId=");
		sb.append(getUolId());
		sb.append(", status=");
		sb.append(getStatus());
		sb.append(", uoltype=");
		sb.append(getUoltype());
		sb.append(", title=");
		sb.append(getTitle());
		sb.append(", username=");
		sb.append(getUsername());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(22);

		sb.append("<model><model-name>");
		sb.append("com.qti.slayer.model.Assignment");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>uolId</column-name><column-value><![CDATA[");
		sb.append(getUolId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>status</column-name><column-value><![CDATA[");
		sb.append(getStatus());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>uoltype</column-name><column-value><![CDATA[");
		sb.append(getUoltype());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>title</column-name><column-value><![CDATA[");
		sb.append(getTitle());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>username</column-name><column-value><![CDATA[");
		sb.append(getUsername());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _userId;
	private String _userUuid;
	private long _uolId;
	private int _status;
	private int _uoltype;
	private String _title;
	private String _username;
	private BaseModel<?> _assignmentRemoteModel;
}