/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import com.qti.slayer.service.persistence.AssignmentPK;

import java.io.Serializable;

/**
 * The base model interface for the Assignment service. Represents a row in the &quot;QTI_Assignment&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.qti.slayer.model.impl.AssignmentModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.qti.slayer.model.impl.AssignmentImpl}.
 * </p>
 *
 * @author Hector
 * @see Assignment
 * @see com.qti.slayer.model.impl.AssignmentImpl
 * @see com.qti.slayer.model.impl.AssignmentModelImpl
 * @generated
 */
public interface AssignmentModel extends BaseModel<Assignment> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a assignment model instance should use the {@link Assignment} interface instead.
	 */

	/**
	 * Returns the primary key of this assignment.
	 *
	 * @return the primary key of this assignment
	 */
	public AssignmentPK getPrimaryKey();

	/**
	 * Sets the primary key of this assignment.
	 *
	 * @param primaryKey the primary key of this assignment
	 */
	public void setPrimaryKey(AssignmentPK primaryKey);

	/**
	 * Returns the user ID of this assignment.
	 *
	 * @return the user ID of this assignment
	 */
	public long getUserId();

	/**
	 * Sets the user ID of this assignment.
	 *
	 * @param userId the user ID of this assignment
	 */
	public void setUserId(long userId);

	/**
	 * Returns the user uuid of this assignment.
	 *
	 * @return the user uuid of this assignment
	 * @throws SystemException if a system exception occurred
	 */
	public String getUserUuid() throws SystemException;

	/**
	 * Sets the user uuid of this assignment.
	 *
	 * @param userUuid the user uuid of this assignment
	 */
	public void setUserUuid(String userUuid);

	/**
	 * Returns the uol ID of this assignment.
	 *
	 * @return the uol ID of this assignment
	 */
	public long getUolId();

	/**
	 * Sets the uol ID of this assignment.
	 *
	 * @param uolId the uol ID of this assignment
	 */
	public void setUolId(long uolId);

	/**
	 * Returns the status of this assignment.
	 *
	 * @return the status of this assignment
	 */
	public int getStatus();

	/**
	 * Sets the status of this assignment.
	 *
	 * @param status the status of this assignment
	 */
	public void setStatus(int status);

	/**
	 * Returns the uoltype of this assignment.
	 *
	 * @return the uoltype of this assignment
	 */
	public int getUoltype();

	/**
	 * Sets the uoltype of this assignment.
	 *
	 * @param uoltype the uoltype of this assignment
	 */
	public void setUoltype(int uoltype);

	/**
	 * Returns the title of this assignment.
	 *
	 * @return the title of this assignment
	 */
	@AutoEscape
	public String getTitle();

	/**
	 * Sets the title of this assignment.
	 *
	 * @param title the title of this assignment
	 */
	public void setTitle(String title);

	/**
	 * Returns the username of this assignment.
	 *
	 * @return the username of this assignment
	 */
	@AutoEscape
	public String getUsername();

	/**
	 * Sets the username of this assignment.
	 *
	 * @param username the username of this assignment
	 */
	public void setUsername(String username);

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public Serializable getPrimaryKeyObj();

	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(Assignment assignment);

	public int hashCode();

	public CacheModel<Assignment> toCacheModel();

	public Assignment toEscapedModel();

	public String toString();

	public String toXmlString();
}