/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.qti.slayer.service.persistence.AssignmentPK;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.List;

/**
 * This class is used by SOAP remote services, specifically {@link com.qti.slayer.service.http.AssignmentServiceSoap}.
 *
 * @author    Hector
 * @see       com.qti.slayer.service.http.AssignmentServiceSoap
 * @generated
 */
public class AssignmentSoap implements Serializable {
	public static AssignmentSoap toSoapModel(Assignment model) {
		AssignmentSoap soapModel = new AssignmentSoap();

		soapModel.setUserId(model.getUserId());
		soapModel.setUolId(model.getUolId());
		soapModel.setStatus(model.getStatus());
		soapModel.setUoltype(model.getUoltype());
		soapModel.setTitle(model.getTitle());
		soapModel.setUsername(model.getUsername());

		return soapModel;
	}

	public static AssignmentSoap[] toSoapModels(Assignment[] models) {
		AssignmentSoap[] soapModels = new AssignmentSoap[models.length];

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModel(models[i]);
		}

		return soapModels;
	}

	public static AssignmentSoap[][] toSoapModels(Assignment[][] models) {
		AssignmentSoap[][] soapModels = null;

		if (models.length > 0) {
			soapModels = new AssignmentSoap[models.length][models[0].length];
		}
		else {
			soapModels = new AssignmentSoap[0][0];
		}

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModels(models[i]);
		}

		return soapModels;
	}

	public static AssignmentSoap[] toSoapModels(List<Assignment> models) {
		List<AssignmentSoap> soapModels = new ArrayList<AssignmentSoap>(models.size());

		for (Assignment model : models) {
			soapModels.add(toSoapModel(model));
		}

		return soapModels.toArray(new AssignmentSoap[soapModels.size()]);
	}

	public AssignmentSoap() {
	}

	public AssignmentPK getPrimaryKey() {
		return new AssignmentPK(_userId, _uolId);
	}

	public void setPrimaryKey(AssignmentPK pk) {
		setUserId(pk.userId);
		setUolId(pk.uolId);
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public long getUolId() {
		return _uolId;
	}

	public void setUolId(long uolId) {
		_uolId = uolId;
	}

	public int getStatus() {
		return _status;
	}

	public void setStatus(int status) {
		_status = status;
	}

	public int getUoltype() {
		return _uoltype;
	}

	public void setUoltype(int uoltype) {
		_uoltype = uoltype;
	}

	public String getTitle() {
		return _title;
	}

	public void setTitle(String title) {
		_title = title;
	}

	public String getUsername() {
		return _username;
	}

	public void setUsername(String username) {
		_username = username;
	}

	private long _userId;
	private long _uolId;
	private int _status;
	private int _uoltype;
	private String _title;
	private String _username;
}