/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.liferay.portal.model.ModelWrapper;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * This class is a wrapper for {@link Assignment}.
 * </p>
 *
 * @author    Hector
 * @see       Assignment
 * @generated
 */
public class AssignmentWrapper implements Assignment, ModelWrapper<Assignment> {
	public AssignmentWrapper(Assignment assignment) {
		_assignment = assignment;
	}

	public Class<?> getModelClass() {
		return Assignment.class;
	}

	public String getModelClassName() {
		return Assignment.class.getName();
	}

	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("userId", getUserId());
		attributes.put("uolId", getUolId());
		attributes.put("status", getStatus());
		attributes.put("uoltype", getUoltype());
		attributes.put("title", getTitle());
		attributes.put("username", getUsername());

		return attributes;
	}

	public void setModelAttributes(Map<String, Object> attributes) {
		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}

		Long uolId = (Long)attributes.get("uolId");

		if (uolId != null) {
			setUolId(uolId);
		}

		Integer status = (Integer)attributes.get("status");

		if (status != null) {
			setStatus(status);
		}

		Integer uoltype = (Integer)attributes.get("uoltype");

		if (uoltype != null) {
			setUoltype(uoltype);
		}

		String title = (String)attributes.get("title");

		if (title != null) {
			setTitle(title);
		}

		String username = (String)attributes.get("username");

		if (username != null) {
			setUsername(username);
		}
	}

	/**
	* Returns the primary key of this assignment.
	*
	* @return the primary key of this assignment
	*/
	public com.qti.slayer.service.persistence.AssignmentPK getPrimaryKey() {
		return _assignment.getPrimaryKey();
	}

	/**
	* Sets the primary key of this assignment.
	*
	* @param primaryKey the primary key of this assignment
	*/
	public void setPrimaryKey(
		com.qti.slayer.service.persistence.AssignmentPK primaryKey) {
		_assignment.setPrimaryKey(primaryKey);
	}

	/**
	* Returns the user ID of this assignment.
	*
	* @return the user ID of this assignment
	*/
	public long getUserId() {
		return _assignment.getUserId();
	}

	/**
	* Sets the user ID of this assignment.
	*
	* @param userId the user ID of this assignment
	*/
	public void setUserId(long userId) {
		_assignment.setUserId(userId);
	}

	/**
	* Returns the user uuid of this assignment.
	*
	* @return the user uuid of this assignment
	* @throws SystemException if a system exception occurred
	*/
	public java.lang.String getUserUuid()
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignment.getUserUuid();
	}

	/**
	* Sets the user uuid of this assignment.
	*
	* @param userUuid the user uuid of this assignment
	*/
	public void setUserUuid(java.lang.String userUuid) {
		_assignment.setUserUuid(userUuid);
	}

	/**
	* Returns the uol ID of this assignment.
	*
	* @return the uol ID of this assignment
	*/
	public long getUolId() {
		return _assignment.getUolId();
	}

	/**
	* Sets the uol ID of this assignment.
	*
	* @param uolId the uol ID of this assignment
	*/
	public void setUolId(long uolId) {
		_assignment.setUolId(uolId);
	}

	/**
	* Returns the status of this assignment.
	*
	* @return the status of this assignment
	*/
	public int getStatus() {
		return _assignment.getStatus();
	}

	/**
	* Sets the status of this assignment.
	*
	* @param status the status of this assignment
	*/
	public void setStatus(int status) {
		_assignment.setStatus(status);
	}

	/**
	* Returns the uoltype of this assignment.
	*
	* @return the uoltype of this assignment
	*/
	public int getUoltype() {
		return _assignment.getUoltype();
	}

	/**
	* Sets the uoltype of this assignment.
	*
	* @param uoltype the uoltype of this assignment
	*/
	public void setUoltype(int uoltype) {
		_assignment.setUoltype(uoltype);
	}

	/**
	* Returns the title of this assignment.
	*
	* @return the title of this assignment
	*/
	public java.lang.String getTitle() {
		return _assignment.getTitle();
	}

	/**
	* Sets the title of this assignment.
	*
	* @param title the title of this assignment
	*/
	public void setTitle(java.lang.String title) {
		_assignment.setTitle(title);
	}

	/**
	* Returns the username of this assignment.
	*
	* @return the username of this assignment
	*/
	public java.lang.String getUsername() {
		return _assignment.getUsername();
	}

	/**
	* Sets the username of this assignment.
	*
	* @param username the username of this assignment
	*/
	public void setUsername(java.lang.String username) {
		_assignment.setUsername(username);
	}

	public boolean isNew() {
		return _assignment.isNew();
	}

	public void setNew(boolean n) {
		_assignment.setNew(n);
	}

	public boolean isCachedModel() {
		return _assignment.isCachedModel();
	}

	public void setCachedModel(boolean cachedModel) {
		_assignment.setCachedModel(cachedModel);
	}

	public boolean isEscapedModel() {
		return _assignment.isEscapedModel();
	}

	public java.io.Serializable getPrimaryKeyObj() {
		return _assignment.getPrimaryKeyObj();
	}

	public void setPrimaryKeyObj(java.io.Serializable primaryKeyObj) {
		_assignment.setPrimaryKeyObj(primaryKeyObj);
	}

	public com.liferay.portlet.expando.model.ExpandoBridge getExpandoBridge() {
		return _assignment.getExpandoBridge();
	}

	public void setExpandoBridgeAttributes(
		com.liferay.portal.service.ServiceContext serviceContext) {
		_assignment.setExpandoBridgeAttributes(serviceContext);
	}

	@Override
	public java.lang.Object clone() {
		return new AssignmentWrapper((Assignment)_assignment.clone());
	}

	public int compareTo(com.qti.slayer.model.Assignment assignment) {
		return _assignment.compareTo(assignment);
	}

	@Override
	public int hashCode() {
		return _assignment.hashCode();
	}

	public com.liferay.portal.model.CacheModel<com.qti.slayer.model.Assignment> toCacheModel() {
		return _assignment.toCacheModel();
	}

	public com.qti.slayer.model.Assignment toEscapedModel() {
		return new AssignmentWrapper(_assignment.toEscapedModel());
	}

	@Override
	public java.lang.String toString() {
		return _assignment.toString();
	}

	public java.lang.String toXmlString() {
		return _assignment.toXmlString();
	}

	public void persist()
		throws com.liferay.portal.kernel.exception.SystemException {
		_assignment.persist();
	}

	/**
	 * @deprecated Renamed to {@link #getWrappedModel}
	 */
	public Assignment getWrappedAssignment() {
		return _assignment;
	}

	public Assignment getWrappedModel() {
		return _assignment;
	}

	public void resetOriginalValues() {
		_assignment.resetOriginalValues();
	}

	private Assignment _assignment;
}