/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.util.PortalUtil;

import com.qti.slayer.service.TestResultLocalServiceUtil;
import com.qti.slayer.service.persistence.TestResultPK;

import java.io.Serializable;

import java.lang.reflect.Proxy;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Hector
 */
public class TestResultClp extends BaseModelImpl<TestResult>
	implements TestResult {
	public TestResultClp() {
	}

	public Class<?> getModelClass() {
		return TestResult.class;
	}

	public String getModelClassName() {
		return TestResult.class.getName();
	}

	public TestResultPK getPrimaryKey() {
		return new TestResultPK(_userId, _uolId);
	}

	public void setPrimaryKey(TestResultPK primaryKey) {
		setUserId(primaryKey.userId);
		setUolId(primaryKey.uolId);
	}

	public Serializable getPrimaryKeyObj() {
		return new TestResultPK(_userId, _uolId);
	}

	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey((TestResultPK)primaryKeyObj);
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("userId", getUserId());
		attributes.put("uolId", getUolId());
		attributes.put("result", getResult());
		attributes.put("autoComment", getAutoComment());
		attributes.put("teacherComment", getTeacherComment());
		attributes.put("title", getTitle());
		attributes.put("username", getUsername());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}

		Long uolId = (Long)attributes.get("uolId");

		if (uolId != null) {
			setUolId(uolId);
		}

		Integer result = (Integer)attributes.get("result");

		if (result != null) {
			setResult(result);
		}

		String autoComment = (String)attributes.get("autoComment");

		if (autoComment != null) {
			setAutoComment(autoComment);
		}

		String teacherComment = (String)attributes.get("teacherComment");

		if (teacherComment != null) {
			setTeacherComment(teacherComment);
		}

		String title = (String)attributes.get("title");

		if (title != null) {
			setTitle(title);
		}

		String username = (String)attributes.get("username");

		if (username != null) {
			setUsername(username);
		}
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
	}

	public void setUserUuid(String userUuid) {
		_userUuid = userUuid;
	}

	public long getUolId() {
		return _uolId;
	}

	public void setUolId(long uolId) {
		_uolId = uolId;
	}

	public int getResult() {
		return _result;
	}

	public void setResult(int result) {
		_result = result;
	}

	public String getAutoComment() {
		return _autoComment;
	}

	public void setAutoComment(String autoComment) {
		_autoComment = autoComment;
	}

	public String getTeacherComment() {
		return _teacherComment;
	}

	public void setTeacherComment(String teacherComment) {
		_teacherComment = teacherComment;
	}

	public String getTitle() {
		return _title;
	}

	public void setTitle(String title) {
		_title = title;
	}

	public String getUsername() {
		return _username;
	}

	public void setUsername(String username) {
		_username = username;
	}

	public BaseModel<?> getTestResultRemoteModel() {
		return _testResultRemoteModel;
	}

	public void setTestResultRemoteModel(BaseModel<?> testResultRemoteModel) {
		_testResultRemoteModel = testResultRemoteModel;
	}

	public void persist() throws SystemException {
		if (this.isNew()) {
			TestResultLocalServiceUtil.addTestResult(this);
		}
		else {
			TestResultLocalServiceUtil.updateTestResult(this);
		}
	}

	@Override
	public TestResult toEscapedModel() {
		return (TestResult)Proxy.newProxyInstance(TestResult.class.getClassLoader(),
			new Class[] { TestResult.class }, new AutoEscapeBeanHandler(this));
	}

	@Override
	public Object clone() {
		TestResultClp clone = new TestResultClp();

		clone.setUserId(getUserId());
		clone.setUolId(getUolId());
		clone.setResult(getResult());
		clone.setAutoComment(getAutoComment());
		clone.setTeacherComment(getTeacherComment());
		clone.setTitle(getTitle());
		clone.setUsername(getUsername());

		return clone;
	}

	public int compareTo(TestResult testResult) {
		int value = 0;

		if (getUserId() < testResult.getUserId()) {
			value = -1;
		}
		else if (getUserId() > testResult.getUserId()) {
			value = 1;
		}
		else {
			value = 0;
		}

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		TestResultClp testResult = null;

		try {
			testResult = (TestResultClp)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		TestResultPK primaryKey = testResult.getPrimaryKey();

		if (getPrimaryKey().equals(primaryKey)) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return getPrimaryKey().hashCode();
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(15);

		sb.append("{userId=");
		sb.append(getUserId());
		sb.append(", uolId=");
		sb.append(getUolId());
		sb.append(", result=");
		sb.append(getResult());
		sb.append(", autoComment=");
		sb.append(getAutoComment());
		sb.append(", teacherComment=");
		sb.append(getTeacherComment());
		sb.append(", title=");
		sb.append(getTitle());
		sb.append(", username=");
		sb.append(getUsername());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(25);

		sb.append("<model><model-name>");
		sb.append("com.qti.slayer.model.TestResult");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>uolId</column-name><column-value><![CDATA[");
		sb.append(getUolId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>result</column-name><column-value><![CDATA[");
		sb.append(getResult());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>autoComment</column-name><column-value><![CDATA[");
		sb.append(getAutoComment());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>teacherComment</column-name><column-value><![CDATA[");
		sb.append(getTeacherComment());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>title</column-name><column-value><![CDATA[");
		sb.append(getTitle());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>username</column-name><column-value><![CDATA[");
		sb.append(getUsername());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _userId;
	private String _userUuid;
	private long _uolId;
	private int _result;
	private String _autoComment;
	private String _teacherComment;
	private String _title;
	private String _username;
	private BaseModel<?> _testResultRemoteModel;
}