/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import com.qti.slayer.service.persistence.TestResultPK;

import java.io.Serializable;

/**
 * The base model interface for the TestResult service. Represents a row in the &quot;QTI_TestResult&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.qti.slayer.model.impl.TestResultModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.qti.slayer.model.impl.TestResultImpl}.
 * </p>
 *
 * @author Hector
 * @see TestResult
 * @see com.qti.slayer.model.impl.TestResultImpl
 * @see com.qti.slayer.model.impl.TestResultModelImpl
 * @generated
 */
public interface TestResultModel extends BaseModel<TestResult> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a test result model instance should use the {@link TestResult} interface instead.
	 */

	/**
	 * Returns the primary key of this test result.
	 *
	 * @return the primary key of this test result
	 */
	public TestResultPK getPrimaryKey();

	/**
	 * Sets the primary key of this test result.
	 *
	 * @param primaryKey the primary key of this test result
	 */
	public void setPrimaryKey(TestResultPK primaryKey);

	/**
	 * Returns the user ID of this test result.
	 *
	 * @return the user ID of this test result
	 */
	public long getUserId();

	/**
	 * Sets the user ID of this test result.
	 *
	 * @param userId the user ID of this test result
	 */
	public void setUserId(long userId);

	/**
	 * Returns the user uuid of this test result.
	 *
	 * @return the user uuid of this test result
	 * @throws SystemException if a system exception occurred
	 */
	public String getUserUuid() throws SystemException;

	/**
	 * Sets the user uuid of this test result.
	 *
	 * @param userUuid the user uuid of this test result
	 */
	public void setUserUuid(String userUuid);

	/**
	 * Returns the uol ID of this test result.
	 *
	 * @return the uol ID of this test result
	 */
	public long getUolId();

	/**
	 * Sets the uol ID of this test result.
	 *
	 * @param uolId the uol ID of this test result
	 */
	public void setUolId(long uolId);

	/**
	 * Returns the result of this test result.
	 *
	 * @return the result of this test result
	 */
	public int getResult();

	/**
	 * Sets the result of this test result.
	 *
	 * @param result the result of this test result
	 */
	public void setResult(int result);

	/**
	 * Returns the auto comment of this test result.
	 *
	 * @return the auto comment of this test result
	 */
	@AutoEscape
	public String getAutoComment();

	/**
	 * Sets the auto comment of this test result.
	 *
	 * @param autoComment the auto comment of this test result
	 */
	public void setAutoComment(String autoComment);

	/**
	 * Returns the teacher comment of this test result.
	 *
	 * @return the teacher comment of this test result
	 */
	@AutoEscape
	public String getTeacherComment();

	/**
	 * Sets the teacher comment of this test result.
	 *
	 * @param teacherComment the teacher comment of this test result
	 */
	public void setTeacherComment(String teacherComment);

	/**
	 * Returns the title of this test result.
	 *
	 * @return the title of this test result
	 */
	@AutoEscape
	public String getTitle();

	/**
	 * Sets the title of this test result.
	 *
	 * @param title the title of this test result
	 */
	public void setTitle(String title);

	/**
	 * Returns the username of this test result.
	 *
	 * @return the username of this test result
	 */
	@AutoEscape
	public String getUsername();

	/**
	 * Sets the username of this test result.
	 *
	 * @param username the username of this test result
	 */
	public void setUsername(String username);

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public Serializable getPrimaryKeyObj();

	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(TestResult testResult);

	public int hashCode();

	public CacheModel<TestResult> toCacheModel();

	public TestResult toEscapedModel();

	public String toString();

	public String toXmlString();
}