/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.qti.slayer.service.persistence.TestResultPK;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.List;

/**
 * This class is used by SOAP remote services, specifically {@link com.qti.slayer.service.http.TestResultServiceSoap}.
 *
 * @author    Hector
 * @see       com.qti.slayer.service.http.TestResultServiceSoap
 * @generated
 */
public class TestResultSoap implements Serializable {
	public static TestResultSoap toSoapModel(TestResult model) {
		TestResultSoap soapModel = new TestResultSoap();

		soapModel.setUserId(model.getUserId());
		soapModel.setUolId(model.getUolId());
		soapModel.setResult(model.getResult());
		soapModel.setAutoComment(model.getAutoComment());
		soapModel.setTeacherComment(model.getTeacherComment());
		soapModel.setTitle(model.getTitle());
		soapModel.setUsername(model.getUsername());

		return soapModel;
	}

	public static TestResultSoap[] toSoapModels(TestResult[] models) {
		TestResultSoap[] soapModels = new TestResultSoap[models.length];

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModel(models[i]);
		}

		return soapModels;
	}

	public static TestResultSoap[][] toSoapModels(TestResult[][] models) {
		TestResultSoap[][] soapModels = null;

		if (models.length > 0) {
			soapModels = new TestResultSoap[models.length][models[0].length];
		}
		else {
			soapModels = new TestResultSoap[0][0];
		}

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModels(models[i]);
		}

		return soapModels;
	}

	public static TestResultSoap[] toSoapModels(List<TestResult> models) {
		List<TestResultSoap> soapModels = new ArrayList<TestResultSoap>(models.size());

		for (TestResult model : models) {
			soapModels.add(toSoapModel(model));
		}

		return soapModels.toArray(new TestResultSoap[soapModels.size()]);
	}

	public TestResultSoap() {
	}

	public TestResultPK getPrimaryKey() {
		return new TestResultPK(_userId, _uolId);
	}

	public void setPrimaryKey(TestResultPK pk) {
		setUserId(pk.userId);
		setUolId(pk.uolId);
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public long getUolId() {
		return _uolId;
	}

	public void setUolId(long uolId) {
		_uolId = uolId;
	}

	public int getResult() {
		return _result;
	}

	public void setResult(int result) {
		_result = result;
	}

	public String getAutoComment() {
		return _autoComment;
	}

	public void setAutoComment(String autoComment) {
		_autoComment = autoComment;
	}

	public String getTeacherComment() {
		return _teacherComment;
	}

	public void setTeacherComment(String teacherComment) {
		_teacherComment = teacherComment;
	}

	public String getTitle() {
		return _title;
	}

	public void setTitle(String title) {
		_title = title;
	}

	public String getUsername() {
		return _username;
	}

	public void setUsername(String username) {
		_username = username;
	}

	private long _userId;
	private long _uolId;
	private int _result;
	private String _autoComment;
	private String _teacherComment;
	private String _title;
	private String _username;
}