/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.liferay.portal.model.ModelWrapper;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * This class is a wrapper for {@link TestResult}.
 * </p>
 *
 * @author    Hector
 * @see       TestResult
 * @generated
 */
public class TestResultWrapper implements TestResult, ModelWrapper<TestResult> {
	public TestResultWrapper(TestResult testResult) {
		_testResult = testResult;
	}

	public Class<?> getModelClass() {
		return TestResult.class;
	}

	public String getModelClassName() {
		return TestResult.class.getName();
	}

	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("userId", getUserId());
		attributes.put("uolId", getUolId());
		attributes.put("result", getResult());
		attributes.put("autoComment", getAutoComment());
		attributes.put("teacherComment", getTeacherComment());
		attributes.put("title", getTitle());
		attributes.put("username", getUsername());

		return attributes;
	}

	public void setModelAttributes(Map<String, Object> attributes) {
		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}

		Long uolId = (Long)attributes.get("uolId");

		if (uolId != null) {
			setUolId(uolId);
		}

		Integer result = (Integer)attributes.get("result");

		if (result != null) {
			setResult(result);
		}

		String autoComment = (String)attributes.get("autoComment");

		if (autoComment != null) {
			setAutoComment(autoComment);
		}

		String teacherComment = (String)attributes.get("teacherComment");

		if (teacherComment != null) {
			setTeacherComment(teacherComment);
		}

		String title = (String)attributes.get("title");

		if (title != null) {
			setTitle(title);
		}

		String username = (String)attributes.get("username");

		if (username != null) {
			setUsername(username);
		}
	}

	/**
	* Returns the primary key of this test result.
	*
	* @return the primary key of this test result
	*/
	public com.qti.slayer.service.persistence.TestResultPK getPrimaryKey() {
		return _testResult.getPrimaryKey();
	}

	/**
	* Sets the primary key of this test result.
	*
	* @param primaryKey the primary key of this test result
	*/
	public void setPrimaryKey(
		com.qti.slayer.service.persistence.TestResultPK primaryKey) {
		_testResult.setPrimaryKey(primaryKey);
	}

	/**
	* Returns the user ID of this test result.
	*
	* @return the user ID of this test result
	*/
	public long getUserId() {
		return _testResult.getUserId();
	}

	/**
	* Sets the user ID of this test result.
	*
	* @param userId the user ID of this test result
	*/
	public void setUserId(long userId) {
		_testResult.setUserId(userId);
	}

	/**
	* Returns the user uuid of this test result.
	*
	* @return the user uuid of this test result
	* @throws SystemException if a system exception occurred
	*/
	public java.lang.String getUserUuid()
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResult.getUserUuid();
	}

	/**
	* Sets the user uuid of this test result.
	*
	* @param userUuid the user uuid of this test result
	*/
	public void setUserUuid(java.lang.String userUuid) {
		_testResult.setUserUuid(userUuid);
	}

	/**
	* Returns the uol ID of this test result.
	*
	* @return the uol ID of this test result
	*/
	public long getUolId() {
		return _testResult.getUolId();
	}

	/**
	* Sets the uol ID of this test result.
	*
	* @param uolId the uol ID of this test result
	*/
	public void setUolId(long uolId) {
		_testResult.setUolId(uolId);
	}

	/**
	* Returns the result of this test result.
	*
	* @return the result of this test result
	*/
	public int getResult() {
		return _testResult.getResult();
	}

	/**
	* Sets the result of this test result.
	*
	* @param result the result of this test result
	*/
	public void setResult(int result) {
		_testResult.setResult(result);
	}

	/**
	* Returns the auto comment of this test result.
	*
	* @return the auto comment of this test result
	*/
	public java.lang.String getAutoComment() {
		return _testResult.getAutoComment();
	}

	/**
	* Sets the auto comment of this test result.
	*
	* @param autoComment the auto comment of this test result
	*/
	public void setAutoComment(java.lang.String autoComment) {
		_testResult.setAutoComment(autoComment);
	}

	/**
	* Returns the teacher comment of this test result.
	*
	* @return the teacher comment of this test result
	*/
	public java.lang.String getTeacherComment() {
		return _testResult.getTeacherComment();
	}

	/**
	* Sets the teacher comment of this test result.
	*
	* @param teacherComment the teacher comment of this test result
	*/
	public void setTeacherComment(java.lang.String teacherComment) {
		_testResult.setTeacherComment(teacherComment);
	}

	/**
	* Returns the title of this test result.
	*
	* @return the title of this test result
	*/
	public java.lang.String getTitle() {
		return _testResult.getTitle();
	}

	/**
	* Sets the title of this test result.
	*
	* @param title the title of this test result
	*/
	public void setTitle(java.lang.String title) {
		_testResult.setTitle(title);
	}

	/**
	* Returns the username of this test result.
	*
	* @return the username of this test result
	*/
	public java.lang.String getUsername() {
		return _testResult.getUsername();
	}

	/**
	* Sets the username of this test result.
	*
	* @param username the username of this test result
	*/
	public void setUsername(java.lang.String username) {
		_testResult.setUsername(username);
	}

	public boolean isNew() {
		return _testResult.isNew();
	}

	public void setNew(boolean n) {
		_testResult.setNew(n);
	}

	public boolean isCachedModel() {
		return _testResult.isCachedModel();
	}

	public void setCachedModel(boolean cachedModel) {
		_testResult.setCachedModel(cachedModel);
	}

	public boolean isEscapedModel() {
		return _testResult.isEscapedModel();
	}

	public java.io.Serializable getPrimaryKeyObj() {
		return _testResult.getPrimaryKeyObj();
	}

	public void setPrimaryKeyObj(java.io.Serializable primaryKeyObj) {
		_testResult.setPrimaryKeyObj(primaryKeyObj);
	}

	public com.liferay.portlet.expando.model.ExpandoBridge getExpandoBridge() {
		return _testResult.getExpandoBridge();
	}

	public void setExpandoBridgeAttributes(
		com.liferay.portal.service.ServiceContext serviceContext) {
		_testResult.setExpandoBridgeAttributes(serviceContext);
	}

	@Override
	public java.lang.Object clone() {
		return new TestResultWrapper((TestResult)_testResult.clone());
	}

	public int compareTo(com.qti.slayer.model.TestResult testResult) {
		return _testResult.compareTo(testResult);
	}

	@Override
	public int hashCode() {
		return _testResult.hashCode();
	}

	public com.liferay.portal.model.CacheModel<com.qti.slayer.model.TestResult> toCacheModel() {
		return _testResult.toCacheModel();
	}

	public com.qti.slayer.model.TestResult toEscapedModel() {
		return new TestResultWrapper(_testResult.toEscapedModel());
	}

	@Override
	public java.lang.String toString() {
		return _testResult.toString();
	}

	public java.lang.String toXmlString() {
		return _testResult.toXmlString();
	}

	public void persist()
		throws com.liferay.portal.kernel.exception.SystemException {
		_testResult.persist();
	}

	/**
	 * @deprecated Renamed to {@link #getWrappedModel}
	 */
	public TestResult getWrappedTestResult() {
		return _testResult;
	}

	public TestResult getWrappedModel() {
		return _testResult;
	}

	public void resetOriginalValues() {
		_testResult.resetOriginalValues();
	}

	private TestResult _testResult;
}