/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.impl.BaseModelImpl;

import com.qti.slayer.service.UolLocalServiceUtil;

import java.io.Serializable;

import java.lang.reflect.Proxy;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author Hector
 */
public class UolClp extends BaseModelImpl<Uol> implements Uol {
	public UolClp() {
	}

	public Class<?> getModelClass() {
		return Uol.class;
	}

	public String getModelClassName() {
		return Uol.class.getName();
	}

	public long getPrimaryKey() {
		return _I_Id;
	}

	public void setPrimaryKey(long primaryKey) {
		setI_Id(primaryKey);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_I_Id);
	}

	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("I_Id", getI_Id());
		attributes.put("classRoomId", getClassRoomId());
		attributes.put("subjectId", getSubjectId());
		attributes.put("countryId", getCountryId());
		attributes.put("companyId", getCompanyId());
		attributes.put("assessmentTestId", getAssessmentTestId());
		attributes.put("createDate", getCreateDate());
		attributes.put("requestedDate", getRequestedDate());
		attributes.put("description", getDescription());
		attributes.put("active", getActive());
		attributes.put("evalTypeId", getEvalTypeId());
		attributes.put("title", getTitle());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long I_Id = (Long)attributes.get("I_Id");

		if (I_Id != null) {
			setI_Id(I_Id);
		}

		Long classRoomId = (Long)attributes.get("classRoomId");

		if (classRoomId != null) {
			setClassRoomId(classRoomId);
		}

		Long subjectId = (Long)attributes.get("subjectId");

		if (subjectId != null) {
			setSubjectId(subjectId);
		}

		Long countryId = (Long)attributes.get("countryId");

		if (countryId != null) {
			setCountryId(countryId);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long assessmentTestId = (Long)attributes.get("assessmentTestId");

		if (assessmentTestId != null) {
			setAssessmentTestId(assessmentTestId);
		}

		Date createDate = (Date)attributes.get("createDate");

		if (createDate != null) {
			setCreateDate(createDate);
		}

		Date requestedDate = (Date)attributes.get("requestedDate");

		if (requestedDate != null) {
			setRequestedDate(requestedDate);
		}

		String description = (String)attributes.get("description");

		if (description != null) {
			setDescription(description);
		}

		Boolean active = (Boolean)attributes.get("active");

		if (active != null) {
			setActive(active);
		}

		Integer evalTypeId = (Integer)attributes.get("evalTypeId");

		if (evalTypeId != null) {
			setEvalTypeId(evalTypeId);
		}

		String title = (String)attributes.get("title");

		if (title != null) {
			setTitle(title);
		}
	}

	public long getI_Id() {
		return _I_Id;
	}

	public void setI_Id(long I_Id) {
		_I_Id = I_Id;
	}

	public long getClassRoomId() {
		return _classRoomId;
	}

	public void setClassRoomId(long classRoomId) {
		_classRoomId = classRoomId;
	}

	public long getSubjectId() {
		return _subjectId;
	}

	public void setSubjectId(long subjectId) {
		_subjectId = subjectId;
	}

	public long getCountryId() {
		return _countryId;
	}

	public void setCountryId(long countryId) {
		_countryId = countryId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getAssessmentTestId() {
		return _assessmentTestId;
	}

	public void setAssessmentTestId(long assessmentTestId) {
		_assessmentTestId = assessmentTestId;
	}

	public Date getCreateDate() {
		return _createDate;
	}

	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	public Date getRequestedDate() {
		return _requestedDate;
	}

	public void setRequestedDate(Date requestedDate) {
		_requestedDate = requestedDate;
	}

	public String getDescription() {
		return _description;
	}

	public void setDescription(String description) {
		_description = description;
	}

	public boolean getActive() {
		return _active;
	}

	public boolean isActive() {
		return _active;
	}

	public void setActive(boolean active) {
		_active = active;
	}

	public int getEvalTypeId() {
		return _evalTypeId;
	}

	public void setEvalTypeId(int evalTypeId) {
		_evalTypeId = evalTypeId;
	}

	public String getTitle() {
		return _title;
	}

	public void setTitle(String title) {
		_title = title;
	}

	public BaseModel<?> getUolRemoteModel() {
		return _uolRemoteModel;
	}

	public void setUolRemoteModel(BaseModel<?> uolRemoteModel) {
		_uolRemoteModel = uolRemoteModel;
	}

	public void persist() throws SystemException {
		if (this.isNew()) {
			UolLocalServiceUtil.addUol(this);
		}
		else {
			UolLocalServiceUtil.updateUol(this);
		}
	}

	@Override
	public Uol toEscapedModel() {
		return (Uol)Proxy.newProxyInstance(Uol.class.getClassLoader(),
			new Class[] { Uol.class }, new AutoEscapeBeanHandler(this));
	}

	@Override
	public Object clone() {
		UolClp clone = new UolClp();

		clone.setI_Id(getI_Id());
		clone.setClassRoomId(getClassRoomId());
		clone.setSubjectId(getSubjectId());
		clone.setCountryId(getCountryId());
		clone.setCompanyId(getCompanyId());
		clone.setAssessmentTestId(getAssessmentTestId());
		clone.setCreateDate(getCreateDate());
		clone.setRequestedDate(getRequestedDate());
		clone.setDescription(getDescription());
		clone.setActive(getActive());
		clone.setEvalTypeId(getEvalTypeId());
		clone.setTitle(getTitle());

		return clone;
	}

	public int compareTo(Uol uol) {
		int value = 0;

		if (getClassRoomId() < uol.getClassRoomId()) {
			value = -1;
		}
		else if (getClassRoomId() > uol.getClassRoomId()) {
			value = 1;
		}
		else {
			value = 0;
		}

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		UolClp uol = null;

		try {
			uol = (UolClp)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long primaryKey = uol.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(25);

		sb.append("{I_Id=");
		sb.append(getI_Id());
		sb.append(", classRoomId=");
		sb.append(getClassRoomId());
		sb.append(", subjectId=");
		sb.append(getSubjectId());
		sb.append(", countryId=");
		sb.append(getCountryId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", assessmentTestId=");
		sb.append(getAssessmentTestId());
		sb.append(", createDate=");
		sb.append(getCreateDate());
		sb.append(", requestedDate=");
		sb.append(getRequestedDate());
		sb.append(", description=");
		sb.append(getDescription());
		sb.append(", active=");
		sb.append(getActive());
		sb.append(", evalTypeId=");
		sb.append(getEvalTypeId());
		sb.append(", title=");
		sb.append(getTitle());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(40);

		sb.append("<model><model-name>");
		sb.append("com.qti.slayer.model.Uol");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>I_Id</column-name><column-value><![CDATA[");
		sb.append(getI_Id());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>classRoomId</column-name><column-value><![CDATA[");
		sb.append(getClassRoomId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>subjectId</column-name><column-value><![CDATA[");
		sb.append(getSubjectId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>countryId</column-name><column-value><![CDATA[");
		sb.append(getCountryId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>assessmentTestId</column-name><column-value><![CDATA[");
		sb.append(getAssessmentTestId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>createDate</column-name><column-value><![CDATA[");
		sb.append(getCreateDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>requestedDate</column-name><column-value><![CDATA[");
		sb.append(getRequestedDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>description</column-name><column-value><![CDATA[");
		sb.append(getDescription());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>active</column-name><column-value><![CDATA[");
		sb.append(getActive());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>evalTypeId</column-name><column-value><![CDATA[");
		sb.append(getEvalTypeId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>title</column-name><column-value><![CDATA[");
		sb.append(getTitle());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _I_Id;
	private long _classRoomId;
	private long _subjectId;
	private long _countryId;
	private long _companyId;
	private long _assessmentTestId;
	private Date _createDate;
	private Date _requestedDate;
	private String _description;
	private boolean _active;
	private int _evalTypeId;
	private String _title;
	private BaseModel<?> _uolRemoteModel;
}