/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Uol service. Represents a row in the &quot;QTI_Uol&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.qti.slayer.model.impl.UolModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.qti.slayer.model.impl.UolImpl}.
 * </p>
 *
 * @author Hector
 * @see Uol
 * @see com.qti.slayer.model.impl.UolImpl
 * @see com.qti.slayer.model.impl.UolModelImpl
 * @generated
 */
public interface UolModel extends BaseModel<Uol> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a uol model instance should use the {@link Uol} interface instead.
	 */

	/**
	 * Returns the primary key of this uol.
	 *
	 * @return the primary key of this uol
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this uol.
	 *
	 * @param primaryKey the primary key of this uol
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the i_ ID of this uol.
	 *
	 * @return the i_ ID of this uol
	 */
	public long getI_Id();

	/**
	 * Sets the i_ ID of this uol.
	 *
	 * @param I_Id the i_ ID of this uol
	 */
	public void setI_Id(long I_Id);

	/**
	 * Returns the class room ID of this uol.
	 *
	 * @return the class room ID of this uol
	 */
	public long getClassRoomId();

	/**
	 * Sets the class room ID of this uol.
	 *
	 * @param classRoomId the class room ID of this uol
	 */
	public void setClassRoomId(long classRoomId);

	/**
	 * Returns the subject ID of this uol.
	 *
	 * @return the subject ID of this uol
	 */
	public long getSubjectId();

	/**
	 * Sets the subject ID of this uol.
	 *
	 * @param subjectId the subject ID of this uol
	 */
	public void setSubjectId(long subjectId);

	/**
	 * Returns the country ID of this uol.
	 *
	 * @return the country ID of this uol
	 */
	public long getCountryId();

	/**
	 * Sets the country ID of this uol.
	 *
	 * @param countryId the country ID of this uol
	 */
	public void setCountryId(long countryId);

	/**
	 * Returns the company ID of this uol.
	 *
	 * @return the company ID of this uol
	 */
	public long getCompanyId();

	/**
	 * Sets the company ID of this uol.
	 *
	 * @param companyId the company ID of this uol
	 */
	public void setCompanyId(long companyId);

	/**
	 * Returns the assessment test ID of this uol.
	 *
	 * @return the assessment test ID of this uol
	 */
	public long getAssessmentTestId();

	/**
	 * Sets the assessment test ID of this uol.
	 *
	 * @param assessmentTestId the assessment test ID of this uol
	 */
	public void setAssessmentTestId(long assessmentTestId);

	/**
	 * Returns the create date of this uol.
	 *
	 * @return the create date of this uol
	 */
	public Date getCreateDate();

	/**
	 * Sets the create date of this uol.
	 *
	 * @param createDate the create date of this uol
	 */
	public void setCreateDate(Date createDate);

	/**
	 * Returns the requested date of this uol.
	 *
	 * @return the requested date of this uol
	 */
	public Date getRequestedDate();

	/**
	 * Sets the requested date of this uol.
	 *
	 * @param requestedDate the requested date of this uol
	 */
	public void setRequestedDate(Date requestedDate);

	/**
	 * Returns the description of this uol.
	 *
	 * @return the description of this uol
	 */
	@AutoEscape
	public String getDescription();

	/**
	 * Sets the description of this uol.
	 *
	 * @param description the description of this uol
	 */
	public void setDescription(String description);

	/**
	 * Returns the active of this uol.
	 *
	 * @return the active of this uol
	 */
	public boolean getActive();

	/**
	 * Returns <code>true</code> if this uol is active.
	 *
	 * @return <code>true</code> if this uol is active; <code>false</code> otherwise
	 */
	public boolean isActive();

	/**
	 * Sets whether this uol is active.
	 *
	 * @param active the active of this uol
	 */
	public void setActive(boolean active);

	/**
	 * Returns the eval type ID of this uol.
	 *
	 * @return the eval type ID of this uol
	 */
	public int getEvalTypeId();

	/**
	 * Sets the eval type ID of this uol.
	 *
	 * @param evalTypeId the eval type ID of this uol
	 */
	public void setEvalTypeId(int evalTypeId);

	/**
	 * Returns the title of this uol.
	 *
	 * @return the title of this uol
	 */
	@AutoEscape
	public String getTitle();

	/**
	 * Sets the title of this uol.
	 *
	 * @param title the title of this uol
	 */
	public void setTitle(String title);

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public Serializable getPrimaryKeyObj();

	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(Uol uol);

	public int hashCode();

	public CacheModel<Uol> toCacheModel();

	public Uol toEscapedModel();

	public String toString();

	public String toXmlString();
}