/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * This class is used by SOAP remote services, specifically {@link com.qti.slayer.service.http.UolServiceSoap}.
 *
 * @author    Hector
 * @see       com.qti.slayer.service.http.UolServiceSoap
 * @generated
 */
public class UolSoap implements Serializable {
	public static UolSoap toSoapModel(Uol model) {
		UolSoap soapModel = new UolSoap();

		soapModel.setI_Id(model.getI_Id());
		soapModel.setClassRoomId(model.getClassRoomId());
		soapModel.setSubjectId(model.getSubjectId());
		soapModel.setCountryId(model.getCountryId());
		soapModel.setCompanyId(model.getCompanyId());
		soapModel.setAssessmentTestId(model.getAssessmentTestId());
		soapModel.setCreateDate(model.getCreateDate());
		soapModel.setRequestedDate(model.getRequestedDate());
		soapModel.setDescription(model.getDescription());
		soapModel.setActive(model.getActive());
		soapModel.setEvalTypeId(model.getEvalTypeId());
		soapModel.setTitle(model.getTitle());

		return soapModel;
	}

	public static UolSoap[] toSoapModels(Uol[] models) {
		UolSoap[] soapModels = new UolSoap[models.length];

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModel(models[i]);
		}

		return soapModels;
	}

	public static UolSoap[][] toSoapModels(Uol[][] models) {
		UolSoap[][] soapModels = null;

		if (models.length > 0) {
			soapModels = new UolSoap[models.length][models[0].length];
		}
		else {
			soapModels = new UolSoap[0][0];
		}

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModels(models[i]);
		}

		return soapModels;
	}

	public static UolSoap[] toSoapModels(List<Uol> models) {
		List<UolSoap> soapModels = new ArrayList<UolSoap>(models.size());

		for (Uol model : models) {
			soapModels.add(toSoapModel(model));
		}

		return soapModels.toArray(new UolSoap[soapModels.size()]);
	}

	public UolSoap() {
	}

	public long getPrimaryKey() {
		return _I_Id;
	}

	public void setPrimaryKey(long pk) {
		setI_Id(pk);
	}

	public long getI_Id() {
		return _I_Id;
	}

	public void setI_Id(long I_Id) {
		_I_Id = I_Id;
	}

	public long getClassRoomId() {
		return _classRoomId;
	}

	public void setClassRoomId(long classRoomId) {
		_classRoomId = classRoomId;
	}

	public long getSubjectId() {
		return _subjectId;
	}

	public void setSubjectId(long subjectId) {
		_subjectId = subjectId;
	}

	public long getCountryId() {
		return _countryId;
	}

	public void setCountryId(long countryId) {
		_countryId = countryId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getAssessmentTestId() {
		return _assessmentTestId;
	}

	public void setAssessmentTestId(long assessmentTestId) {
		_assessmentTestId = assessmentTestId;
	}

	public Date getCreateDate() {
		return _createDate;
	}

	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	public Date getRequestedDate() {
		return _requestedDate;
	}

	public void setRequestedDate(Date requestedDate) {
		_requestedDate = requestedDate;
	}

	public String getDescription() {
		return _description;
	}

	public void setDescription(String description) {
		_description = description;
	}

	public boolean getActive() {
		return _active;
	}

	public boolean isActive() {
		return _active;
	}

	public void setActive(boolean active) {
		_active = active;
	}

	public int getEvalTypeId() {
		return _evalTypeId;
	}

	public void setEvalTypeId(int evalTypeId) {
		_evalTypeId = evalTypeId;
	}

	public String getTitle() {
		return _title;
	}

	public void setTitle(String title) {
		_title = title;
	}

	private long _I_Id;
	private long _classRoomId;
	private long _subjectId;
	private long _countryId;
	private long _companyId;
	private long _assessmentTestId;
	private Date _createDate;
	private Date _requestedDate;
	private String _description;
	private boolean _active;
	private int _evalTypeId;
	private String _title;
}