/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model;

import com.liferay.portal.model.ModelWrapper;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * This class is a wrapper for {@link Uol}.
 * </p>
 *
 * @author    Hector
 * @see       Uol
 * @generated
 */
public class UolWrapper implements Uol, ModelWrapper<Uol> {
	public UolWrapper(Uol uol) {
		_uol = uol;
	}

	public Class<?> getModelClass() {
		return Uol.class;
	}

	public String getModelClassName() {
		return Uol.class.getName();
	}

	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("I_Id", getI_Id());
		attributes.put("classRoomId", getClassRoomId());
		attributes.put("subjectId", getSubjectId());
		attributes.put("countryId", getCountryId());
		attributes.put("companyId", getCompanyId());
		attributes.put("assessmentTestId", getAssessmentTestId());
		attributes.put("createDate", getCreateDate());
		attributes.put("requestedDate", getRequestedDate());
		attributes.put("description", getDescription());
		attributes.put("active", getActive());
		attributes.put("evalTypeId", getEvalTypeId());
		attributes.put("title", getTitle());

		return attributes;
	}

	public void setModelAttributes(Map<String, Object> attributes) {
		Long I_Id = (Long)attributes.get("I_Id");

		if (I_Id != null) {
			setI_Id(I_Id);
		}

		Long classRoomId = (Long)attributes.get("classRoomId");

		if (classRoomId != null) {
			setClassRoomId(classRoomId);
		}

		Long subjectId = (Long)attributes.get("subjectId");

		if (subjectId != null) {
			setSubjectId(subjectId);
		}

		Long countryId = (Long)attributes.get("countryId");

		if (countryId != null) {
			setCountryId(countryId);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long assessmentTestId = (Long)attributes.get("assessmentTestId");

		if (assessmentTestId != null) {
			setAssessmentTestId(assessmentTestId);
		}

		Date createDate = (Date)attributes.get("createDate");

		if (createDate != null) {
			setCreateDate(createDate);
		}

		Date requestedDate = (Date)attributes.get("requestedDate");

		if (requestedDate != null) {
			setRequestedDate(requestedDate);
		}

		String description = (String)attributes.get("description");

		if (description != null) {
			setDescription(description);
		}

		Boolean active = (Boolean)attributes.get("active");

		if (active != null) {
			setActive(active);
		}

		Integer evalTypeId = (Integer)attributes.get("evalTypeId");

		if (evalTypeId != null) {
			setEvalTypeId(evalTypeId);
		}

		String title = (String)attributes.get("title");

		if (title != null) {
			setTitle(title);
		}
	}

	/**
	* Returns the primary key of this uol.
	*
	* @return the primary key of this uol
	*/
	public long getPrimaryKey() {
		return _uol.getPrimaryKey();
	}

	/**
	* Sets the primary key of this uol.
	*
	* @param primaryKey the primary key of this uol
	*/
	public void setPrimaryKey(long primaryKey) {
		_uol.setPrimaryKey(primaryKey);
	}

	/**
	* Returns the i_ ID of this uol.
	*
	* @return the i_ ID of this uol
	*/
	public long getI_Id() {
		return _uol.getI_Id();
	}

	/**
	* Sets the i_ ID of this uol.
	*
	* @param I_Id the i_ ID of this uol
	*/
	public void setI_Id(long I_Id) {
		_uol.setI_Id(I_Id);
	}

	/**
	* Returns the class room ID of this uol.
	*
	* @return the class room ID of this uol
	*/
	public long getClassRoomId() {
		return _uol.getClassRoomId();
	}

	/**
	* Sets the class room ID of this uol.
	*
	* @param classRoomId the class room ID of this uol
	*/
	public void setClassRoomId(long classRoomId) {
		_uol.setClassRoomId(classRoomId);
	}

	/**
	* Returns the subject ID of this uol.
	*
	* @return the subject ID of this uol
	*/
	public long getSubjectId() {
		return _uol.getSubjectId();
	}

	/**
	* Sets the subject ID of this uol.
	*
	* @param subjectId the subject ID of this uol
	*/
	public void setSubjectId(long subjectId) {
		_uol.setSubjectId(subjectId);
	}

	/**
	* Returns the country ID of this uol.
	*
	* @return the country ID of this uol
	*/
	public long getCountryId() {
		return _uol.getCountryId();
	}

	/**
	* Sets the country ID of this uol.
	*
	* @param countryId the country ID of this uol
	*/
	public void setCountryId(long countryId) {
		_uol.setCountryId(countryId);
	}

	/**
	* Returns the company ID of this uol.
	*
	* @return the company ID of this uol
	*/
	public long getCompanyId() {
		return _uol.getCompanyId();
	}

	/**
	* Sets the company ID of this uol.
	*
	* @param companyId the company ID of this uol
	*/
	public void setCompanyId(long companyId) {
		_uol.setCompanyId(companyId);
	}

	/**
	* Returns the assessment test ID of this uol.
	*
	* @return the assessment test ID of this uol
	*/
	public long getAssessmentTestId() {
		return _uol.getAssessmentTestId();
	}

	/**
	* Sets the assessment test ID of this uol.
	*
	* @param assessmentTestId the assessment test ID of this uol
	*/
	public void setAssessmentTestId(long assessmentTestId) {
		_uol.setAssessmentTestId(assessmentTestId);
	}

	/**
	* Returns the create date of this uol.
	*
	* @return the create date of this uol
	*/
	public java.util.Date getCreateDate() {
		return _uol.getCreateDate();
	}

	/**
	* Sets the create date of this uol.
	*
	* @param createDate the create date of this uol
	*/
	public void setCreateDate(java.util.Date createDate) {
		_uol.setCreateDate(createDate);
	}

	/**
	* Returns the requested date of this uol.
	*
	* @return the requested date of this uol
	*/
	public java.util.Date getRequestedDate() {
		return _uol.getRequestedDate();
	}

	/**
	* Sets the requested date of this uol.
	*
	* @param requestedDate the requested date of this uol
	*/
	public void setRequestedDate(java.util.Date requestedDate) {
		_uol.setRequestedDate(requestedDate);
	}

	/**
	* Returns the description of this uol.
	*
	* @return the description of this uol
	*/
	public java.lang.String getDescription() {
		return _uol.getDescription();
	}

	/**
	* Sets the description of this uol.
	*
	* @param description the description of this uol
	*/
	public void setDescription(java.lang.String description) {
		_uol.setDescription(description);
	}

	/**
	* Returns the active of this uol.
	*
	* @return the active of this uol
	*/
	public boolean getActive() {
		return _uol.getActive();
	}

	/**
	* Returns <code>true</code> if this uol is active.
	*
	* @return <code>true</code> if this uol is active; <code>false</code> otherwise
	*/
	public boolean isActive() {
		return _uol.isActive();
	}

	/**
	* Sets whether this uol is active.
	*
	* @param active the active of this uol
	*/
	public void setActive(boolean active) {
		_uol.setActive(active);
	}

	/**
	* Returns the eval type ID of this uol.
	*
	* @return the eval type ID of this uol
	*/
	public int getEvalTypeId() {
		return _uol.getEvalTypeId();
	}

	/**
	* Sets the eval type ID of this uol.
	*
	* @param evalTypeId the eval type ID of this uol
	*/
	public void setEvalTypeId(int evalTypeId) {
		_uol.setEvalTypeId(evalTypeId);
	}

	/**
	* Returns the title of this uol.
	*
	* @return the title of this uol
	*/
	public java.lang.String getTitle() {
		return _uol.getTitle();
	}

	/**
	* Sets the title of this uol.
	*
	* @param title the title of this uol
	*/
	public void setTitle(java.lang.String title) {
		_uol.setTitle(title);
	}

	public boolean isNew() {
		return _uol.isNew();
	}

	public void setNew(boolean n) {
		_uol.setNew(n);
	}

	public boolean isCachedModel() {
		return _uol.isCachedModel();
	}

	public void setCachedModel(boolean cachedModel) {
		_uol.setCachedModel(cachedModel);
	}

	public boolean isEscapedModel() {
		return _uol.isEscapedModel();
	}

	public java.io.Serializable getPrimaryKeyObj() {
		return _uol.getPrimaryKeyObj();
	}

	public void setPrimaryKeyObj(java.io.Serializable primaryKeyObj) {
		_uol.setPrimaryKeyObj(primaryKeyObj);
	}

	public com.liferay.portlet.expando.model.ExpandoBridge getExpandoBridge() {
		return _uol.getExpandoBridge();
	}

	public void setExpandoBridgeAttributes(
		com.liferay.portal.service.ServiceContext serviceContext) {
		_uol.setExpandoBridgeAttributes(serviceContext);
	}

	@Override
	public java.lang.Object clone() {
		return new UolWrapper((Uol)_uol.clone());
	}

	public int compareTo(com.qti.slayer.model.Uol uol) {
		return _uol.compareTo(uol);
	}

	@Override
	public int hashCode() {
		return _uol.hashCode();
	}

	public com.liferay.portal.model.CacheModel<com.qti.slayer.model.Uol> toCacheModel() {
		return _uol.toCacheModel();
	}

	public com.qti.slayer.model.Uol toEscapedModel() {
		return new UolWrapper(_uol.toEscapedModel());
	}

	@Override
	public java.lang.String toString() {
		return _uol.toString();
	}

	public java.lang.String toXmlString() {
		return _uol.toXmlString();
	}

	public void persist()
		throws com.liferay.portal.kernel.exception.SystemException {
		_uol.persist();
	}

	/**
	 * @deprecated Renamed to {@link #getWrappedModel}
	 */
	public Uol getWrappedUol() {
		return _uol;
	}

	public Uol getWrappedModel() {
		return _uol;
	}

	public void resetOriginalValues() {
		_uol.resetOriginalValues();
	}

	private Uol _uol;
}