/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service;

import com.liferay.portal.service.ServiceWrapper;

/**
 * <p>
 * This class is a wrapper for {@link AssignmentLocalService}.
 * </p>
 *
 * @author    Hector
 * @see       AssignmentLocalService
 * @generated
 */
public class AssignmentLocalServiceWrapper implements AssignmentLocalService,
	ServiceWrapper<AssignmentLocalService> {
	public AssignmentLocalServiceWrapper(
		AssignmentLocalService assignmentLocalService) {
		_assignmentLocalService = assignmentLocalService;
	}

	/**
	* Adds the assignment to the database. Also notifies the appropriate model listeners.
	*
	* @param assignment the assignment
	* @return the assignment that was added
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Assignment addAssignment(
		com.qti.slayer.model.Assignment assignment)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.addAssignment(assignment);
	}

	/**
	* Creates a new assignment with the primary key. Does not add the assignment to the database.
	*
	* @param assignmentPK the primary key for the new assignment
	* @return the new assignment
	*/
	public com.qti.slayer.model.Assignment createAssignment(
		com.qti.slayer.service.persistence.AssignmentPK assignmentPK) {
		return _assignmentLocalService.createAssignment(assignmentPK);
	}

	/**
	* Deletes the assignment with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param assignmentPK the primary key of the assignment
	* @return the assignment that was removed
	* @throws PortalException if a assignment with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Assignment deleteAssignment(
		com.qti.slayer.service.persistence.AssignmentPK assignmentPK)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.deleteAssignment(assignmentPK);
	}

	/**
	* Deletes the assignment from the database. Also notifies the appropriate model listeners.
	*
	* @param assignment the assignment
	* @return the assignment that was removed
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Assignment deleteAssignment(
		com.qti.slayer.model.Assignment assignment)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.deleteAssignment(assignment);
	}

	public com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
		return _assignmentLocalService.dynamicQuery();
	}

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query
	* @return the matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.dynamicQuery(dynamicQuery);
	}

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @return the range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.dynamicQuery(dynamicQuery, start, end);
	}

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.dynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	* Returns the number of rows that match the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @return the number of rows that match the dynamic query
	* @throws SystemException if a system exception occurred
	*/
	public long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.dynamicQueryCount(dynamicQuery);
	}

	public com.qti.slayer.model.Assignment fetchAssignment(
		com.qti.slayer.service.persistence.AssignmentPK assignmentPK)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.fetchAssignment(assignmentPK);
	}

	/**
	* Returns the assignment with the primary key.
	*
	* @param assignmentPK the primary key of the assignment
	* @return the assignment
	* @throws PortalException if a assignment with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Assignment getAssignment(
		com.qti.slayer.service.persistence.AssignmentPK assignmentPK)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.getAssignment(assignmentPK);
	}

	public com.liferay.portal.model.PersistedModel getPersistedModel(
		java.io.Serializable primaryKeyObj)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.getPersistedModel(primaryKeyObj);
	}

	/**
	* Returns a range of all the assignments.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of assignments
	* @param end the upper bound of the range of assignments (not inclusive)
	* @return the range of assignments
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.Assignment> getAssignments(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.getAssignments(start, end);
	}

	/**
	* Returns the number of assignments.
	*
	* @return the number of assignments
	* @throws SystemException if a system exception occurred
	*/
	public int getAssignmentsCount()
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.getAssignmentsCount();
	}

	/**
	* Updates the assignment in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param assignment the assignment
	* @return the assignment that was updated
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Assignment updateAssignment(
		com.qti.slayer.model.Assignment assignment)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.updateAssignment(assignment);
	}

	/**
	* Updates the assignment in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param assignment the assignment
	* @param merge whether to merge the assignment with the current session. See {@link com.liferay.portal.service.persistence.BatchSession#update(com.liferay.portal.kernel.dao.orm.Session, com.liferay.portal.model.BaseModel, boolean)} for an explanation.
	* @return the assignment that was updated
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Assignment updateAssignment(
		com.qti.slayer.model.Assignment assignment, boolean merge)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _assignmentLocalService.updateAssignment(assignment, merge);
	}

	/**
	* Returns the Spring bean ID for this bean.
	*
	* @return the Spring bean ID for this bean
	*/
	public java.lang.String getBeanIdentifier() {
		return _assignmentLocalService.getBeanIdentifier();
	}

	/**
	* Sets the Spring bean ID for this bean.
	*
	* @param beanIdentifier the Spring bean ID for this bean
	*/
	public void setBeanIdentifier(java.lang.String beanIdentifier) {
		_assignmentLocalService.setBeanIdentifier(beanIdentifier);
	}

	public java.lang.Object invokeMethod(java.lang.String name,
		java.lang.String[] parameterTypes, java.lang.Object[] arguments)
		throws java.lang.Throwable {
		return _assignmentLocalService.invokeMethod(name, parameterTypes,
			arguments);
	}

	/**
	* Creates a new test result with the primary key. Does not add the test result to the database.
	*
	* @param the primary keys for the new test result
	* @return the new test result
	*/
	public com.qti.slayer.model.Assignment getAssignment(
		java.lang.String uolIdStr, java.lang.String userIdStr) {
		return _assignmentLocalService.getAssignment(uolIdStr, userIdStr);
	}

	/**
	 * @deprecated Renamed to {@link #getWrappedService}
	 */
	public AssignmentLocalService getWrappedAssignmentLocalService() {
		return _assignmentLocalService;
	}

	/**
	 * @deprecated Renamed to {@link #setWrappedService}
	 */
	public void setWrappedAssignmentLocalService(
		AssignmentLocalService assignmentLocalService) {
		_assignmentLocalService = assignmentLocalService;
	}

	public AssignmentLocalService getWrappedService() {
		return _assignmentLocalService;
	}

	public void setWrappedService(AssignmentLocalService assignmentLocalService) {
		_assignmentLocalService = assignmentLocalService;
	}

	private AssignmentLocalService _assignmentLocalService;
}