/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service;

import com.liferay.portal.service.ServiceWrapper;

/**
 * <p>
 * This class is a wrapper for {@link TestResultLocalService}.
 * </p>
 *
 * @author    Hector
 * @see       TestResultLocalService
 * @generated
 */
public class TestResultLocalServiceWrapper implements TestResultLocalService,
	ServiceWrapper<TestResultLocalService> {
	public TestResultLocalServiceWrapper(
		TestResultLocalService testResultLocalService) {
		_testResultLocalService = testResultLocalService;
	}

	/**
	* Adds the test result to the database. Also notifies the appropriate model listeners.
	*
	* @param testResult the test result
	* @return the test result that was added
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.TestResult addTestResult(
		com.qti.slayer.model.TestResult testResult)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.addTestResult(testResult);
	}

	/**
	* Creates a new test result with the primary key. Does not add the test result to the database.
	*
	* @param testResultPK the primary key for the new test result
	* @return the new test result
	*/
	public com.qti.slayer.model.TestResult createTestResult(
		com.qti.slayer.service.persistence.TestResultPK testResultPK) {
		return _testResultLocalService.createTestResult(testResultPK);
	}

	/**
	* Deletes the test result with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param testResultPK the primary key of the test result
	* @return the test result that was removed
	* @throws PortalException if a test result with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.TestResult deleteTestResult(
		com.qti.slayer.service.persistence.TestResultPK testResultPK)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.deleteTestResult(testResultPK);
	}

	/**
	* Deletes the test result from the database. Also notifies the appropriate model listeners.
	*
	* @param testResult the test result
	* @return the test result that was removed
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.TestResult deleteTestResult(
		com.qti.slayer.model.TestResult testResult)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.deleteTestResult(testResult);
	}

	public com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
		return _testResultLocalService.dynamicQuery();
	}

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query
	* @return the matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.dynamicQuery(dynamicQuery);
	}

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @return the range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.dynamicQuery(dynamicQuery, start, end);
	}

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.dynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	* Returns the number of rows that match the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @return the number of rows that match the dynamic query
	* @throws SystemException if a system exception occurred
	*/
	public long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.dynamicQueryCount(dynamicQuery);
	}

	public com.qti.slayer.model.TestResult fetchTestResult(
		com.qti.slayer.service.persistence.TestResultPK testResultPK)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.fetchTestResult(testResultPK);
	}

	/**
	* Returns the test result with the primary key.
	*
	* @param testResultPK the primary key of the test result
	* @return the test result
	* @throws PortalException if a test result with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.TestResult getTestResult(
		com.qti.slayer.service.persistence.TestResultPK testResultPK)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.getTestResult(testResultPK);
	}

	public com.liferay.portal.model.PersistedModel getPersistedModel(
		java.io.Serializable primaryKeyObj)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.getPersistedModel(primaryKeyObj);
	}

	/**
	* Returns a range of all the test results.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of test results
	* @param end the upper bound of the range of test results (not inclusive)
	* @return the range of test results
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.TestResult> getTestResults(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.getTestResults(start, end);
	}

	/**
	* Returns the number of test results.
	*
	* @return the number of test results
	* @throws SystemException if a system exception occurred
	*/
	public int getTestResultsCount()
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.getTestResultsCount();
	}

	/**
	* Updates the test result in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param testResult the test result
	* @return the test result that was updated
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.TestResult updateTestResult(
		com.qti.slayer.model.TestResult testResult)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.updateTestResult(testResult);
	}

	/**
	* Updates the test result in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param testResult the test result
	* @param merge whether to merge the test result with the current session. See {@link com.liferay.portal.service.persistence.BatchSession#update(com.liferay.portal.kernel.dao.orm.Session, com.liferay.portal.model.BaseModel, boolean)} for an explanation.
	* @return the test result that was updated
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.TestResult updateTestResult(
		com.qti.slayer.model.TestResult testResult, boolean merge)
		throws com.liferay.portal.kernel.exception.SystemException {
		return _testResultLocalService.updateTestResult(testResult, merge);
	}

	/**
	* Returns the Spring bean ID for this bean.
	*
	* @return the Spring bean ID for this bean
	*/
	public java.lang.String getBeanIdentifier() {
		return _testResultLocalService.getBeanIdentifier();
	}

	/**
	* Sets the Spring bean ID for this bean.
	*
	* @param beanIdentifier the Spring bean ID for this bean
	*/
	public void setBeanIdentifier(java.lang.String beanIdentifier) {
		_testResultLocalService.setBeanIdentifier(beanIdentifier);
	}

	public java.lang.Object invokeMethod(java.lang.String name,
		java.lang.String[] parameterTypes, java.lang.Object[] arguments)
		throws java.lang.Throwable {
		return _testResultLocalService.invokeMethod(name, parameterTypes,
			arguments);
	}

	/**
	* Creates a new test result with the primary key. Does not add the test result to the database.
	*
	* @param the primary keys for the new test result
	* @return the new test result
	*/
	public com.qti.slayer.model.TestResult getTestResult(
		java.lang.String uolIdStr, java.lang.String userIdStr) {
		return _testResultLocalService.getTestResult(uolIdStr, userIdStr);
	}

	/**
	 * @deprecated Renamed to {@link #getWrappedService}
	 */
	public TestResultLocalService getWrappedTestResultLocalService() {
		return _testResultLocalService;
	}

	/**
	 * @deprecated Renamed to {@link #setWrappedService}
	 */
	public void setWrappedTestResultLocalService(
		TestResultLocalService testResultLocalService) {
		_testResultLocalService = testResultLocalService;
	}

	public TestResultLocalService getWrappedService() {
		return _testResultLocalService;
	}

	public void setWrappedService(TestResultLocalService testResultLocalService) {
		_testResultLocalService = testResultLocalService;
	}

	private TestResultLocalService _testResultLocalService;
}