/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service.messaging;

import com.liferay.portal.kernel.messaging.BaseMessageListener;
import com.liferay.portal.kernel.messaging.Message;

import com.qti.slayer.service.AssignmentLocalServiceUtil;
import com.qti.slayer.service.AssignmentServiceUtil;
import com.qti.slayer.service.ClpSerializer;
import com.qti.slayer.service.TestResultLocalServiceUtil;
import com.qti.slayer.service.TestResultServiceUtil;
import com.qti.slayer.service.UolLocalServiceUtil;
import com.qti.slayer.service.UolServiceUtil;

/**
 * @author Brian Wing Shun Chan
 */
public class ClpMessageListener extends BaseMessageListener {
	public static String getServletContextName() {
		return ClpSerializer.getServletContextName();
	}

	@Override
	protected void doReceive(Message message) throws Exception {
		String command = message.getString("command");
		String servletContextName = message.getString("servletContextName");

		if (command.equals("undeploy") &&
				servletContextName.equals(getServletContextName())) {
			AssignmentLocalServiceUtil.clearService();

			AssignmentServiceUtil.clearService();
			TestResultLocalServiceUtil.clearService();

			TestResultServiceUtil.clearService();
			UolLocalServiceUtil.clearService();

			UolServiceUtil.clearService();
		}
	}
}