/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service.persistence;

import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;

import java.io.Serializable;

/**
 * @author Hector
 */
public class TestResultPK implements Comparable<TestResultPK>, Serializable {
	public long userId;
	public long uolId;

	public TestResultPK() {
	}

	public TestResultPK(long userId, long uolId) {
		this.userId = userId;
		this.uolId = uolId;
	}

	public long getUserId() {
		return userId;
	}

	public void setUserId(long userId) {
		this.userId = userId;
	}

	public long getUolId() {
		return uolId;
	}

	public void setUolId(long uolId) {
		this.uolId = uolId;
	}

	public int compareTo(TestResultPK pk) {
		if (pk == null) {
			return -1;
		}

		int value = 0;

		if (userId < pk.userId) {
			value = -1;
		}
		else if (userId > pk.userId) {
			value = 1;
		}
		else {
			value = 0;
		}

		if (value != 0) {
			return value;
		}

		if (uolId < pk.uolId) {
			value = -1;
		}
		else if (uolId > pk.uolId) {
			value = 1;
		}
		else {
			value = 0;
		}

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		TestResultPK pk = null;

		try {
			pk = (TestResultPK)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		if ((userId == pk.userId) && (uolId == pk.uolId)) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (String.valueOf(userId) + String.valueOf(uolId)).hashCode();
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(10);

		sb.append(StringPool.OPEN_CURLY_BRACE);

		sb.append("userId");
		sb.append(StringPool.EQUAL);
		sb.append(userId);

		sb.append(StringPool.COMMA);
		sb.append(StringPool.SPACE);
		sb.append("uolId");
		sb.append(StringPool.EQUAL);
		sb.append(uolId);

		sb.append(StringPool.CLOSE_CURLY_BRACE);

		return sb.toString();
	}
}