/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service.persistence;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.ReferenceRegistry;
import com.liferay.portal.service.ServiceContext;

import com.qti.slayer.model.TestResult;

import java.util.List;

/**
 * The persistence utility for the test result service. This utility wraps {@link TestResultPersistenceImpl} and provides direct access to the database for CRUD operations. This utility should only be used by the service layer, as it must operate within a transaction. Never access this utility in a JSP, controller, model, or other front-end class.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Hector
 * @see TestResultPersistence
 * @see TestResultPersistenceImpl
 * @generated
 */
public class TestResultUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#clearCache()
	 */
	public static void clearCache() {
		getPersistence().clearCache();
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#clearCache(com.liferay.portal.model.BaseModel)
	 */
	public static void clearCache(TestResult testResult) {
		getPersistence().clearCache(testResult);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#countWithDynamicQuery(DynamicQuery)
	 */
	public long countWithDynamicQuery(DynamicQuery dynamicQuery)
		throws SystemException {
		return getPersistence().countWithDynamicQuery(dynamicQuery);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery)
	 */
	public static List<TestResult> findWithDynamicQuery(
		DynamicQuery dynamicQuery) throws SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int)
	 */
	public static List<TestResult> findWithDynamicQuery(
		DynamicQuery dynamicQuery, int start, int end)
		throws SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int, OrderByComparator)
	 */
	public static List<TestResult> findWithDynamicQuery(
		DynamicQuery dynamicQuery, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		return getPersistence()
				   .findWithDynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#update(com.liferay.portal.model.BaseModel, boolean)
	 */
	public static TestResult update(TestResult testResult, boolean merge)
		throws SystemException {
		return getPersistence().update(testResult, merge);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#update(com.liferay.portal.model.BaseModel, boolean, ServiceContext)
	 */
	public static TestResult update(TestResult testResult, boolean merge,
		ServiceContext serviceContext) throws SystemException {
		return getPersistence().update(testResult, merge, serviceContext);
	}

	/**
	* Caches the test result in the entity cache if it is enabled.
	*
	* @param testResult the test result
	*/
	public static void cacheResult(com.qti.slayer.model.TestResult testResult) {
		getPersistence().cacheResult(testResult);
	}

	/**
	* Caches the test results in the entity cache if it is enabled.
	*
	* @param testResults the test results
	*/
	public static void cacheResult(
		java.util.List<com.qti.slayer.model.TestResult> testResults) {
		getPersistence().cacheResult(testResults);
	}

	/**
	* Creates a new test result with the primary key. Does not add the test result to the database.
	*
	* @param testResultPK the primary key for the new test result
	* @return the new test result
	*/
	public static com.qti.slayer.model.TestResult create(
		com.qti.slayer.service.persistence.TestResultPK testResultPK) {
		return getPersistence().create(testResultPK);
	}

	/**
	* Removes the test result with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param testResultPK the primary key of the test result
	* @return the test result that was removed
	* @throws com.qti.slayer.NoSuchTestResultException if a test result with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult remove(
		com.qti.slayer.service.persistence.TestResultPK testResultPK)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchTestResultException {
		return getPersistence().remove(testResultPK);
	}

	public static com.qti.slayer.model.TestResult updateImpl(
		com.qti.slayer.model.TestResult testResult, boolean merge)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().updateImpl(testResult, merge);
	}

	/**
	* Returns the test result with the primary key or throws a {@link com.qti.slayer.NoSuchTestResultException} if it could not be found.
	*
	* @param testResultPK the primary key of the test result
	* @return the test result
	* @throws com.qti.slayer.NoSuchTestResultException if a test result with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult findByPrimaryKey(
		com.qti.slayer.service.persistence.TestResultPK testResultPK)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchTestResultException {
		return getPersistence().findByPrimaryKey(testResultPK);
	}

	/**
	* Returns the test result with the primary key or returns <code>null</code> if it could not be found.
	*
	* @param testResultPK the primary key of the test result
	* @return the test result, or <code>null</code> if a test result with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult fetchByPrimaryKey(
		com.qti.slayer.service.persistence.TestResultPK testResultPK)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().fetchByPrimaryKey(testResultPK);
	}

	/**
	* Returns all the test results where userId = &#63;.
	*
	* @param userId the user ID
	* @return the matching test results
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.TestResult> findByUserId(
		long userId) throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findByUserId(userId);
	}

	/**
	* Returns a range of all the test results where userId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param userId the user ID
	* @param start the lower bound of the range of test results
	* @param end the upper bound of the range of test results (not inclusive)
	* @return the range of matching test results
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.TestResult> findByUserId(
		long userId, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findByUserId(userId, start, end);
	}

	/**
	* Returns an ordered range of all the test results where userId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param userId the user ID
	* @param start the lower bound of the range of test results
	* @param end the upper bound of the range of test results (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching test results
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.TestResult> findByUserId(
		long userId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .findByUserId(userId, start, end, orderByComparator);
	}

	/**
	* Returns the first test result in the ordered set where userId = &#63;.
	*
	* @param userId the user ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching test result
	* @throws com.qti.slayer.NoSuchTestResultException if a matching test result could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult findByUserId_First(
		long userId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchTestResultException {
		return getPersistence().findByUserId_First(userId, orderByComparator);
	}

	/**
	* Returns the first test result in the ordered set where userId = &#63;.
	*
	* @param userId the user ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching test result, or <code>null</code> if a matching test result could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult fetchByUserId_First(
		long userId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().fetchByUserId_First(userId, orderByComparator);
	}

	/**
	* Returns the last test result in the ordered set where userId = &#63;.
	*
	* @param userId the user ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching test result
	* @throws com.qti.slayer.NoSuchTestResultException if a matching test result could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult findByUserId_Last(
		long userId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchTestResultException {
		return getPersistence().findByUserId_Last(userId, orderByComparator);
	}

	/**
	* Returns the last test result in the ordered set where userId = &#63;.
	*
	* @param userId the user ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching test result, or <code>null</code> if a matching test result could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult fetchByUserId_Last(
		long userId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().fetchByUserId_Last(userId, orderByComparator);
	}

	/**
	* Returns the test results before and after the current test result in the ordered set where userId = &#63;.
	*
	* @param testResultPK the primary key of the current test result
	* @param userId the user ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next test result
	* @throws com.qti.slayer.NoSuchTestResultException if a test result with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult[] findByUserId_PrevAndNext(
		com.qti.slayer.service.persistence.TestResultPK testResultPK,
		long userId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchTestResultException {
		return getPersistence()
				   .findByUserId_PrevAndNext(testResultPK, userId,
			orderByComparator);
	}

	/**
	* Returns all the test results where uolId = &#63;.
	*
	* @param uolId the uol ID
	* @return the matching test results
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.TestResult> findByUolId(
		long uolId) throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findByUolId(uolId);
	}

	/**
	* Returns a range of all the test results where uolId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param uolId the uol ID
	* @param start the lower bound of the range of test results
	* @param end the upper bound of the range of test results (not inclusive)
	* @return the range of matching test results
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.TestResult> findByUolId(
		long uolId, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findByUolId(uolId, start, end);
	}

	/**
	* Returns an ordered range of all the test results where uolId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param uolId the uol ID
	* @param start the lower bound of the range of test results
	* @param end the upper bound of the range of test results (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching test results
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.TestResult> findByUolId(
		long uolId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findByUolId(uolId, start, end, orderByComparator);
	}

	/**
	* Returns the first test result in the ordered set where uolId = &#63;.
	*
	* @param uolId the uol ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching test result
	* @throws com.qti.slayer.NoSuchTestResultException if a matching test result could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult findByUolId_First(
		long uolId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchTestResultException {
		return getPersistence().findByUolId_First(uolId, orderByComparator);
	}

	/**
	* Returns the first test result in the ordered set where uolId = &#63;.
	*
	* @param uolId the uol ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching test result, or <code>null</code> if a matching test result could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult fetchByUolId_First(
		long uolId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().fetchByUolId_First(uolId, orderByComparator);
	}

	/**
	* Returns the last test result in the ordered set where uolId = &#63;.
	*
	* @param uolId the uol ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching test result
	* @throws com.qti.slayer.NoSuchTestResultException if a matching test result could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult findByUolId_Last(long uolId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchTestResultException {
		return getPersistence().findByUolId_Last(uolId, orderByComparator);
	}

	/**
	* Returns the last test result in the ordered set where uolId = &#63;.
	*
	* @param uolId the uol ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching test result, or <code>null</code> if a matching test result could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult fetchByUolId_Last(
		long uolId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().fetchByUolId_Last(uolId, orderByComparator);
	}

	/**
	* Returns the test results before and after the current test result in the ordered set where uolId = &#63;.
	*
	* @param testResultPK the primary key of the current test result
	* @param uolId the uol ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next test result
	* @throws com.qti.slayer.NoSuchTestResultException if a test result with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.TestResult[] findByUolId_PrevAndNext(
		com.qti.slayer.service.persistence.TestResultPK testResultPK,
		long uolId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchTestResultException {
		return getPersistence()
				   .findByUolId_PrevAndNext(testResultPK, uolId,
			orderByComparator);
	}

	/**
	* Returns all the test results.
	*
	* @return the test results
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.TestResult> findAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll();
	}

	/**
	* Returns a range of all the test results.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of test results
	* @param end the upper bound of the range of test results (not inclusive)
	* @return the range of test results
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.TestResult> findAll(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll(start, end);
	}

	/**
	* Returns an ordered range of all the test results.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of test results
	* @param end the upper bound of the range of test results (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of test results
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.TestResult> findAll(
		int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll(start, end, orderByComparator);
	}

	/**
	* Removes all the test results where userId = &#63; from the database.
	*
	* @param userId the user ID
	* @throws SystemException if a system exception occurred
	*/
	public static void removeByUserId(long userId)
		throws com.liferay.portal.kernel.exception.SystemException {
		getPersistence().removeByUserId(userId);
	}

	/**
	* Removes all the test results where uolId = &#63; from the database.
	*
	* @param uolId the uol ID
	* @throws SystemException if a system exception occurred
	*/
	public static void removeByUolId(long uolId)
		throws com.liferay.portal.kernel.exception.SystemException {
		getPersistence().removeByUolId(uolId);
	}

	/**
	* Removes all the test results from the database.
	*
	* @throws SystemException if a system exception occurred
	*/
	public static void removeAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		getPersistence().removeAll();
	}

	/**
	* Returns the number of test results where userId = &#63;.
	*
	* @param userId the user ID
	* @return the number of matching test results
	* @throws SystemException if a system exception occurred
	*/
	public static int countByUserId(long userId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().countByUserId(userId);
	}

	/**
	* Returns the number of test results where uolId = &#63;.
	*
	* @param uolId the uol ID
	* @return the number of matching test results
	* @throws SystemException if a system exception occurred
	*/
	public static int countByUolId(long uolId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().countByUolId(uolId);
	}

	/**
	* Returns the number of test results.
	*
	* @return the number of test results
	* @throws SystemException if a system exception occurred
	*/
	public static int countAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().countAll();
	}

	public static TestResultPersistence getPersistence() {
		if (_persistence == null) {
			_persistence = (TestResultPersistence)PortletBeanLocatorUtil.locate(com.qti.slayer.service.ClpSerializer.getServletContextName(),
					TestResultPersistence.class.getName());

			ReferenceRegistry.registerReference(TestResultUtil.class,
				"_persistence");
		}

		return _persistence;
	}

	/**
	 * @deprecated
	 */
	public void setPersistence(TestResultPersistence persistence) {
	}

	private static TestResultPersistence _persistence;
}