/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service.persistence;

import com.liferay.portal.service.persistence.BasePersistence;

import com.qti.slayer.model.Uol;

/**
 * The persistence interface for the uol service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Hector
 * @see UolPersistenceImpl
 * @see UolUtil
 * @generated
 */
public interface UolPersistence extends BasePersistence<Uol> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. Always use {@link UolUtil} to access the uol persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this interface.
	 */

	/**
	* Caches the uol in the entity cache if it is enabled.
	*
	* @param uol the uol
	*/
	public void cacheResult(com.qti.slayer.model.Uol uol);

	/**
	* Caches the uols in the entity cache if it is enabled.
	*
	* @param uols the uols
	*/
	public void cacheResult(java.util.List<com.qti.slayer.model.Uol> uols);

	/**
	* Creates a new uol with the primary key. Does not add the uol to the database.
	*
	* @param I_Id the primary key for the new uol
	* @return the new uol
	*/
	public com.qti.slayer.model.Uol create(long I_Id);

	/**
	* Removes the uol with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param I_Id the primary key of the uol
	* @return the uol that was removed
	* @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol remove(long I_Id)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException;

	public com.qti.slayer.model.Uol updateImpl(com.qti.slayer.model.Uol uol,
		boolean merge)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the uol with the primary key or throws a {@link com.qti.slayer.NoSuchUolException} if it could not be found.
	*
	* @param I_Id the primary key of the uol
	* @return the uol
	* @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol findByPrimaryKey(long I_Id)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException;

	/**
	* Returns the uol with the primary key or returns <code>null</code> if it could not be found.
	*
	* @param I_Id the primary key of the uol
	* @return the uol, or <code>null</code> if a uol with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol fetchByPrimaryKey(long I_Id)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns all the uols where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @return the matching uols
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.Uol> findByClassRoomId(
		long classRoomId)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns a range of all the uols where classRoomId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param classRoomId the class room ID
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @return the range of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.Uol> findByClassRoomId(
		long classRoomId, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns an ordered range of all the uols where classRoomId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param classRoomId the class room ID
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.Uol> findByClassRoomId(
		long classRoomId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the first uol in the ordered set where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching uol
	* @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol findByClassRoomId_First(long classRoomId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException;

	/**
	* Returns the first uol in the ordered set where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching uol, or <code>null</code> if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol fetchByClassRoomId_First(long classRoomId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the last uol in the ordered set where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching uol
	* @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol findByClassRoomId_Last(long classRoomId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException;

	/**
	* Returns the last uol in the ordered set where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching uol, or <code>null</code> if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol fetchByClassRoomId_Last(long classRoomId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the uols before and after the current uol in the ordered set where classRoomId = &#63;.
	*
	* @param I_Id the primary key of the current uol
	* @param classRoomId the class room ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next uol
	* @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol[] findByClassRoomId_PrevAndNext(long I_Id,
		long classRoomId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException;

	/**
	* Returns all the uols where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @return the matching uols
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.Uol> findByAssessmentTestId(
		long assessmentTestId)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns a range of all the uols where assessmentTestId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param assessmentTestId the assessment test ID
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @return the range of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.Uol> findByAssessmentTestId(
		long assessmentTestId, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns an ordered range of all the uols where assessmentTestId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param assessmentTestId the assessment test ID
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.Uol> findByAssessmentTestId(
		long assessmentTestId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the first uol in the ordered set where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching uol
	* @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol findByAssessmentTestId_First(
		long assessmentTestId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException;

	/**
	* Returns the first uol in the ordered set where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching uol, or <code>null</code> if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol fetchByAssessmentTestId_First(
		long assessmentTestId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the last uol in the ordered set where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching uol
	* @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol findByAssessmentTestId_Last(
		long assessmentTestId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException;

	/**
	* Returns the last uol in the ordered set where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching uol, or <code>null</code> if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol fetchByAssessmentTestId_Last(
		long assessmentTestId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the uols before and after the current uol in the ordered set where assessmentTestId = &#63;.
	*
	* @param I_Id the primary key of the current uol
	* @param assessmentTestId the assessment test ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next uol
	* @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public com.qti.slayer.model.Uol[] findByAssessmentTestId_PrevAndNext(
		long I_Id, long assessmentTestId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException;

	/**
	* Returns all the uols.
	*
	* @return the uols
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.Uol> findAll()
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns a range of all the uols.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @return the range of uols
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.Uol> findAll(int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns an ordered range of all the uols.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of uols
	* @throws SystemException if a system exception occurred
	*/
	public java.util.List<com.qti.slayer.model.Uol> findAll(int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Removes all the uols where classRoomId = &#63; from the database.
	*
	* @param classRoomId the class room ID
	* @throws SystemException if a system exception occurred
	*/
	public void removeByClassRoomId(long classRoomId)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Removes all the uols where assessmentTestId = &#63; from the database.
	*
	* @param assessmentTestId the assessment test ID
	* @throws SystemException if a system exception occurred
	*/
	public void removeByAssessmentTestId(long assessmentTestId)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Removes all the uols from the database.
	*
	* @throws SystemException if a system exception occurred
	*/
	public void removeAll()
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the number of uols where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @return the number of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public int countByClassRoomId(long classRoomId)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the number of uols where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @return the number of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public int countByAssessmentTestId(long assessmentTestId)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Returns the number of uols.
	*
	* @return the number of uols
	* @throws SystemException if a system exception occurred
	*/
	public int countAll()
		throws com.liferay.portal.kernel.exception.SystemException;
}