/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service.persistence;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.ReferenceRegistry;
import com.liferay.portal.service.ServiceContext;

import com.qti.slayer.model.Uol;

import java.util.List;

/**
 * The persistence utility for the uol service. This utility wraps {@link UolPersistenceImpl} and provides direct access to the database for CRUD operations. This utility should only be used by the service layer, as it must operate within a transaction. Never access this utility in a JSP, controller, model, or other front-end class.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Hector
 * @see UolPersistence
 * @see UolPersistenceImpl
 * @generated
 */
public class UolUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#clearCache()
	 */
	public static void clearCache() {
		getPersistence().clearCache();
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#clearCache(com.liferay.portal.model.BaseModel)
	 */
	public static void clearCache(Uol uol) {
		getPersistence().clearCache(uol);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#countWithDynamicQuery(DynamicQuery)
	 */
	public long countWithDynamicQuery(DynamicQuery dynamicQuery)
		throws SystemException {
		return getPersistence().countWithDynamicQuery(dynamicQuery);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery)
	 */
	public static List<Uol> findWithDynamicQuery(DynamicQuery dynamicQuery)
		throws SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int)
	 */
	public static List<Uol> findWithDynamicQuery(DynamicQuery dynamicQuery,
		int start, int end) throws SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int, OrderByComparator)
	 */
	public static List<Uol> findWithDynamicQuery(DynamicQuery dynamicQuery,
		int start, int end, OrderByComparator orderByComparator)
		throws SystemException {
		return getPersistence()
				   .findWithDynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#update(com.liferay.portal.model.BaseModel, boolean)
	 */
	public static Uol update(Uol uol, boolean merge) throws SystemException {
		return getPersistence().update(uol, merge);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#update(com.liferay.portal.model.BaseModel, boolean, ServiceContext)
	 */
	public static Uol update(Uol uol, boolean merge,
		ServiceContext serviceContext) throws SystemException {
		return getPersistence().update(uol, merge, serviceContext);
	}

	/**
	* Caches the uol in the entity cache if it is enabled.
	*
	* @param uol the uol
	*/
	public static void cacheResult(com.qti.slayer.model.Uol uol) {
		getPersistence().cacheResult(uol);
	}

	/**
	* Caches the uols in the entity cache if it is enabled.
	*
	* @param uols the uols
	*/
	public static void cacheResult(
		java.util.List<com.qti.slayer.model.Uol> uols) {
		getPersistence().cacheResult(uols);
	}

	/**
	* Creates a new uol with the primary key. Does not add the uol to the database.
	*
	* @param I_Id the primary key for the new uol
	* @return the new uol
	*/
	public static com.qti.slayer.model.Uol create(long I_Id) {
		return getPersistence().create(I_Id);
	}

	/**
	* Removes the uol with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param I_Id the primary key of the uol
	* @return the uol that was removed
	* @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol remove(long I_Id)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException {
		return getPersistence().remove(I_Id);
	}

	public static com.qti.slayer.model.Uol updateImpl(
		com.qti.slayer.model.Uol uol, boolean merge)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().updateImpl(uol, merge);
	}

	/**
	* Returns the uol with the primary key or throws a {@link com.qti.slayer.NoSuchUolException} if it could not be found.
	*
	* @param I_Id the primary key of the uol
	* @return the uol
	* @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol findByPrimaryKey(long I_Id)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException {
		return getPersistence().findByPrimaryKey(I_Id);
	}

	/**
	* Returns the uol with the primary key or returns <code>null</code> if it could not be found.
	*
	* @param I_Id the primary key of the uol
	* @return the uol, or <code>null</code> if a uol with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol fetchByPrimaryKey(long I_Id)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().fetchByPrimaryKey(I_Id);
	}

	/**
	* Returns all the uols where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @return the matching uols
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.Uol> findByClassRoomId(
		long classRoomId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findByClassRoomId(classRoomId);
	}

	/**
	* Returns a range of all the uols where classRoomId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param classRoomId the class room ID
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @return the range of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.Uol> findByClassRoomId(
		long classRoomId, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findByClassRoomId(classRoomId, start, end);
	}

	/**
	* Returns an ordered range of all the uols where classRoomId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param classRoomId the class room ID
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.Uol> findByClassRoomId(
		long classRoomId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .findByClassRoomId(classRoomId, start, end, orderByComparator);
	}

	/**
	* Returns the first uol in the ordered set where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching uol
	* @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol findByClassRoomId_First(
		long classRoomId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException {
		return getPersistence()
				   .findByClassRoomId_First(classRoomId, orderByComparator);
	}

	/**
	* Returns the first uol in the ordered set where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching uol, or <code>null</code> if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol fetchByClassRoomId_First(
		long classRoomId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .fetchByClassRoomId_First(classRoomId, orderByComparator);
	}

	/**
	* Returns the last uol in the ordered set where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching uol
	* @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol findByClassRoomId_Last(
		long classRoomId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException {
		return getPersistence()
				   .findByClassRoomId_Last(classRoomId, orderByComparator);
	}

	/**
	* Returns the last uol in the ordered set where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching uol, or <code>null</code> if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol fetchByClassRoomId_Last(
		long classRoomId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .fetchByClassRoomId_Last(classRoomId, orderByComparator);
	}

	/**
	* Returns the uols before and after the current uol in the ordered set where classRoomId = &#63;.
	*
	* @param I_Id the primary key of the current uol
	* @param classRoomId the class room ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next uol
	* @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol[] findByClassRoomId_PrevAndNext(
		long I_Id, long classRoomId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException {
		return getPersistence()
				   .findByClassRoomId_PrevAndNext(I_Id, classRoomId,
			orderByComparator);
	}

	/**
	* Returns all the uols where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @return the matching uols
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.Uol> findByAssessmentTestId(
		long assessmentTestId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findByAssessmentTestId(assessmentTestId);
	}

	/**
	* Returns a range of all the uols where assessmentTestId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param assessmentTestId the assessment test ID
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @return the range of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.Uol> findByAssessmentTestId(
		long assessmentTestId, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .findByAssessmentTestId(assessmentTestId, start, end);
	}

	/**
	* Returns an ordered range of all the uols where assessmentTestId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param assessmentTestId the assessment test ID
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.Uol> findByAssessmentTestId(
		long assessmentTestId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .findByAssessmentTestId(assessmentTestId, start, end,
			orderByComparator);
	}

	/**
	* Returns the first uol in the ordered set where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching uol
	* @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol findByAssessmentTestId_First(
		long assessmentTestId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException {
		return getPersistence()
				   .findByAssessmentTestId_First(assessmentTestId,
			orderByComparator);
	}

	/**
	* Returns the first uol in the ordered set where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching uol, or <code>null</code> if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol fetchByAssessmentTestId_First(
		long assessmentTestId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .fetchByAssessmentTestId_First(assessmentTestId,
			orderByComparator);
	}

	/**
	* Returns the last uol in the ordered set where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching uol
	* @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol findByAssessmentTestId_Last(
		long assessmentTestId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException {
		return getPersistence()
				   .findByAssessmentTestId_Last(assessmentTestId,
			orderByComparator);
	}

	/**
	* Returns the last uol in the ordered set where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching uol, or <code>null</code> if a matching uol could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol fetchByAssessmentTestId_Last(
		long assessmentTestId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .fetchByAssessmentTestId_Last(assessmentTestId,
			orderByComparator);
	}

	/**
	* Returns the uols before and after the current uol in the ordered set where assessmentTestId = &#63;.
	*
	* @param I_Id the primary key of the current uol
	* @param assessmentTestId the assessment test ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next uol
	* @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.qti.slayer.model.Uol[] findByAssessmentTestId_PrevAndNext(
		long I_Id, long assessmentTestId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.qti.slayer.NoSuchUolException {
		return getPersistence()
				   .findByAssessmentTestId_PrevAndNext(I_Id, assessmentTestId,
			orderByComparator);
	}

	/**
	* Returns all the uols.
	*
	* @return the uols
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.Uol> findAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll();
	}

	/**
	* Returns a range of all the uols.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @return the range of uols
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.Uol> findAll(int start,
		int end) throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll(start, end);
	}

	/**
	* Returns an ordered range of all the uols.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of uols
	* @param end the upper bound of the range of uols (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of uols
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.qti.slayer.model.Uol> findAll(int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll(start, end, orderByComparator);
	}

	/**
	* Removes all the uols where classRoomId = &#63; from the database.
	*
	* @param classRoomId the class room ID
	* @throws SystemException if a system exception occurred
	*/
	public static void removeByClassRoomId(long classRoomId)
		throws com.liferay.portal.kernel.exception.SystemException {
		getPersistence().removeByClassRoomId(classRoomId);
	}

	/**
	* Removes all the uols where assessmentTestId = &#63; from the database.
	*
	* @param assessmentTestId the assessment test ID
	* @throws SystemException if a system exception occurred
	*/
	public static void removeByAssessmentTestId(long assessmentTestId)
		throws com.liferay.portal.kernel.exception.SystemException {
		getPersistence().removeByAssessmentTestId(assessmentTestId);
	}

	/**
	* Removes all the uols from the database.
	*
	* @throws SystemException if a system exception occurred
	*/
	public static void removeAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		getPersistence().removeAll();
	}

	/**
	* Returns the number of uols where classRoomId = &#63;.
	*
	* @param classRoomId the class room ID
	* @return the number of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public static int countByClassRoomId(long classRoomId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().countByClassRoomId(classRoomId);
	}

	/**
	* Returns the number of uols where assessmentTestId = &#63;.
	*
	* @param assessmentTestId the assessment test ID
	* @return the number of matching uols
	* @throws SystemException if a system exception occurred
	*/
	public static int countByAssessmentTestId(long assessmentTestId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().countByAssessmentTestId(assessmentTestId);
	}

	/**
	* Returns the number of uols.
	*
	* @return the number of uols
	* @throws SystemException if a system exception occurred
	*/
	public static int countAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().countAll();
	}

	public static UolPersistence getPersistence() {
		if (_persistence == null) {
			_persistence = (UolPersistence)PortletBeanLocatorUtil.locate(com.qti.slayer.service.ClpSerializer.getServletContextName(),
					UolPersistence.class.getName());

			ReferenceRegistry.registerReference(UolUtil.class, "_persistence");
		}

		return _persistence;
	}

	/**
	 * @deprecated
	 */
	public void setPersistence(UolPersistence persistence) {
	}

	private static UolPersistence _persistence;
}