package com.qti;

import java.io.IOException;
import java.util.Date;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.PortletException;

import com.liferay.counter.service.CounterLocalServiceUtil;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.ParamUtil;
import com.liferay.util.bridges.mvc.MVCPortlet;
import com.qti.slayer.model.Assignment;
import com.qti.slayer.model.Uol;
import com.qti.slayer.model.impl.UolImpl;
import com.qti.slayer.service.AssignmentLocalServiceUtil;
import com.qti.slayer.service.UolLocalServiceUtil;

/**
 * Portlet implementation class QtiViewer
 */
public class QtiViewer extends MVCPortlet {
	
	/**
	* Updates QTI test.
	*
	* @param actionRequest  ActionRequest object
	* @param actionResponse Action Response object
	* @throws IOException if system exception occurred
	* @throws PortletException if a portlet exception occurred
	*/
	
	public void updateQTITest(ActionRequest actionRequest,	ActionResponse actionResponse)	throws IOException, PortletException 
	{
	String qtiTitle = ParamUtil.getString(actionRequest, "qtiTitle");
	String content = ParamUtil.getString(actionRequest, "content");
	System.out.println("Els inputs ==> " + qtiTitle + ", " + content);
	
	
	Uol uolAux = new UolImpl();
	//set primary key
	long UolId =0L;
	
	try 
	{
		UolId = CounterLocalServiceUtil.increment(this.getClass().getName());
	} 
	
	catch (SystemException e)
	{
		e.printStackTrace();
		
	}
	
	uolAux.setI_Id(UolId);
	
	
	
	//set UI fields
	
	uolAux.setTitle(qtiTitle);
	

	
	//set audit field(s)
	uolAux.setDescription("Aquesta es una prova de UOL");
	uolAux.setCreateDate(new Date());
	
	
	//insert the Uol using persistence API
	
	try 
	{
		UolLocalServiceUtil.addUol(uolAux);
	}
	catch (SystemException e) 
	{
		e.printStackTrace();	
	}
	
	// gracefully redirecting to the default portlet view
	String redirectURL = ParamUtil.getString(actionRequest, "redirectURL");
	actionResponse.sendRedirect(redirectURL);
 
	}
	
	/**
	* Updates Unit of Learning Status.
	*
	* @param actionRequest  ActionRequest object
	* @param actionResponse Action Response object
	* @throws IOException if system exception occurred
	* @throws PortletException if a portlet exception occurred
	*/
	public void updateStatusAction(ActionRequest actionRequest,ActionResponse actionResponse)	throws IOException, PortletException 
	{
		String I_Id = ParamUtil.getString(actionRequest, "I_Id");
		System.out.println("Els inputs ==> " + I_Id);
		
		Uol uolAux=null;
		try {
			uolAux = UolLocalServiceUtil.getUol(Long.parseLong(I_Id));
		} catch (NumberFormatException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (PortalException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (SystemException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		boolean currentStatus = uolAux.getActive();
		System.out.println("Updating Uol Status:" + uolAux.getActive());
		
		//remove the assignment using persistence API
		
		try 
		{
			uolAux.setActive(!currentStatus);
			UolLocalServiceUtil.updateUol(uolAux);
		}
		catch (SystemException e) 
		{
			e.printStackTrace();	
		}
		
	}
	
	
}
