package com.qti;

import java.io.IOException;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.PortletException;

import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.ParamUtil;
import com.liferay.util.bridges.mvc.MVCPortlet;
import com.qti.slayer.model.TestResult;
import com.qti.slayer.service.TestResultLocalServiceUtil;

/**
 * Portlet implementation class TestResultPortlet
 */
public class TestResultPortlet extends MVCPortlet {
 
	/**
	* Removes Test Result.
	*
	* @param actionRequest  ActionRequest object
	* @param actionResponse Action Response object
	* @throws IOException if system exception occurred
	* @throws PortletException if a portlet exception occurred
	*/
	public void removeTestResultAction(ActionRequest actionRequest,ActionResponse actionResponse)	throws IOException, PortletException 
	{
		String uolId = ParamUtil.getString(actionRequest, "uolId");
		String userId = ParamUtil.getString(actionRequest, "userId");
		System.out.println("Els inputs ==> " + uolId + ", " + userId);
		
		
		TestResult testAux = TestResultLocalServiceUtil.getTestResult(uolId, userId);
		System.out.println("Deleting test result:" + testAux.toString());
		
		//remove the assignment using persistence API
		
		try 
		{
			TestResultLocalServiceUtil.deleteTestResult(testAux);
		}
		catch (SystemException e) 
		{
			e.printStackTrace();	
		}
		
	}

	
}
