/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model.impl;

import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;

import com.qti.slayer.model.Assignment;

import java.io.Serializable;

/**
 * The cache model class for representing Assignment in entity cache.
 *
 * @author Hector
 * @see Assignment
 * @generated
 */
public class AssignmentCacheModel implements CacheModel<Assignment>,
	Serializable {
	@Override
	public String toString() {
		StringBundler sb = new StringBundler(13);

		sb.append("{userId=");
		sb.append(userId);
		sb.append(", uolId=");
		sb.append(uolId);
		sb.append(", status=");
		sb.append(status);
		sb.append(", uoltype=");
		sb.append(uoltype);
		sb.append(", title=");
		sb.append(title);
		sb.append(", username=");
		sb.append(username);
		sb.append("}");

		return sb.toString();
	}

	public Assignment toEntityModel() {
		AssignmentImpl assignmentImpl = new AssignmentImpl();

		assignmentImpl.setUserId(userId);
		assignmentImpl.setUolId(uolId);
		assignmentImpl.setStatus(status);
		assignmentImpl.setUoltype(uoltype);

		if (title == null) {
			assignmentImpl.setTitle(StringPool.BLANK);
		}
		else {
			assignmentImpl.setTitle(title);
		}

		if (username == null) {
			assignmentImpl.setUsername(StringPool.BLANK);
		}
		else {
			assignmentImpl.setUsername(username);
		}

		assignmentImpl.resetOriginalValues();

		return assignmentImpl;
	}

	public long userId;
	public long uolId;
	public int status;
	public int uoltype;
	public String title;
	public String username;
}