/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model.impl;

import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;

import com.qti.slayer.model.TestResult;

import java.io.Serializable;

/**
 * The cache model class for representing TestResult in entity cache.
 *
 * @author Hector
 * @see TestResult
 * @generated
 */
public class TestResultCacheModel implements CacheModel<TestResult>,
	Serializable {
	@Override
	public String toString() {
		StringBundler sb = new StringBundler(15);

		sb.append("{userId=");
		sb.append(userId);
		sb.append(", uolId=");
		sb.append(uolId);
		sb.append(", result=");
		sb.append(result);
		sb.append(", autoComment=");
		sb.append(autoComment);
		sb.append(", teacherComment=");
		sb.append(teacherComment);
		sb.append(", title=");
		sb.append(title);
		sb.append(", username=");
		sb.append(username);
		sb.append("}");

		return sb.toString();
	}

	public TestResult toEntityModel() {
		TestResultImpl testResultImpl = new TestResultImpl();

		testResultImpl.setUserId(userId);
		testResultImpl.setUolId(uolId);
		testResultImpl.setResult(result);

		if (autoComment == null) {
			testResultImpl.setAutoComment(StringPool.BLANK);
		}
		else {
			testResultImpl.setAutoComment(autoComment);
		}

		if (teacherComment == null) {
			testResultImpl.setTeacherComment(StringPool.BLANK);
		}
		else {
			testResultImpl.setTeacherComment(teacherComment);
		}

		if (title == null) {
			testResultImpl.setTitle(StringPool.BLANK);
		}
		else {
			testResultImpl.setTitle(title);
		}

		if (username == null) {
			testResultImpl.setUsername(StringPool.BLANK);
		}
		else {
			testResultImpl.setUsername(username);
		}

		testResultImpl.resetOriginalValues();

		return testResultImpl;
	}

	public long userId;
	public long uolId;
	public int result;
	public String autoComment;
	public String teacherComment;
	public String title;
	public String username;
}