/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model.impl;

import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;

import com.qti.slayer.model.Uol;

import java.io.Serializable;

import java.util.Date;

/**
 * The cache model class for representing Uol in entity cache.
 *
 * @author Hector
 * @see Uol
 * @generated
 */
public class UolCacheModel implements CacheModel<Uol>, Serializable {
	@Override
	public String toString() {
		StringBundler sb = new StringBundler(25);

		sb.append("{I_Id=");
		sb.append(I_Id);
		sb.append(", classRoomId=");
		sb.append(classRoomId);
		sb.append(", subjectId=");
		sb.append(subjectId);
		sb.append(", countryId=");
		sb.append(countryId);
		sb.append(", companyId=");
		sb.append(companyId);
		sb.append(", assessmentTestId=");
		sb.append(assessmentTestId);
		sb.append(", createDate=");
		sb.append(createDate);
		sb.append(", requestedDate=");
		sb.append(requestedDate);
		sb.append(", description=");
		sb.append(description);
		sb.append(", active=");
		sb.append(active);
		sb.append(", evalTypeId=");
		sb.append(evalTypeId);
		sb.append(", title=");
		sb.append(title);
		sb.append("}");

		return sb.toString();
	}

	public Uol toEntityModel() {
		UolImpl uolImpl = new UolImpl();

		uolImpl.setI_Id(I_Id);
		uolImpl.setClassRoomId(classRoomId);
		uolImpl.setSubjectId(subjectId);
		uolImpl.setCountryId(countryId);
		uolImpl.setCompanyId(companyId);
		uolImpl.setAssessmentTestId(assessmentTestId);

		if (createDate == Long.MIN_VALUE) {
			uolImpl.setCreateDate(null);
		}
		else {
			uolImpl.setCreateDate(new Date(createDate));
		}

		if (requestedDate == Long.MIN_VALUE) {
			uolImpl.setRequestedDate(null);
		}
		else {
			uolImpl.setRequestedDate(new Date(requestedDate));
		}

		if (description == null) {
			uolImpl.setDescription(StringPool.BLANK);
		}
		else {
			uolImpl.setDescription(description);
		}

		uolImpl.setActive(active);
		uolImpl.setEvalTypeId(evalTypeId);

		if (title == null) {
			uolImpl.setTitle(StringPool.BLANK);
		}
		else {
			uolImpl.setTitle(title);
		}

		uolImpl.resetOriginalValues();

		return uolImpl;
	}

	public long I_Id;
	public long classRoomId;
	public long subjectId;
	public long countryId;
	public long companyId;
	public long assessmentTestId;
	public long createDate;
	public long requestedDate;
	public String description;
	public boolean active;
	public int evalTypeId;
	public String title;
}