/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.json.JSON;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import com.qti.slayer.model.Uol;
import com.qti.slayer.model.UolModel;
import com.qti.slayer.model.UolSoap;

import java.io.Serializable;

import java.sql.Types;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * The base model implementation for the Uol service. Represents a row in the &quot;QTI_Uol&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link com.qti.slayer.model.UolModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link UolImpl}.
 * </p>
 *
 * @author Hector
 * @see UolImpl
 * @see com.qti.slayer.model.Uol
 * @see com.qti.slayer.model.UolModel
 * @generated
 */
@JSON(strict = true)
public class UolModelImpl extends BaseModelImpl<Uol> implements UolModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a uol model instance should use the {@link com.qti.slayer.model.Uol} interface instead.
	 */
	public static final String TABLE_NAME = "QTI_Uol";
	public static final Object[][] TABLE_COLUMNS = {
			{ "I_Id", Types.BIGINT },
			{ "classRoomId", Types.BIGINT },
			{ "subjectId", Types.BIGINT },
			{ "countryId", Types.BIGINT },
			{ "companyId", Types.BIGINT },
			{ "assessmentTestId", Types.BIGINT },
			{ "createDate", Types.TIMESTAMP },
			{ "requestedDate", Types.TIMESTAMP },
			{ "description", Types.VARCHAR },
			{ "active_", Types.BOOLEAN },
			{ "evalTypeId", Types.INTEGER },
			{ "title", Types.VARCHAR }
		};
	public static final String TABLE_SQL_CREATE = "create table QTI_Uol (I_Id LONG not null primary key,classRoomId LONG,subjectId LONG,countryId LONG,companyId LONG,assessmentTestId LONG,createDate DATE null,requestedDate DATE null,description VARCHAR(75) null,active_ BOOLEAN,evalTypeId INTEGER,title VARCHAR(75) null)";
	public static final String TABLE_SQL_DROP = "drop table QTI_Uol";
	public static final String ORDER_BY_JPQL = " ORDER BY uol.classRoomId ASC";
	public static final String ORDER_BY_SQL = " ORDER BY QTI_Uol.classRoomId ASC";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.com.qti.slayer.model.Uol"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.com.qti.slayer.model.Uol"),
			true);
	public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.column.bitmask.enabled.com.qti.slayer.model.Uol"),
			true);
	public static long ASSESSMENTTESTID_COLUMN_BITMASK = 1L;
	public static long CLASSROOMID_COLUMN_BITMASK = 2L;

	/**
	 * Converts the soap model instance into a normal model instance.
	 *
	 * @param soapModel the soap model instance to convert
	 * @return the normal model instance
	 */
	public static Uol toModel(UolSoap soapModel) {
		if (soapModel == null) {
			return null;
		}

		Uol model = new UolImpl();

		model.setI_Id(soapModel.getI_Id());
		model.setClassRoomId(soapModel.getClassRoomId());
		model.setSubjectId(soapModel.getSubjectId());
		model.setCountryId(soapModel.getCountryId());
		model.setCompanyId(soapModel.getCompanyId());
		model.setAssessmentTestId(soapModel.getAssessmentTestId());
		model.setCreateDate(soapModel.getCreateDate());
		model.setRequestedDate(soapModel.getRequestedDate());
		model.setDescription(soapModel.getDescription());
		model.setActive(soapModel.getActive());
		model.setEvalTypeId(soapModel.getEvalTypeId());
		model.setTitle(soapModel.getTitle());

		return model;
	}

	/**
	 * Converts the soap model instances into normal model instances.
	 *
	 * @param soapModels the soap model instances to convert
	 * @return the normal model instances
	 */
	public static List<Uol> toModels(UolSoap[] soapModels) {
		if (soapModels == null) {
			return null;
		}

		List<Uol> models = new ArrayList<Uol>(soapModels.length);

		for (UolSoap soapModel : soapModels) {
			models.add(toModel(soapModel));
		}

		return models;
	}

	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.com.qti.slayer.model.Uol"));

	public UolModelImpl() {
	}

	public long getPrimaryKey() {
		return _I_Id;
	}

	public void setPrimaryKey(long primaryKey) {
		setI_Id(primaryKey);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_I_Id);
	}

	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	public Class<?> getModelClass() {
		return Uol.class;
	}

	public String getModelClassName() {
		return Uol.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("I_Id", getI_Id());
		attributes.put("classRoomId", getClassRoomId());
		attributes.put("subjectId", getSubjectId());
		attributes.put("countryId", getCountryId());
		attributes.put("companyId", getCompanyId());
		attributes.put("assessmentTestId", getAssessmentTestId());
		attributes.put("createDate", getCreateDate());
		attributes.put("requestedDate", getRequestedDate());
		attributes.put("description", getDescription());
		attributes.put("active", getActive());
		attributes.put("evalTypeId", getEvalTypeId());
		attributes.put("title", getTitle());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long I_Id = (Long)attributes.get("I_Id");

		if (I_Id != null) {
			setI_Id(I_Id);
		}

		Long classRoomId = (Long)attributes.get("classRoomId");

		if (classRoomId != null) {
			setClassRoomId(classRoomId);
		}

		Long subjectId = (Long)attributes.get("subjectId");

		if (subjectId != null) {
			setSubjectId(subjectId);
		}

		Long countryId = (Long)attributes.get("countryId");

		if (countryId != null) {
			setCountryId(countryId);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long assessmentTestId = (Long)attributes.get("assessmentTestId");

		if (assessmentTestId != null) {
			setAssessmentTestId(assessmentTestId);
		}

		Date createDate = (Date)attributes.get("createDate");

		if (createDate != null) {
			setCreateDate(createDate);
		}

		Date requestedDate = (Date)attributes.get("requestedDate");

		if (requestedDate != null) {
			setRequestedDate(requestedDate);
		}

		String description = (String)attributes.get("description");

		if (description != null) {
			setDescription(description);
		}

		Boolean active = (Boolean)attributes.get("active");

		if (active != null) {
			setActive(active);
		}

		Integer evalTypeId = (Integer)attributes.get("evalTypeId");

		if (evalTypeId != null) {
			setEvalTypeId(evalTypeId);
		}

		String title = (String)attributes.get("title");

		if (title != null) {
			setTitle(title);
		}
	}

	@JSON
	public long getI_Id() {
		return _I_Id;
	}

	public void setI_Id(long I_Id) {
		_I_Id = I_Id;
	}

	@JSON
	public long getClassRoomId() {
		return _classRoomId;
	}

	public void setClassRoomId(long classRoomId) {
		_columnBitmask = -1L;

		if (!_setOriginalClassRoomId) {
			_setOriginalClassRoomId = true;

			_originalClassRoomId = _classRoomId;
		}

		_classRoomId = classRoomId;
	}

	public long getOriginalClassRoomId() {
		return _originalClassRoomId;
	}

	@JSON
	public long getSubjectId() {
		return _subjectId;
	}

	public void setSubjectId(long subjectId) {
		_subjectId = subjectId;
	}

	@JSON
	public long getCountryId() {
		return _countryId;
	}

	public void setCountryId(long countryId) {
		_countryId = countryId;
	}

	@JSON
	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	@JSON
	public long getAssessmentTestId() {
		return _assessmentTestId;
	}

	public void setAssessmentTestId(long assessmentTestId) {
		_columnBitmask |= ASSESSMENTTESTID_COLUMN_BITMASK;

		if (!_setOriginalAssessmentTestId) {
			_setOriginalAssessmentTestId = true;

			_originalAssessmentTestId = _assessmentTestId;
		}

		_assessmentTestId = assessmentTestId;
	}

	public long getOriginalAssessmentTestId() {
		return _originalAssessmentTestId;
	}

	@JSON
	public Date getCreateDate() {
		return _createDate;
	}

	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	@JSON
	public Date getRequestedDate() {
		return _requestedDate;
	}

	public void setRequestedDate(Date requestedDate) {
		_requestedDate = requestedDate;
	}

	@JSON
	public String getDescription() {
		if (_description == null) {
			return StringPool.BLANK;
		}
		else {
			return _description;
		}
	}

	public void setDescription(String description) {
		_description = description;
	}

	@JSON
	public boolean getActive() {
		return _active;
	}

	public boolean isActive() {
		return _active;
	}

	public void setActive(boolean active) {
		_active = active;
	}

	@JSON
	public int getEvalTypeId() {
		return _evalTypeId;
	}

	public void setEvalTypeId(int evalTypeId) {
		_evalTypeId = evalTypeId;
	}

	@JSON
	public String getTitle() {
		if (_title == null) {
			return StringPool.BLANK;
		}
		else {
			return _title;
		}
	}

	public void setTitle(String title) {
		_title = title;
	}

	public long getColumnBitmask() {
		return _columnBitmask;
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
			Uol.class.getName(), getPrimaryKey());
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		ExpandoBridge expandoBridge = getExpandoBridge();

		expandoBridge.setAttributes(serviceContext);
	}

	@Override
	public Uol toEscapedModel() {
		if (_escapedModelProxy == null) {
			_escapedModelProxy = (Uol)ProxyUtil.newProxyInstance(_classLoader,
					_escapedModelProxyInterfaces,
					new AutoEscapeBeanHandler(this));
		}

		return _escapedModelProxy;
	}

	@Override
	public Object clone() {
		UolImpl uolImpl = new UolImpl();

		uolImpl.setI_Id(getI_Id());
		uolImpl.setClassRoomId(getClassRoomId());
		uolImpl.setSubjectId(getSubjectId());
		uolImpl.setCountryId(getCountryId());
		uolImpl.setCompanyId(getCompanyId());
		uolImpl.setAssessmentTestId(getAssessmentTestId());
		uolImpl.setCreateDate(getCreateDate());
		uolImpl.setRequestedDate(getRequestedDate());
		uolImpl.setDescription(getDescription());
		uolImpl.setActive(getActive());
		uolImpl.setEvalTypeId(getEvalTypeId());
		uolImpl.setTitle(getTitle());

		uolImpl.resetOriginalValues();

		return uolImpl;
	}

	public int compareTo(Uol uol) {
		int value = 0;

		if (getClassRoomId() < uol.getClassRoomId()) {
			value = -1;
		}
		else if (getClassRoomId() > uol.getClassRoomId()) {
			value = 1;
		}
		else {
			value = 0;
		}

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		Uol uol = null;

		try {
			uol = (Uol)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long primaryKey = uol.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public void resetOriginalValues() {
		UolModelImpl uolModelImpl = this;

		uolModelImpl._originalClassRoomId = uolModelImpl._classRoomId;

		uolModelImpl._setOriginalClassRoomId = false;

		uolModelImpl._originalAssessmentTestId = uolModelImpl._assessmentTestId;

		uolModelImpl._setOriginalAssessmentTestId = false;

		uolModelImpl._columnBitmask = 0;
	}

	@Override
	public CacheModel<Uol> toCacheModel() {
		UolCacheModel uolCacheModel = new UolCacheModel();

		uolCacheModel.I_Id = getI_Id();

		uolCacheModel.classRoomId = getClassRoomId();

		uolCacheModel.subjectId = getSubjectId();

		uolCacheModel.countryId = getCountryId();

		uolCacheModel.companyId = getCompanyId();

		uolCacheModel.assessmentTestId = getAssessmentTestId();

		Date createDate = getCreateDate();

		if (createDate != null) {
			uolCacheModel.createDate = createDate.getTime();
		}
		else {
			uolCacheModel.createDate = Long.MIN_VALUE;
		}

		Date requestedDate = getRequestedDate();

		if (requestedDate != null) {
			uolCacheModel.requestedDate = requestedDate.getTime();
		}
		else {
			uolCacheModel.requestedDate = Long.MIN_VALUE;
		}

		uolCacheModel.description = getDescription();

		String description = uolCacheModel.description;

		if ((description != null) && (description.length() == 0)) {
			uolCacheModel.description = null;
		}

		uolCacheModel.active = getActive();

		uolCacheModel.evalTypeId = getEvalTypeId();

		uolCacheModel.title = getTitle();

		String title = uolCacheModel.title;

		if ((title != null) && (title.length() == 0)) {
			uolCacheModel.title = null;
		}

		return uolCacheModel;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(25);

		sb.append("{I_Id=");
		sb.append(getI_Id());
		sb.append(", classRoomId=");
		sb.append(getClassRoomId());
		sb.append(", subjectId=");
		sb.append(getSubjectId());
		sb.append(", countryId=");
		sb.append(getCountryId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", assessmentTestId=");
		sb.append(getAssessmentTestId());
		sb.append(", createDate=");
		sb.append(getCreateDate());
		sb.append(", requestedDate=");
		sb.append(getRequestedDate());
		sb.append(", description=");
		sb.append(getDescription());
		sb.append(", active=");
		sb.append(getActive());
		sb.append(", evalTypeId=");
		sb.append(getEvalTypeId());
		sb.append(", title=");
		sb.append(getTitle());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(40);

		sb.append("<model><model-name>");
		sb.append("com.qti.slayer.model.Uol");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>I_Id</column-name><column-value><![CDATA[");
		sb.append(getI_Id());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>classRoomId</column-name><column-value><![CDATA[");
		sb.append(getClassRoomId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>subjectId</column-name><column-value><![CDATA[");
		sb.append(getSubjectId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>countryId</column-name><column-value><![CDATA[");
		sb.append(getCountryId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>assessmentTestId</column-name><column-value><![CDATA[");
		sb.append(getAssessmentTestId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>createDate</column-name><column-value><![CDATA[");
		sb.append(getCreateDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>requestedDate</column-name><column-value><![CDATA[");
		sb.append(getRequestedDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>description</column-name><column-value><![CDATA[");
		sb.append(getDescription());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>active</column-name><column-value><![CDATA[");
		sb.append(getActive());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>evalTypeId</column-name><column-value><![CDATA[");
		sb.append(getEvalTypeId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>title</column-name><column-value><![CDATA[");
		sb.append(getTitle());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private static ClassLoader _classLoader = Uol.class.getClassLoader();
	private static Class<?>[] _escapedModelProxyInterfaces = new Class[] {
			Uol.class
		};
	private long _I_Id;
	private long _classRoomId;
	private long _originalClassRoomId;
	private boolean _setOriginalClassRoomId;
	private long _subjectId;
	private long _countryId;
	private long _companyId;
	private long _assessmentTestId;
	private long _originalAssessmentTestId;
	private boolean _setOriginalAssessmentTestId;
	private Date _createDate;
	private Date _requestedDate;
	private String _description;
	private boolean _active;
	private int _evalTypeId;
	private String _title;
	private long _columnBitmask;
	private Uol _escapedModelProxy;
}