/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service.impl;

import com.qti.slayer.model.TestResult;
import com.qti.slayer.service.base.TestResultLocalServiceBaseImpl;
import com.qti.slayer.service.persistence.TestResultPK;

/**
 * The implementation of the test result local service.
 *
 * <p>
 * All custom service methods should be put in this class. Whenever methods are added, rerun ServiceBuilder to copy their definitions into the {@link com.qti.slayer.service.TestResultLocalService} interface.
 *
 * <p>
 * This is a local service. Methods of this service will not have security checks based on the propagated JAAS credentials because this service can only be accessed from within the same VM.
 * </p>
 *
 * @author Hector
 * @see com.qti.slayer.service.base.TestResultLocalServiceBaseImpl
 * @see com.qti.slayer.service.TestResultLocalServiceUtil
 */
public class TestResultLocalServiceImpl extends TestResultLocalServiceBaseImpl {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never reference this interface directly. Always use {@link com.qti.slayer.service.TestResultLocalServiceUtil} to access the test result local service.
	 */
	
	/**
	* Creates a new test result with the primary key. Does not add the test result to the database.
	*
	* @param uolIdStr uolId primary key for the new test result
	* @param userIdStr userId primary keys for the new test result
	* @return the new test result
	*/
	public TestResult getTestResult(String uolIdStr, String userIdStr)
	{
		long uolId = Long.parseLong(uolIdStr);
		long userId = Long.parseLong(userIdStr);
		TestResultPK pk = new TestResultPK(userId,uolId);
		return createTestResult(pk);
	}

	/*
	@Override
	public TestResult getTestResult(long uolId, long userId) {
		// TODO Auto-generated method stub
		TestResultPK pk = new TestResultPK(uolId, userId);
		return createTestResult(pk);
	}
	*/
}