/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service.persistence;

import com.liferay.portal.NoSuchModelException;
import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryPos;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PropsKeys;
import com.liferay.portal.kernel.util.PropsUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.service.persistence.BatchSessionUtil;
import com.liferay.portal.service.persistence.ResourcePersistence;
import com.liferay.portal.service.persistence.UserPersistence;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import com.qti.slayer.NoSuchAssignmentException;
import com.qti.slayer.model.Assignment;
import com.qti.slayer.model.impl.AssignmentImpl;
import com.qti.slayer.model.impl.AssignmentModelImpl;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * The persistence implementation for the assignment service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Hector
 * @see AssignmentPersistence
 * @see AssignmentUtil
 * @generated
 */
public class AssignmentPersistenceImpl extends BasePersistenceImpl<Assignment>
	implements AssignmentPersistence {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link AssignmentUtil} to access the assignment persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */
	public static final String FINDER_CLASS_NAME_ENTITY = AssignmentImpl.class.getName();
	public static final String FINDER_CLASS_NAME_LIST_WITH_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List1";
	public static final String FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List2";
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_USERID = new FinderPath(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
			AssignmentModelImpl.FINDER_CACHE_ENABLED, AssignmentImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByUserId",
			new String[] {
				Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_USERID =
		new FinderPath(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
			AssignmentModelImpl.FINDER_CACHE_ENABLED, AssignmentImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByUserId",
			new String[] { Long.class.getName() },
			AssignmentModelImpl.USERID_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_USERID = new FinderPath(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
			AssignmentModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByUserId",
			new String[] { Long.class.getName() });
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_ALL = new FinderPath(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
			AssignmentModelImpl.FINDER_CACHE_ENABLED, AssignmentImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL = new FinderPath(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
			AssignmentModelImpl.FINDER_CACHE_ENABLED, AssignmentImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
			AssignmentModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countAll", new String[0]);

	/**
	 * Caches the assignment in the entity cache if it is enabled.
	 *
	 * @param assignment the assignment
	 */
	public void cacheResult(Assignment assignment) {
		EntityCacheUtil.putResult(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
			AssignmentImpl.class, assignment.getPrimaryKey(), assignment);

		assignment.resetOriginalValues();
	}

	/**
	 * Caches the assignments in the entity cache if it is enabled.
	 *
	 * @param assignments the assignments
	 */
	public void cacheResult(List<Assignment> assignments) {
		for (Assignment assignment : assignments) {
			if (EntityCacheUtil.getResult(
						AssignmentModelImpl.ENTITY_CACHE_ENABLED,
						AssignmentImpl.class, assignment.getPrimaryKey()) == null) {
				cacheResult(assignment);
			}
			else {
				assignment.resetOriginalValues();
			}
		}
	}

	/**
	 * Clears the cache for all assignments.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache() {
		if (_HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE) {
			CacheRegistryUtil.clear(AssignmentImpl.class.getName());
		}

		EntityCacheUtil.clearCache(AssignmentImpl.class.getName());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	/**
	 * Clears the cache for the assignment.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache(Assignment assignment) {
		EntityCacheUtil.removeResult(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
			AssignmentImpl.class, assignment.getPrimaryKey());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	@Override
	public void clearCache(List<Assignment> assignments) {
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

		for (Assignment assignment : assignments) {
			EntityCacheUtil.removeResult(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
				AssignmentImpl.class, assignment.getPrimaryKey());
		}
	}

	/**
	 * Creates a new assignment with the primary key. Does not add the assignment to the database.
	 *
	 * @param assignmentPK the primary key for the new assignment
	 * @return the new assignment
	 */
	public Assignment create(AssignmentPK assignmentPK) {
		Assignment assignment = new AssignmentImpl();

		assignment.setNew(true);
		assignment.setPrimaryKey(assignmentPK);

		return assignment;
	}

	/**
	 * Removes the assignment with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param assignmentPK the primary key of the assignment
	 * @return the assignment that was removed
	 * @throws com.qti.slayer.NoSuchAssignmentException if a assignment with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Assignment remove(AssignmentPK assignmentPK)
		throws NoSuchAssignmentException, SystemException {
		return remove((Serializable)assignmentPK);
	}

	/**
	 * Removes the assignment with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param primaryKey the primary key of the assignment
	 * @return the assignment that was removed
	 * @throws com.qti.slayer.NoSuchAssignmentException if a assignment with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Assignment remove(Serializable primaryKey)
		throws NoSuchAssignmentException, SystemException {
		Session session = null;

		try {
			session = openSession();

			Assignment assignment = (Assignment)session.get(AssignmentImpl.class,
					primaryKey);

			if (assignment == null) {
				if (_log.isWarnEnabled()) {
					_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
				}

				throw new NoSuchAssignmentException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
					primaryKey);
			}

			return remove(assignment);
		}
		catch (NoSuchAssignmentException nsee) {
			throw nsee;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	@Override
	protected Assignment removeImpl(Assignment assignment)
		throws SystemException {
		assignment = toUnwrappedModel(assignment);

		Session session = null;

		try {
			session = openSession();

			BatchSessionUtil.delete(session, assignment);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		clearCache(assignment);

		return assignment;
	}

	@Override
	public Assignment updateImpl(com.qti.slayer.model.Assignment assignment,
		boolean merge) throws SystemException {
		assignment = toUnwrappedModel(assignment);

		boolean isNew = assignment.isNew();

		AssignmentModelImpl assignmentModelImpl = (AssignmentModelImpl)assignment;

		Session session = null;

		try {
			session = openSession();

			BatchSessionUtil.update(session, assignment, merge);

			assignment.setNew(false);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);

		if (isNew || !AssignmentModelImpl.COLUMN_BITMASK_ENABLED) {
			FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
		}

		else {
			if ((assignmentModelImpl.getColumnBitmask() &
					FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_USERID.getColumnBitmask()) != 0) {
				Object[] args = new Object[] {
						Long.valueOf(assignmentModelImpl.getOriginalUserId())
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_USERID, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_USERID,
					args);

				args = new Object[] {
						Long.valueOf(assignmentModelImpl.getUserId())
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_USERID, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_USERID,
					args);
			}
		}

		EntityCacheUtil.putResult(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
			AssignmentImpl.class, assignment.getPrimaryKey(), assignment);

		return assignment;
	}

	protected Assignment toUnwrappedModel(Assignment assignment) {
		if (assignment instanceof AssignmentImpl) {
			return assignment;
		}

		AssignmentImpl assignmentImpl = new AssignmentImpl();

		assignmentImpl.setNew(assignment.isNew());
		assignmentImpl.setPrimaryKey(assignment.getPrimaryKey());

		assignmentImpl.setUserId(assignment.getUserId());
		assignmentImpl.setUolId(assignment.getUolId());
		assignmentImpl.setStatus(assignment.getStatus());
		assignmentImpl.setUoltype(assignment.getUoltype());
		assignmentImpl.setTitle(assignment.getTitle());
		assignmentImpl.setUsername(assignment.getUsername());

		return assignmentImpl;
	}

	/**
	 * Returns the assignment with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
	 *
	 * @param primaryKey the primary key of the assignment
	 * @return the assignment
	 * @throws com.liferay.portal.NoSuchModelException if a assignment with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Assignment findByPrimaryKey(Serializable primaryKey)
		throws NoSuchModelException, SystemException {
		return findByPrimaryKey((AssignmentPK)primaryKey);
	}

	/**
	 * Returns the assignment with the primary key or throws a {@link com.qti.slayer.NoSuchAssignmentException} if it could not be found.
	 *
	 * @param assignmentPK the primary key of the assignment
	 * @return the assignment
	 * @throws com.qti.slayer.NoSuchAssignmentException if a assignment with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Assignment findByPrimaryKey(AssignmentPK assignmentPK)
		throws NoSuchAssignmentException, SystemException {
		Assignment assignment = fetchByPrimaryKey(assignmentPK);

		if (assignment == null) {
			if (_log.isWarnEnabled()) {
				_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + assignmentPK);
			}

			throw new NoSuchAssignmentException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
				assignmentPK);
		}

		return assignment;
	}

	/**
	 * Returns the assignment with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param primaryKey the primary key of the assignment
	 * @return the assignment, or <code>null</code> if a assignment with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Assignment fetchByPrimaryKey(Serializable primaryKey)
		throws SystemException {
		return fetchByPrimaryKey((AssignmentPK)primaryKey);
	}

	/**
	 * Returns the assignment with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param assignmentPK the primary key of the assignment
	 * @return the assignment, or <code>null</code> if a assignment with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Assignment fetchByPrimaryKey(AssignmentPK assignmentPK)
		throws SystemException {
		Assignment assignment = (Assignment)EntityCacheUtil.getResult(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
				AssignmentImpl.class, assignmentPK);

		if (assignment == _nullAssignment) {
			return null;
		}

		if (assignment == null) {
			Session session = null;

			boolean hasException = false;

			try {
				session = openSession();

				assignment = (Assignment)session.get(AssignmentImpl.class,
						assignmentPK);
			}
			catch (Exception e) {
				hasException = true;

				throw processException(e);
			}
			finally {
				if (assignment != null) {
					cacheResult(assignment);
				}
				else if (!hasException) {
					EntityCacheUtil.putResult(AssignmentModelImpl.ENTITY_CACHE_ENABLED,
						AssignmentImpl.class, assignmentPK, _nullAssignment);
				}

				closeSession(session);
			}
		}

		return assignment;
	}

	/**
	 * Returns all the assignments where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @return the matching assignments
	 * @throws SystemException if a system exception occurred
	 */
	public List<Assignment> findByUserId(long userId) throws SystemException {
		return findByUserId(userId, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the assignments where userId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user ID
	 * @param start the lower bound of the range of assignments
	 * @param end the upper bound of the range of assignments (not inclusive)
	 * @return the range of matching assignments
	 * @throws SystemException if a system exception occurred
	 */
	public List<Assignment> findByUserId(long userId, int start, int end)
		throws SystemException {
		return findByUserId(userId, start, end, null);
	}

	/**
	 * Returns an ordered range of all the assignments where userId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user ID
	 * @param start the lower bound of the range of assignments
	 * @param end the upper bound of the range of assignments (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching assignments
	 * @throws SystemException if a system exception occurred
	 */
	public List<Assignment> findByUserId(long userId, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_USERID;
			finderArgs = new Object[] { userId };
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_USERID;
			finderArgs = new Object[] { userId, start, end, orderByComparator };
		}

		List<Assignment> list = (List<Assignment>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if ((list != null) && !list.isEmpty()) {
			for (Assignment assignment : list) {
				if ((userId != assignment.getUserId())) {
					list = null;

					break;
				}
			}
		}

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(3);
			}

			query.append(_SQL_SELECT_ASSIGNMENT_WHERE);

			query.append(_FINDER_COLUMN_USERID_USERID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			else {
				query.append(AssignmentModelImpl.ORDER_BY_JPQL);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(userId);

				list = (List<Assignment>)QueryUtil.list(q, getDialect(), start,
						end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(finderPath, finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(finderPath, finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Returns the first assignment in the ordered set where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching assignment
	 * @throws com.qti.slayer.NoSuchAssignmentException if a matching assignment could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Assignment findByUserId_First(long userId,
		OrderByComparator orderByComparator)
		throws NoSuchAssignmentException, SystemException {
		Assignment assignment = fetchByUserId_First(userId, orderByComparator);

		if (assignment != null) {
			return assignment;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("userId=");
		msg.append(userId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchAssignmentException(msg.toString());
	}

	/**
	 * Returns the first assignment in the ordered set where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching assignment, or <code>null</code> if a matching assignment could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Assignment fetchByUserId_First(long userId,
		OrderByComparator orderByComparator) throws SystemException {
		List<Assignment> list = findByUserId(userId, 0, 1, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the last assignment in the ordered set where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching assignment
	 * @throws com.qti.slayer.NoSuchAssignmentException if a matching assignment could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Assignment findByUserId_Last(long userId,
		OrderByComparator orderByComparator)
		throws NoSuchAssignmentException, SystemException {
		Assignment assignment = fetchByUserId_Last(userId, orderByComparator);

		if (assignment != null) {
			return assignment;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("userId=");
		msg.append(userId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchAssignmentException(msg.toString());
	}

	/**
	 * Returns the last assignment in the ordered set where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching assignment, or <code>null</code> if a matching assignment could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Assignment fetchByUserId_Last(long userId,
		OrderByComparator orderByComparator) throws SystemException {
		int count = countByUserId(userId);

		List<Assignment> list = findByUserId(userId, count - 1, count,
				orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the assignments before and after the current assignment in the ordered set where userId = &#63;.
	 *
	 * @param assignmentPK the primary key of the current assignment
	 * @param userId the user ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the previous, current, and next assignment
	 * @throws com.qti.slayer.NoSuchAssignmentException if a assignment with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Assignment[] findByUserId_PrevAndNext(AssignmentPK assignmentPK,
		long userId, OrderByComparator orderByComparator)
		throws NoSuchAssignmentException, SystemException {
		Assignment assignment = findByPrimaryKey(assignmentPK);

		Session session = null;

		try {
			session = openSession();

			Assignment[] array = new AssignmentImpl[3];

			array[0] = getByUserId_PrevAndNext(session, assignment, userId,
					orderByComparator, true);

			array[1] = assignment;

			array[2] = getByUserId_PrevAndNext(session, assignment, userId,
					orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected Assignment getByUserId_PrevAndNext(Session session,
		Assignment assignment, long userId,
		OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_ASSIGNMENT_WHERE);

		query.append(_FINDER_COLUMN_USERID_USERID_2);

		if (orderByComparator != null) {
			String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

			if (orderByConditionFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByConditionFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByConditionFields[i]);

				if ((i + 1) < orderByConditionFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			String[] orderByFields = orderByComparator.getOrderByFields();

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		else {
			query.append(AssignmentModelImpl.ORDER_BY_JPQL);
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(userId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByConditionValues(assignment);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<Assignment> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Returns all the assignments.
	 *
	 * @return the assignments
	 * @throws SystemException if a system exception occurred
	 */
	public List<Assignment> findAll() throws SystemException {
		return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the assignments.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of assignments
	 * @param end the upper bound of the range of assignments (not inclusive)
	 * @return the range of assignments
	 * @throws SystemException if a system exception occurred
	 */
	public List<Assignment> findAll(int start, int end)
		throws SystemException {
		return findAll(start, end, null);
	}

	/**
	 * Returns an ordered range of all the assignments.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of assignments
	 * @param end the upper bound of the range of assignments (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of assignments
	 * @throws SystemException if a system exception occurred
	 */
	public List<Assignment> findAll(int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		FinderPath finderPath = null;
		Object[] finderArgs = new Object[] { start, end, orderByComparator };

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL;
			finderArgs = FINDER_ARGS_EMPTY;
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_ALL;
			finderArgs = new Object[] { start, end, orderByComparator };
		}

		List<Assignment> list = (List<Assignment>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;
			String sql = null;

			if (orderByComparator != null) {
				query = new StringBundler(2 +
						(orderByComparator.getOrderByFields().length * 3));

				query.append(_SQL_SELECT_ASSIGNMENT);

				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);

				sql = query.toString();
			}
			else {
				sql = _SQL_SELECT_ASSIGNMENT.concat(AssignmentModelImpl.ORDER_BY_JPQL);
			}

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				if (orderByComparator == null) {
					list = (List<Assignment>)QueryUtil.list(q, getDialect(),
							start, end, false);

					Collections.sort(list);
				}
				else {
					list = (List<Assignment>)QueryUtil.list(q, getDialect(),
							start, end);
				}
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(finderPath, finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(finderPath, finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Removes all the assignments where userId = &#63; from the database.
	 *
	 * @param userId the user ID
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByUserId(long userId) throws SystemException {
		for (Assignment assignment : findByUserId(userId)) {
			remove(assignment);
		}
	}

	/**
	 * Removes all the assignments from the database.
	 *
	 * @throws SystemException if a system exception occurred
	 */
	public void removeAll() throws SystemException {
		for (Assignment assignment : findAll()) {
			remove(assignment);
		}
	}

	/**
	 * Returns the number of assignments where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @return the number of matching assignments
	 * @throws SystemException if a system exception occurred
	 */
	public int countByUserId(long userId) throws SystemException {
		Object[] finderArgs = new Object[] { userId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_USERID,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_ASSIGNMENT_WHERE);

			query.append(_FINDER_COLUMN_USERID_USERID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(userId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_USERID,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Returns the number of assignments.
	 *
	 * @return the number of assignments
	 * @throws SystemException if a system exception occurred
	 */
	public int countAll() throws SystemException {
		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
				FINDER_ARGS_EMPTY, this);

		if (count == null) {
			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(_SQL_COUNT_ASSIGNMENT);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL,
					FINDER_ARGS_EMPTY, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Initializes the assignment persistence.
	 */
	public void afterPropertiesSet() {
		String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
					com.liferay.util.service.ServiceProps.get(
						"value.object.listener.com.qti.slayer.model.Assignment")));

		if (listenerClassNames.length > 0) {
			try {
				List<ModelListener<Assignment>> listenersList = new ArrayList<ModelListener<Assignment>>();

				for (String listenerClassName : listenerClassNames) {
					listenersList.add((ModelListener<Assignment>)InstanceFactory.newInstance(
							listenerClassName));
				}

				listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
			}
			catch (Exception e) {
				_log.error(e);
			}
		}
	}

	public void destroy() {
		EntityCacheUtil.removeCache(AssignmentImpl.class.getName());
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	@BeanReference(type = AssignmentPersistence.class)
	protected AssignmentPersistence assignmentPersistence;
	@BeanReference(type = TestResultPersistence.class)
	protected TestResultPersistence testResultPersistence;
	@BeanReference(type = UolPersistence.class)
	protected UolPersistence uolPersistence;
	@BeanReference(type = ResourcePersistence.class)
	protected ResourcePersistence resourcePersistence;
	@BeanReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
	private static final String _SQL_SELECT_ASSIGNMENT = "SELECT assignment FROM Assignment assignment";
	private static final String _SQL_SELECT_ASSIGNMENT_WHERE = "SELECT assignment FROM Assignment assignment WHERE ";
	private static final String _SQL_COUNT_ASSIGNMENT = "SELECT COUNT(assignment) FROM Assignment assignment";
	private static final String _SQL_COUNT_ASSIGNMENT_WHERE = "SELECT COUNT(assignment) FROM Assignment assignment WHERE ";
	private static final String _FINDER_COLUMN_USERID_USERID_2 = "assignment.id.userId = ?";
	private static final String _ORDER_BY_ENTITY_ALIAS = "assignment.";
	private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No Assignment exists with the primary key ";
	private static final String _NO_SUCH_ENTITY_WITH_KEY = "No Assignment exists with the key {";
	private static final boolean _HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE = GetterUtil.getBoolean(PropsUtil.get(
				PropsKeys.HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE));
	private static Log _log = LogFactoryUtil.getLog(AssignmentPersistenceImpl.class);
	private static Assignment _nullAssignment = new AssignmentImpl() {
			@Override
			public Object clone() {
				return this;
			}

			@Override
			public CacheModel<Assignment> toCacheModel() {
				return _nullAssignmentCacheModel;
			}
		};

	private static CacheModel<Assignment> _nullAssignmentCacheModel = new CacheModel<Assignment>() {
			public Assignment toEntityModel() {
				return _nullAssignment;
			}
		};
}