/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service.persistence;

import com.liferay.portal.NoSuchModelException;
import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryPos;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PropsKeys;
import com.liferay.portal.kernel.util.PropsUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.service.persistence.BatchSessionUtil;
import com.liferay.portal.service.persistence.ResourcePersistence;
import com.liferay.portal.service.persistence.UserPersistence;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import com.qti.slayer.NoSuchTestResultException;
import com.qti.slayer.model.TestResult;
import com.qti.slayer.model.impl.TestResultImpl;
import com.qti.slayer.model.impl.TestResultModelImpl;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * The persistence implementation for the test result service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Hector
 * @see TestResultPersistence
 * @see TestResultUtil
 * @generated
 */
public class TestResultPersistenceImpl extends BasePersistenceImpl<TestResult>
	implements TestResultPersistence {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link TestResultUtil} to access the test result persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */
	public static final String FINDER_CLASS_NAME_ENTITY = TestResultImpl.class.getName();
	public static final String FINDER_CLASS_NAME_LIST_WITH_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List1";
	public static final String FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List2";
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_USERID = new FinderPath(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultModelImpl.FINDER_CACHE_ENABLED, TestResultImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByUserId",
			new String[] {
				Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_USERID =
		new FinderPath(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultModelImpl.FINDER_CACHE_ENABLED, TestResultImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByUserId",
			new String[] { Long.class.getName() },
			TestResultModelImpl.USERID_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_USERID = new FinderPath(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByUserId",
			new String[] { Long.class.getName() });
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_UOLID = new FinderPath(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultModelImpl.FINDER_CACHE_ENABLED, TestResultImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByUolId",
			new String[] {
				Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UOLID = new FinderPath(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultModelImpl.FINDER_CACHE_ENABLED, TestResultImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByUolId",
			new String[] { Long.class.getName() },
			TestResultModelImpl.UOLID_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_UOLID = new FinderPath(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByUolId",
			new String[] { Long.class.getName() });
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_ALL = new FinderPath(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultModelImpl.FINDER_CACHE_ENABLED, TestResultImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL = new FinderPath(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultModelImpl.FINDER_CACHE_ENABLED, TestResultImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countAll", new String[0]);

	/**
	 * Caches the test result in the entity cache if it is enabled.
	 *
	 * @param testResult the test result
	 */
	public void cacheResult(TestResult testResult) {
		EntityCacheUtil.putResult(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultImpl.class, testResult.getPrimaryKey(), testResult);

		testResult.resetOriginalValues();
	}

	/**
	 * Caches the test results in the entity cache if it is enabled.
	 *
	 * @param testResults the test results
	 */
	public void cacheResult(List<TestResult> testResults) {
		for (TestResult testResult : testResults) {
			if (EntityCacheUtil.getResult(
						TestResultModelImpl.ENTITY_CACHE_ENABLED,
						TestResultImpl.class, testResult.getPrimaryKey()) == null) {
				cacheResult(testResult);
			}
			else {
				testResult.resetOriginalValues();
			}
		}
	}

	/**
	 * Clears the cache for all test results.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache() {
		if (_HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE) {
			CacheRegistryUtil.clear(TestResultImpl.class.getName());
		}

		EntityCacheUtil.clearCache(TestResultImpl.class.getName());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	/**
	 * Clears the cache for the test result.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache(TestResult testResult) {
		EntityCacheUtil.removeResult(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultImpl.class, testResult.getPrimaryKey());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	@Override
	public void clearCache(List<TestResult> testResults) {
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

		for (TestResult testResult : testResults) {
			EntityCacheUtil.removeResult(TestResultModelImpl.ENTITY_CACHE_ENABLED,
				TestResultImpl.class, testResult.getPrimaryKey());
		}
	}

	/**
	 * Creates a new test result with the primary key. Does not add the test result to the database.
	 *
	 * @param testResultPK the primary key for the new test result
	 * @return the new test result
	 */
	public TestResult create(TestResultPK testResultPK) {
		TestResult testResult = new TestResultImpl();

		testResult.setNew(true);
		testResult.setPrimaryKey(testResultPK);

		return testResult;
	}

	/**
	 * Removes the test result with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param testResultPK the primary key of the test result
	 * @return the test result that was removed
	 * @throws com.qti.slayer.NoSuchTestResultException if a test result with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult remove(TestResultPK testResultPK)
		throws NoSuchTestResultException, SystemException {
		return remove((Serializable)testResultPK);
	}

	/**
	 * Removes the test result with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param primaryKey the primary key of the test result
	 * @return the test result that was removed
	 * @throws com.qti.slayer.NoSuchTestResultException if a test result with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public TestResult remove(Serializable primaryKey)
		throws NoSuchTestResultException, SystemException {
		Session session = null;

		try {
			session = openSession();

			TestResult testResult = (TestResult)session.get(TestResultImpl.class,
					primaryKey);

			if (testResult == null) {
				if (_log.isWarnEnabled()) {
					_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
				}

				throw new NoSuchTestResultException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
					primaryKey);
			}

			return remove(testResult);
		}
		catch (NoSuchTestResultException nsee) {
			throw nsee;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	@Override
	protected TestResult removeImpl(TestResult testResult)
		throws SystemException {
		testResult = toUnwrappedModel(testResult);

		Session session = null;

		try {
			session = openSession();

			BatchSessionUtil.delete(session, testResult);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		clearCache(testResult);

		return testResult;
	}

	@Override
	public TestResult updateImpl(com.qti.slayer.model.TestResult testResult,
		boolean merge) throws SystemException {
		testResult = toUnwrappedModel(testResult);

		boolean isNew = testResult.isNew();

		TestResultModelImpl testResultModelImpl = (TestResultModelImpl)testResult;

		Session session = null;

		try {
			session = openSession();

			BatchSessionUtil.update(session, testResult, merge);

			testResult.setNew(false);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);

		if (isNew || !TestResultModelImpl.COLUMN_BITMASK_ENABLED) {
			FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
		}

		else {
			if ((testResultModelImpl.getColumnBitmask() &
					FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_USERID.getColumnBitmask()) != 0) {
				Object[] args = new Object[] {
						Long.valueOf(testResultModelImpl.getOriginalUserId())
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_USERID, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_USERID,
					args);

				args = new Object[] {
						Long.valueOf(testResultModelImpl.getUserId())
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_USERID, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_USERID,
					args);
			}

			if ((testResultModelImpl.getColumnBitmask() &
					FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UOLID.getColumnBitmask()) != 0) {
				Object[] args = new Object[] {
						Long.valueOf(testResultModelImpl.getOriginalUolId())
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UOLID, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UOLID,
					args);

				args = new Object[] { Long.valueOf(testResultModelImpl.getUolId()) };

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UOLID, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UOLID,
					args);
			}
		}

		EntityCacheUtil.putResult(TestResultModelImpl.ENTITY_CACHE_ENABLED,
			TestResultImpl.class, testResult.getPrimaryKey(), testResult);

		return testResult;
	}

	protected TestResult toUnwrappedModel(TestResult testResult) {
		if (testResult instanceof TestResultImpl) {
			return testResult;
		}

		TestResultImpl testResultImpl = new TestResultImpl();

		testResultImpl.setNew(testResult.isNew());
		testResultImpl.setPrimaryKey(testResult.getPrimaryKey());

		testResultImpl.setUserId(testResult.getUserId());
		testResultImpl.setUolId(testResult.getUolId());
		testResultImpl.setResult(testResult.getResult());
		testResultImpl.setAutoComment(testResult.getAutoComment());
		testResultImpl.setTeacherComment(testResult.getTeacherComment());
		testResultImpl.setTitle(testResult.getTitle());
		testResultImpl.setUsername(testResult.getUsername());

		return testResultImpl;
	}

	/**
	 * Returns the test result with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
	 *
	 * @param primaryKey the primary key of the test result
	 * @return the test result
	 * @throws com.liferay.portal.NoSuchModelException if a test result with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public TestResult findByPrimaryKey(Serializable primaryKey)
		throws NoSuchModelException, SystemException {
		return findByPrimaryKey((TestResultPK)primaryKey);
	}

	/**
	 * Returns the test result with the primary key or throws a {@link com.qti.slayer.NoSuchTestResultException} if it could not be found.
	 *
	 * @param testResultPK the primary key of the test result
	 * @return the test result
	 * @throws com.qti.slayer.NoSuchTestResultException if a test result with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult findByPrimaryKey(TestResultPK testResultPK)
		throws NoSuchTestResultException, SystemException {
		TestResult testResult = fetchByPrimaryKey(testResultPK);

		if (testResult == null) {
			if (_log.isWarnEnabled()) {
				_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + testResultPK);
			}

			throw new NoSuchTestResultException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
				testResultPK);
		}

		return testResult;
	}

	/**
	 * Returns the test result with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param primaryKey the primary key of the test result
	 * @return the test result, or <code>null</code> if a test result with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public TestResult fetchByPrimaryKey(Serializable primaryKey)
		throws SystemException {
		return fetchByPrimaryKey((TestResultPK)primaryKey);
	}

	/**
	 * Returns the test result with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param testResultPK the primary key of the test result
	 * @return the test result, or <code>null</code> if a test result with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult fetchByPrimaryKey(TestResultPK testResultPK)
		throws SystemException {
		TestResult testResult = (TestResult)EntityCacheUtil.getResult(TestResultModelImpl.ENTITY_CACHE_ENABLED,
				TestResultImpl.class, testResultPK);

		if (testResult == _nullTestResult) {
			return null;
		}

		if (testResult == null) {
			Session session = null;

			boolean hasException = false;

			try {
				session = openSession();

				testResult = (TestResult)session.get(TestResultImpl.class,
						testResultPK);
			}
			catch (Exception e) {
				hasException = true;

				throw processException(e);
			}
			finally {
				if (testResult != null) {
					cacheResult(testResult);
				}
				else if (!hasException) {
					EntityCacheUtil.putResult(TestResultModelImpl.ENTITY_CACHE_ENABLED,
						TestResultImpl.class, testResultPK, _nullTestResult);
				}

				closeSession(session);
			}
		}

		return testResult;
	}

	/**
	 * Returns all the test results where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @return the matching test results
	 * @throws SystemException if a system exception occurred
	 */
	public List<TestResult> findByUserId(long userId) throws SystemException {
		return findByUserId(userId, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the test results where userId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user ID
	 * @param start the lower bound of the range of test results
	 * @param end the upper bound of the range of test results (not inclusive)
	 * @return the range of matching test results
	 * @throws SystemException if a system exception occurred
	 */
	public List<TestResult> findByUserId(long userId, int start, int end)
		throws SystemException {
		return findByUserId(userId, start, end, null);
	}

	/**
	 * Returns an ordered range of all the test results where userId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user ID
	 * @param start the lower bound of the range of test results
	 * @param end the upper bound of the range of test results (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching test results
	 * @throws SystemException if a system exception occurred
	 */
	public List<TestResult> findByUserId(long userId, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_USERID;
			finderArgs = new Object[] { userId };
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_USERID;
			finderArgs = new Object[] { userId, start, end, orderByComparator };
		}

		List<TestResult> list = (List<TestResult>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if ((list != null) && !list.isEmpty()) {
			for (TestResult testResult : list) {
				if ((userId != testResult.getUserId())) {
					list = null;

					break;
				}
			}
		}

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(3);
			}

			query.append(_SQL_SELECT_TESTRESULT_WHERE);

			query.append(_FINDER_COLUMN_USERID_USERID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			else {
				query.append(TestResultModelImpl.ORDER_BY_JPQL);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(userId);

				list = (List<TestResult>)QueryUtil.list(q, getDialect(), start,
						end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(finderPath, finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(finderPath, finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Returns the first test result in the ordered set where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching test result
	 * @throws com.qti.slayer.NoSuchTestResultException if a matching test result could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult findByUserId_First(long userId,
		OrderByComparator orderByComparator)
		throws NoSuchTestResultException, SystemException {
		TestResult testResult = fetchByUserId_First(userId, orderByComparator);

		if (testResult != null) {
			return testResult;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("userId=");
		msg.append(userId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchTestResultException(msg.toString());
	}

	/**
	 * Returns the first test result in the ordered set where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching test result, or <code>null</code> if a matching test result could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult fetchByUserId_First(long userId,
		OrderByComparator orderByComparator) throws SystemException {
		List<TestResult> list = findByUserId(userId, 0, 1, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the last test result in the ordered set where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching test result
	 * @throws com.qti.slayer.NoSuchTestResultException if a matching test result could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult findByUserId_Last(long userId,
		OrderByComparator orderByComparator)
		throws NoSuchTestResultException, SystemException {
		TestResult testResult = fetchByUserId_Last(userId, orderByComparator);

		if (testResult != null) {
			return testResult;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("userId=");
		msg.append(userId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchTestResultException(msg.toString());
	}

	/**
	 * Returns the last test result in the ordered set where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching test result, or <code>null</code> if a matching test result could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult fetchByUserId_Last(long userId,
		OrderByComparator orderByComparator) throws SystemException {
		int count = countByUserId(userId);

		List<TestResult> list = findByUserId(userId, count - 1, count,
				orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the test results before and after the current test result in the ordered set where userId = &#63;.
	 *
	 * @param testResultPK the primary key of the current test result
	 * @param userId the user ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the previous, current, and next test result
	 * @throws com.qti.slayer.NoSuchTestResultException if a test result with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult[] findByUserId_PrevAndNext(TestResultPK testResultPK,
		long userId, OrderByComparator orderByComparator)
		throws NoSuchTestResultException, SystemException {
		TestResult testResult = findByPrimaryKey(testResultPK);

		Session session = null;

		try {
			session = openSession();

			TestResult[] array = new TestResultImpl[3];

			array[0] = getByUserId_PrevAndNext(session, testResult, userId,
					orderByComparator, true);

			array[1] = testResult;

			array[2] = getByUserId_PrevAndNext(session, testResult, userId,
					orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected TestResult getByUserId_PrevAndNext(Session session,
		TestResult testResult, long userId,
		OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_TESTRESULT_WHERE);

		query.append(_FINDER_COLUMN_USERID_USERID_2);

		if (orderByComparator != null) {
			String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

			if (orderByConditionFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByConditionFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByConditionFields[i]);

				if ((i + 1) < orderByConditionFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			String[] orderByFields = orderByComparator.getOrderByFields();

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		else {
			query.append(TestResultModelImpl.ORDER_BY_JPQL);
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(userId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByConditionValues(testResult);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<TestResult> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Returns all the test results where uolId = &#63;.
	 *
	 * @param uolId the uol ID
	 * @return the matching test results
	 * @throws SystemException if a system exception occurred
	 */
	public List<TestResult> findByUolId(long uolId) throws SystemException {
		return findByUolId(uolId, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the test results where uolId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param uolId the uol ID
	 * @param start the lower bound of the range of test results
	 * @param end the upper bound of the range of test results (not inclusive)
	 * @return the range of matching test results
	 * @throws SystemException if a system exception occurred
	 */
	public List<TestResult> findByUolId(long uolId, int start, int end)
		throws SystemException {
		return findByUolId(uolId, start, end, null);
	}

	/**
	 * Returns an ordered range of all the test results where uolId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param uolId the uol ID
	 * @param start the lower bound of the range of test results
	 * @param end the upper bound of the range of test results (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching test results
	 * @throws SystemException if a system exception occurred
	 */
	public List<TestResult> findByUolId(long uolId, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UOLID;
			finderArgs = new Object[] { uolId };
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_UOLID;
			finderArgs = new Object[] { uolId, start, end, orderByComparator };
		}

		List<TestResult> list = (List<TestResult>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if ((list != null) && !list.isEmpty()) {
			for (TestResult testResult : list) {
				if ((uolId != testResult.getUolId())) {
					list = null;

					break;
				}
			}
		}

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(3);
			}

			query.append(_SQL_SELECT_TESTRESULT_WHERE);

			query.append(_FINDER_COLUMN_UOLID_UOLID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			else {
				query.append(TestResultModelImpl.ORDER_BY_JPQL);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(uolId);

				list = (List<TestResult>)QueryUtil.list(q, getDialect(), start,
						end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(finderPath, finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(finderPath, finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Returns the first test result in the ordered set where uolId = &#63;.
	 *
	 * @param uolId the uol ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching test result
	 * @throws com.qti.slayer.NoSuchTestResultException if a matching test result could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult findByUolId_First(long uolId,
		OrderByComparator orderByComparator)
		throws NoSuchTestResultException, SystemException {
		TestResult testResult = fetchByUolId_First(uolId, orderByComparator);

		if (testResult != null) {
			return testResult;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("uolId=");
		msg.append(uolId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchTestResultException(msg.toString());
	}

	/**
	 * Returns the first test result in the ordered set where uolId = &#63;.
	 *
	 * @param uolId the uol ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching test result, or <code>null</code> if a matching test result could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult fetchByUolId_First(long uolId,
		OrderByComparator orderByComparator) throws SystemException {
		List<TestResult> list = findByUolId(uolId, 0, 1, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the last test result in the ordered set where uolId = &#63;.
	 *
	 * @param uolId the uol ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching test result
	 * @throws com.qti.slayer.NoSuchTestResultException if a matching test result could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult findByUolId_Last(long uolId,
		OrderByComparator orderByComparator)
		throws NoSuchTestResultException, SystemException {
		TestResult testResult = fetchByUolId_Last(uolId, orderByComparator);

		if (testResult != null) {
			return testResult;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("uolId=");
		msg.append(uolId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchTestResultException(msg.toString());
	}

	/**
	 * Returns the last test result in the ordered set where uolId = &#63;.
	 *
	 * @param uolId the uol ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching test result, or <code>null</code> if a matching test result could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult fetchByUolId_Last(long uolId,
		OrderByComparator orderByComparator) throws SystemException {
		int count = countByUolId(uolId);

		List<TestResult> list = findByUolId(uolId, count - 1, count,
				orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the test results before and after the current test result in the ordered set where uolId = &#63;.
	 *
	 * @param testResultPK the primary key of the current test result
	 * @param uolId the uol ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the previous, current, and next test result
	 * @throws com.qti.slayer.NoSuchTestResultException if a test result with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public TestResult[] findByUolId_PrevAndNext(TestResultPK testResultPK,
		long uolId, OrderByComparator orderByComparator)
		throws NoSuchTestResultException, SystemException {
		TestResult testResult = findByPrimaryKey(testResultPK);

		Session session = null;

		try {
			session = openSession();

			TestResult[] array = new TestResultImpl[3];

			array[0] = getByUolId_PrevAndNext(session, testResult, uolId,
					orderByComparator, true);

			array[1] = testResult;

			array[2] = getByUolId_PrevAndNext(session, testResult, uolId,
					orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected TestResult getByUolId_PrevAndNext(Session session,
		TestResult testResult, long uolId, OrderByComparator orderByComparator,
		boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_TESTRESULT_WHERE);

		query.append(_FINDER_COLUMN_UOLID_UOLID_2);

		if (orderByComparator != null) {
			String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

			if (orderByConditionFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByConditionFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByConditionFields[i]);

				if ((i + 1) < orderByConditionFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			String[] orderByFields = orderByComparator.getOrderByFields();

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		else {
			query.append(TestResultModelImpl.ORDER_BY_JPQL);
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(uolId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByConditionValues(testResult);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<TestResult> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Returns all the test results.
	 *
	 * @return the test results
	 * @throws SystemException if a system exception occurred
	 */
	public List<TestResult> findAll() throws SystemException {
		return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the test results.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of test results
	 * @param end the upper bound of the range of test results (not inclusive)
	 * @return the range of test results
	 * @throws SystemException if a system exception occurred
	 */
	public List<TestResult> findAll(int start, int end)
		throws SystemException {
		return findAll(start, end, null);
	}

	/**
	 * Returns an ordered range of all the test results.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of test results
	 * @param end the upper bound of the range of test results (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of test results
	 * @throws SystemException if a system exception occurred
	 */
	public List<TestResult> findAll(int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		FinderPath finderPath = null;
		Object[] finderArgs = new Object[] { start, end, orderByComparator };

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL;
			finderArgs = FINDER_ARGS_EMPTY;
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_ALL;
			finderArgs = new Object[] { start, end, orderByComparator };
		}

		List<TestResult> list = (List<TestResult>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;
			String sql = null;

			if (orderByComparator != null) {
				query = new StringBundler(2 +
						(orderByComparator.getOrderByFields().length * 3));

				query.append(_SQL_SELECT_TESTRESULT);

				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);

				sql = query.toString();
			}
			else {
				sql = _SQL_SELECT_TESTRESULT.concat(TestResultModelImpl.ORDER_BY_JPQL);
			}

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				if (orderByComparator == null) {
					list = (List<TestResult>)QueryUtil.list(q, getDialect(),
							start, end, false);

					Collections.sort(list);
				}
				else {
					list = (List<TestResult>)QueryUtil.list(q, getDialect(),
							start, end);
				}
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(finderPath, finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(finderPath, finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Removes all the test results where userId = &#63; from the database.
	 *
	 * @param userId the user ID
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByUserId(long userId) throws SystemException {
		for (TestResult testResult : findByUserId(userId)) {
			remove(testResult);
		}
	}

	/**
	 * Removes all the test results where uolId = &#63; from the database.
	 *
	 * @param uolId the uol ID
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByUolId(long uolId) throws SystemException {
		for (TestResult testResult : findByUolId(uolId)) {
			remove(testResult);
		}
	}

	/**
	 * Removes all the test results from the database.
	 *
	 * @throws SystemException if a system exception occurred
	 */
	public void removeAll() throws SystemException {
		for (TestResult testResult : findAll()) {
			remove(testResult);
		}
	}

	/**
	 * Returns the number of test results where userId = &#63;.
	 *
	 * @param userId the user ID
	 * @return the number of matching test results
	 * @throws SystemException if a system exception occurred
	 */
	public int countByUserId(long userId) throws SystemException {
		Object[] finderArgs = new Object[] { userId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_USERID,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_TESTRESULT_WHERE);

			query.append(_FINDER_COLUMN_USERID_USERID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(userId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_USERID,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Returns the number of test results where uolId = &#63;.
	 *
	 * @param uolId the uol ID
	 * @return the number of matching test results
	 * @throws SystemException if a system exception occurred
	 */
	public int countByUolId(long uolId) throws SystemException {
		Object[] finderArgs = new Object[] { uolId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_UOLID,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_TESTRESULT_WHERE);

			query.append(_FINDER_COLUMN_UOLID_UOLID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(uolId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_UOLID,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Returns the number of test results.
	 *
	 * @return the number of test results
	 * @throws SystemException if a system exception occurred
	 */
	public int countAll() throws SystemException {
		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
				FINDER_ARGS_EMPTY, this);

		if (count == null) {
			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(_SQL_COUNT_TESTRESULT);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL,
					FINDER_ARGS_EMPTY, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Initializes the test result persistence.
	 */
	public void afterPropertiesSet() {
		String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
					com.liferay.util.service.ServiceProps.get(
						"value.object.listener.com.qti.slayer.model.TestResult")));

		if (listenerClassNames.length > 0) {
			try {
				List<ModelListener<TestResult>> listenersList = new ArrayList<ModelListener<TestResult>>();

				for (String listenerClassName : listenerClassNames) {
					listenersList.add((ModelListener<TestResult>)InstanceFactory.newInstance(
							listenerClassName));
				}

				listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
			}
			catch (Exception e) {
				_log.error(e);
			}
		}
	}

	public void destroy() {
		EntityCacheUtil.removeCache(TestResultImpl.class.getName());
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	@BeanReference(type = AssignmentPersistence.class)
	protected AssignmentPersistence assignmentPersistence;
	@BeanReference(type = TestResultPersistence.class)
	protected TestResultPersistence testResultPersistence;
	@BeanReference(type = UolPersistence.class)
	protected UolPersistence uolPersistence;
	@BeanReference(type = ResourcePersistence.class)
	protected ResourcePersistence resourcePersistence;
	@BeanReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
	private static final String _SQL_SELECT_TESTRESULT = "SELECT testResult FROM TestResult testResult";
	private static final String _SQL_SELECT_TESTRESULT_WHERE = "SELECT testResult FROM TestResult testResult WHERE ";
	private static final String _SQL_COUNT_TESTRESULT = "SELECT COUNT(testResult) FROM TestResult testResult";
	private static final String _SQL_COUNT_TESTRESULT_WHERE = "SELECT COUNT(testResult) FROM TestResult testResult WHERE ";
	private static final String _FINDER_COLUMN_USERID_USERID_2 = "testResult.id.userId = ?";
	private static final String _FINDER_COLUMN_UOLID_UOLID_2 = "testResult.id.uolId = ?";
	private static final String _ORDER_BY_ENTITY_ALIAS = "testResult.";
	private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No TestResult exists with the primary key ";
	private static final String _NO_SUCH_ENTITY_WITH_KEY = "No TestResult exists with the key {";
	private static final boolean _HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE = GetterUtil.getBoolean(PropsUtil.get(
				PropsKeys.HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE));
	private static Log _log = LogFactoryUtil.getLog(TestResultPersistenceImpl.class);
	private static TestResult _nullTestResult = new TestResultImpl() {
			@Override
			public Object clone() {
				return this;
			}

			@Override
			public CacheModel<TestResult> toCacheModel() {
				return _nullTestResultCacheModel;
			}
		};

	private static CacheModel<TestResult> _nullTestResultCacheModel = new CacheModel<TestResult>() {
			public TestResult toEntityModel() {
				return _nullTestResult;
			}
		};
}