/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.qti.slayer.service.persistence;

import com.liferay.portal.NoSuchModelException;
import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryPos;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PropsKeys;
import com.liferay.portal.kernel.util.PropsUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.service.persistence.BatchSessionUtil;
import com.liferay.portal.service.persistence.ResourcePersistence;
import com.liferay.portal.service.persistence.UserPersistence;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import com.qti.slayer.NoSuchUolException;
import com.qti.slayer.model.Uol;
import com.qti.slayer.model.impl.UolImpl;
import com.qti.slayer.model.impl.UolModelImpl;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * The persistence implementation for the uol service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Hector
 * @see UolPersistence
 * @see UolUtil
 * @generated
 */
public class UolPersistenceImpl extends BasePersistenceImpl<Uol>
	implements UolPersistence {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link UolUtil} to access the uol persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */
	public static final String FINDER_CLASS_NAME_ENTITY = UolImpl.class.getName();
	public static final String FINDER_CLASS_NAME_LIST_WITH_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List1";
	public static final String FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List2";
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_CLASSROOMID =
		new FinderPath(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolModelImpl.FINDER_CACHE_ENABLED, UolImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByClassRoomId",
			new String[] {
				Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_CLASSROOMID =
		new FinderPath(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolModelImpl.FINDER_CACHE_ENABLED, UolImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByClassRoomId",
			new String[] { Long.class.getName() },
			UolModelImpl.CLASSROOMID_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_CLASSROOMID = new FinderPath(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByClassRoomId",
			new String[] { Long.class.getName() });
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_ASSESSMENTTESTID =
		new FinderPath(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolModelImpl.FINDER_CACHE_ENABLED, UolImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByAssessmentTestId",
			new String[] {
				Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ASSESSMENTTESTID =
		new FinderPath(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolModelImpl.FINDER_CACHE_ENABLED, UolImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION,
			"findByAssessmentTestId", new String[] { Long.class.getName() },
			UolModelImpl.ASSESSMENTTESTID_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_ASSESSMENTTESTID = new FinderPath(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION,
			"countByAssessmentTestId", new String[] { Long.class.getName() });
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_ALL = new FinderPath(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolModelImpl.FINDER_CACHE_ENABLED, UolImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL = new FinderPath(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolModelImpl.FINDER_CACHE_ENABLED, UolImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countAll", new String[0]);

	/**
	 * Caches the uol in the entity cache if it is enabled.
	 *
	 * @param uol the uol
	 */
	public void cacheResult(Uol uol) {
		EntityCacheUtil.putResult(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolImpl.class, uol.getPrimaryKey(), uol);

		uol.resetOriginalValues();
	}

	/**
	 * Caches the uols in the entity cache if it is enabled.
	 *
	 * @param uols the uols
	 */
	public void cacheResult(List<Uol> uols) {
		for (Uol uol : uols) {
			if (EntityCacheUtil.getResult(UolModelImpl.ENTITY_CACHE_ENABLED,
						UolImpl.class, uol.getPrimaryKey()) == null) {
				cacheResult(uol);
			}
			else {
				uol.resetOriginalValues();
			}
		}
	}

	/**
	 * Clears the cache for all uols.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache() {
		if (_HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE) {
			CacheRegistryUtil.clear(UolImpl.class.getName());
		}

		EntityCacheUtil.clearCache(UolImpl.class.getName());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	/**
	 * Clears the cache for the uol.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache(Uol uol) {
		EntityCacheUtil.removeResult(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolImpl.class, uol.getPrimaryKey());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	@Override
	public void clearCache(List<Uol> uols) {
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

		for (Uol uol : uols) {
			EntityCacheUtil.removeResult(UolModelImpl.ENTITY_CACHE_ENABLED,
				UolImpl.class, uol.getPrimaryKey());
		}
	}

	/**
	 * Creates a new uol with the primary key. Does not add the uol to the database.
	 *
	 * @param I_Id the primary key for the new uol
	 * @return the new uol
	 */
	public Uol create(long I_Id) {
		Uol uol = new UolImpl();

		uol.setNew(true);
		uol.setPrimaryKey(I_Id);

		return uol;
	}

	/**
	 * Removes the uol with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param I_Id the primary key of the uol
	 * @return the uol that was removed
	 * @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol remove(long I_Id) throws NoSuchUolException, SystemException {
		return remove(Long.valueOf(I_Id));
	}

	/**
	 * Removes the uol with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param primaryKey the primary key of the uol
	 * @return the uol that was removed
	 * @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Uol remove(Serializable primaryKey)
		throws NoSuchUolException, SystemException {
		Session session = null;

		try {
			session = openSession();

			Uol uol = (Uol)session.get(UolImpl.class, primaryKey);

			if (uol == null) {
				if (_log.isWarnEnabled()) {
					_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
				}

				throw new NoSuchUolException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
					primaryKey);
			}

			return remove(uol);
		}
		catch (NoSuchUolException nsee) {
			throw nsee;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	@Override
	protected Uol removeImpl(Uol uol) throws SystemException {
		uol = toUnwrappedModel(uol);

		Session session = null;

		try {
			session = openSession();

			BatchSessionUtil.delete(session, uol);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		clearCache(uol);

		return uol;
	}

	@Override
	public Uol updateImpl(com.qti.slayer.model.Uol uol, boolean merge)
		throws SystemException {
		uol = toUnwrappedModel(uol);

		boolean isNew = uol.isNew();

		UolModelImpl uolModelImpl = (UolModelImpl)uol;

		Session session = null;

		try {
			session = openSession();

			BatchSessionUtil.update(session, uol, merge);

			uol.setNew(false);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);

		if (isNew || !UolModelImpl.COLUMN_BITMASK_ENABLED) {
			FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
		}

		else {
			if ((uolModelImpl.getColumnBitmask() &
					FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_CLASSROOMID.getColumnBitmask()) != 0) {
				Object[] args = new Object[] {
						Long.valueOf(uolModelImpl.getOriginalClassRoomId())
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_CLASSROOMID,
					args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_CLASSROOMID,
					args);

				args = new Object[] { Long.valueOf(uolModelImpl.getClassRoomId()) };

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_CLASSROOMID,
					args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_CLASSROOMID,
					args);
			}

			if ((uolModelImpl.getColumnBitmask() &
					FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ASSESSMENTTESTID.getColumnBitmask()) != 0) {
				Object[] args = new Object[] {
						Long.valueOf(uolModelImpl.getOriginalAssessmentTestId())
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_ASSESSMENTTESTID,
					args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ASSESSMENTTESTID,
					args);

				args = new Object[] {
						Long.valueOf(uolModelImpl.getAssessmentTestId())
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_ASSESSMENTTESTID,
					args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ASSESSMENTTESTID,
					args);
			}
		}

		EntityCacheUtil.putResult(UolModelImpl.ENTITY_CACHE_ENABLED,
			UolImpl.class, uol.getPrimaryKey(), uol);

		return uol;
	}

	protected Uol toUnwrappedModel(Uol uol) {
		if (uol instanceof UolImpl) {
			return uol;
		}

		UolImpl uolImpl = new UolImpl();

		uolImpl.setNew(uol.isNew());
		uolImpl.setPrimaryKey(uol.getPrimaryKey());

		uolImpl.setI_Id(uol.getI_Id());
		uolImpl.setClassRoomId(uol.getClassRoomId());
		uolImpl.setSubjectId(uol.getSubjectId());
		uolImpl.setCountryId(uol.getCountryId());
		uolImpl.setCompanyId(uol.getCompanyId());
		uolImpl.setAssessmentTestId(uol.getAssessmentTestId());
		uolImpl.setCreateDate(uol.getCreateDate());
		uolImpl.setRequestedDate(uol.getRequestedDate());
		uolImpl.setDescription(uol.getDescription());
		uolImpl.setActive(uol.isActive());
		uolImpl.setEvalTypeId(uol.getEvalTypeId());
		uolImpl.setTitle(uol.getTitle());

		return uolImpl;
	}

	/**
	 * Returns the uol with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
	 *
	 * @param primaryKey the primary key of the uol
	 * @return the uol
	 * @throws com.liferay.portal.NoSuchModelException if a uol with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Uol findByPrimaryKey(Serializable primaryKey)
		throws NoSuchModelException, SystemException {
		return findByPrimaryKey(((Long)primaryKey).longValue());
	}

	/**
	 * Returns the uol with the primary key or throws a {@link com.qti.slayer.NoSuchUolException} if it could not be found.
	 *
	 * @param I_Id the primary key of the uol
	 * @return the uol
	 * @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol findByPrimaryKey(long I_Id)
		throws NoSuchUolException, SystemException {
		Uol uol = fetchByPrimaryKey(I_Id);

		if (uol == null) {
			if (_log.isWarnEnabled()) {
				_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + I_Id);
			}

			throw new NoSuchUolException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
				I_Id);
		}

		return uol;
	}

	/**
	 * Returns the uol with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param primaryKey the primary key of the uol
	 * @return the uol, or <code>null</code> if a uol with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public Uol fetchByPrimaryKey(Serializable primaryKey)
		throws SystemException {
		return fetchByPrimaryKey(((Long)primaryKey).longValue());
	}

	/**
	 * Returns the uol with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param I_Id the primary key of the uol
	 * @return the uol, or <code>null</code> if a uol with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol fetchByPrimaryKey(long I_Id) throws SystemException {
		Uol uol = (Uol)EntityCacheUtil.getResult(UolModelImpl.ENTITY_CACHE_ENABLED,
				UolImpl.class, I_Id);

		if (uol == _nullUol) {
			return null;
		}

		if (uol == null) {
			Session session = null;

			boolean hasException = false;

			try {
				session = openSession();

				uol = (Uol)session.get(UolImpl.class, Long.valueOf(I_Id));
			}
			catch (Exception e) {
				hasException = true;

				throw processException(e);
			}
			finally {
				if (uol != null) {
					cacheResult(uol);
				}
				else if (!hasException) {
					EntityCacheUtil.putResult(UolModelImpl.ENTITY_CACHE_ENABLED,
						UolImpl.class, I_Id, _nullUol);
				}

				closeSession(session);
			}
		}

		return uol;
	}

	/**
	 * Returns all the uols where classRoomId = &#63;.
	 *
	 * @param classRoomId the class room ID
	 * @return the matching uols
	 * @throws SystemException if a system exception occurred
	 */
	public List<Uol> findByClassRoomId(long classRoomId)
		throws SystemException {
		return findByClassRoomId(classRoomId, QueryUtil.ALL_POS,
			QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the uols where classRoomId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param classRoomId the class room ID
	 * @param start the lower bound of the range of uols
	 * @param end the upper bound of the range of uols (not inclusive)
	 * @return the range of matching uols
	 * @throws SystemException if a system exception occurred
	 */
	public List<Uol> findByClassRoomId(long classRoomId, int start, int end)
		throws SystemException {
		return findByClassRoomId(classRoomId, start, end, null);
	}

	/**
	 * Returns an ordered range of all the uols where classRoomId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param classRoomId the class room ID
	 * @param start the lower bound of the range of uols
	 * @param end the upper bound of the range of uols (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching uols
	 * @throws SystemException if a system exception occurred
	 */
	public List<Uol> findByClassRoomId(long classRoomId, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_CLASSROOMID;
			finderArgs = new Object[] { classRoomId };
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_CLASSROOMID;
			finderArgs = new Object[] { classRoomId, start, end, orderByComparator };
		}

		List<Uol> list = (List<Uol>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if ((list != null) && !list.isEmpty()) {
			for (Uol uol : list) {
				if ((classRoomId != uol.getClassRoomId())) {
					list = null;

					break;
				}
			}
		}

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(3);
			}

			query.append(_SQL_SELECT_UOL_WHERE);

			query.append(_FINDER_COLUMN_CLASSROOMID_CLASSROOMID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			else {
				query.append(UolModelImpl.ORDER_BY_JPQL);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(classRoomId);

				list = (List<Uol>)QueryUtil.list(q, getDialect(), start, end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(finderPath, finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(finderPath, finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Returns the first uol in the ordered set where classRoomId = &#63;.
	 *
	 * @param classRoomId the class room ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching uol
	 * @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol findByClassRoomId_First(long classRoomId,
		OrderByComparator orderByComparator)
		throws NoSuchUolException, SystemException {
		Uol uol = fetchByClassRoomId_First(classRoomId, orderByComparator);

		if (uol != null) {
			return uol;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("classRoomId=");
		msg.append(classRoomId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchUolException(msg.toString());
	}

	/**
	 * Returns the first uol in the ordered set where classRoomId = &#63;.
	 *
	 * @param classRoomId the class room ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching uol, or <code>null</code> if a matching uol could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol fetchByClassRoomId_First(long classRoomId,
		OrderByComparator orderByComparator) throws SystemException {
		List<Uol> list = findByClassRoomId(classRoomId, 0, 1, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the last uol in the ordered set where classRoomId = &#63;.
	 *
	 * @param classRoomId the class room ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching uol
	 * @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol findByClassRoomId_Last(long classRoomId,
		OrderByComparator orderByComparator)
		throws NoSuchUolException, SystemException {
		Uol uol = fetchByClassRoomId_Last(classRoomId, orderByComparator);

		if (uol != null) {
			return uol;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("classRoomId=");
		msg.append(classRoomId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchUolException(msg.toString());
	}

	/**
	 * Returns the last uol in the ordered set where classRoomId = &#63;.
	 *
	 * @param classRoomId the class room ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching uol, or <code>null</code> if a matching uol could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol fetchByClassRoomId_Last(long classRoomId,
		OrderByComparator orderByComparator) throws SystemException {
		int count = countByClassRoomId(classRoomId);

		List<Uol> list = findByClassRoomId(classRoomId, count - 1, count,
				orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the uols before and after the current uol in the ordered set where classRoomId = &#63;.
	 *
	 * @param I_Id the primary key of the current uol
	 * @param classRoomId the class room ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the previous, current, and next uol
	 * @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol[] findByClassRoomId_PrevAndNext(long I_Id, long classRoomId,
		OrderByComparator orderByComparator)
		throws NoSuchUolException, SystemException {
		Uol uol = findByPrimaryKey(I_Id);

		Session session = null;

		try {
			session = openSession();

			Uol[] array = new UolImpl[3];

			array[0] = getByClassRoomId_PrevAndNext(session, uol, classRoomId,
					orderByComparator, true);

			array[1] = uol;

			array[2] = getByClassRoomId_PrevAndNext(session, uol, classRoomId,
					orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected Uol getByClassRoomId_PrevAndNext(Session session, Uol uol,
		long classRoomId, OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_UOL_WHERE);

		query.append(_FINDER_COLUMN_CLASSROOMID_CLASSROOMID_2);

		if (orderByComparator != null) {
			String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

			if (orderByConditionFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByConditionFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByConditionFields[i]);

				if ((i + 1) < orderByConditionFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			String[] orderByFields = orderByComparator.getOrderByFields();

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		else {
			query.append(UolModelImpl.ORDER_BY_JPQL);
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(classRoomId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByConditionValues(uol);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<Uol> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Returns all the uols where assessmentTestId = &#63;.
	 *
	 * @param assessmentTestId the assessment test ID
	 * @return the matching uols
	 * @throws SystemException if a system exception occurred
	 */
	public List<Uol> findByAssessmentTestId(long assessmentTestId)
		throws SystemException {
		return findByAssessmentTestId(assessmentTestId, QueryUtil.ALL_POS,
			QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the uols where assessmentTestId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param assessmentTestId the assessment test ID
	 * @param start the lower bound of the range of uols
	 * @param end the upper bound of the range of uols (not inclusive)
	 * @return the range of matching uols
	 * @throws SystemException if a system exception occurred
	 */
	public List<Uol> findByAssessmentTestId(long assessmentTestId, int start,
		int end) throws SystemException {
		return findByAssessmentTestId(assessmentTestId, start, end, null);
	}

	/**
	 * Returns an ordered range of all the uols where assessmentTestId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param assessmentTestId the assessment test ID
	 * @param start the lower bound of the range of uols
	 * @param end the upper bound of the range of uols (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching uols
	 * @throws SystemException if a system exception occurred
	 */
	public List<Uol> findByAssessmentTestId(long assessmentTestId, int start,
		int end, OrderByComparator orderByComparator) throws SystemException {
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ASSESSMENTTESTID;
			finderArgs = new Object[] { assessmentTestId };
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_ASSESSMENTTESTID;
			finderArgs = new Object[] {
					assessmentTestId,
					
					start, end, orderByComparator
				};
		}

		List<Uol> list = (List<Uol>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if ((list != null) && !list.isEmpty()) {
			for (Uol uol : list) {
				if ((assessmentTestId != uol.getAssessmentTestId())) {
					list = null;

					break;
				}
			}
		}

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(3);
			}

			query.append(_SQL_SELECT_UOL_WHERE);

			query.append(_FINDER_COLUMN_ASSESSMENTTESTID_ASSESSMENTTESTID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			else {
				query.append(UolModelImpl.ORDER_BY_JPQL);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(assessmentTestId);

				list = (List<Uol>)QueryUtil.list(q, getDialect(), start, end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(finderPath, finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(finderPath, finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Returns the first uol in the ordered set where assessmentTestId = &#63;.
	 *
	 * @param assessmentTestId the assessment test ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching uol
	 * @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol findByAssessmentTestId_First(long assessmentTestId,
		OrderByComparator orderByComparator)
		throws NoSuchUolException, SystemException {
		Uol uol = fetchByAssessmentTestId_First(assessmentTestId,
				orderByComparator);

		if (uol != null) {
			return uol;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("assessmentTestId=");
		msg.append(assessmentTestId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchUolException(msg.toString());
	}

	/**
	 * Returns the first uol in the ordered set where assessmentTestId = &#63;.
	 *
	 * @param assessmentTestId the assessment test ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching uol, or <code>null</code> if a matching uol could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol fetchByAssessmentTestId_First(long assessmentTestId,
		OrderByComparator orderByComparator) throws SystemException {
		List<Uol> list = findByAssessmentTestId(assessmentTestId, 0, 1,
				orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the last uol in the ordered set where assessmentTestId = &#63;.
	 *
	 * @param assessmentTestId the assessment test ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching uol
	 * @throws com.qti.slayer.NoSuchUolException if a matching uol could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol findByAssessmentTestId_Last(long assessmentTestId,
		OrderByComparator orderByComparator)
		throws NoSuchUolException, SystemException {
		Uol uol = fetchByAssessmentTestId_Last(assessmentTestId,
				orderByComparator);

		if (uol != null) {
			return uol;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("assessmentTestId=");
		msg.append(assessmentTestId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchUolException(msg.toString());
	}

	/**
	 * Returns the last uol in the ordered set where assessmentTestId = &#63;.
	 *
	 * @param assessmentTestId the assessment test ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching uol, or <code>null</code> if a matching uol could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol fetchByAssessmentTestId_Last(long assessmentTestId,
		OrderByComparator orderByComparator) throws SystemException {
		int count = countByAssessmentTestId(assessmentTestId);

		List<Uol> list = findByAssessmentTestId(assessmentTestId, count - 1,
				count, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the uols before and after the current uol in the ordered set where assessmentTestId = &#63;.
	 *
	 * @param I_Id the primary key of the current uol
	 * @param assessmentTestId the assessment test ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the previous, current, and next uol
	 * @throws com.qti.slayer.NoSuchUolException if a uol with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Uol[] findByAssessmentTestId_PrevAndNext(long I_Id,
		long assessmentTestId, OrderByComparator orderByComparator)
		throws NoSuchUolException, SystemException {
		Uol uol = findByPrimaryKey(I_Id);

		Session session = null;

		try {
			session = openSession();

			Uol[] array = new UolImpl[3];

			array[0] = getByAssessmentTestId_PrevAndNext(session, uol,
					assessmentTestId, orderByComparator, true);

			array[1] = uol;

			array[2] = getByAssessmentTestId_PrevAndNext(session, uol,
					assessmentTestId, orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected Uol getByAssessmentTestId_PrevAndNext(Session session, Uol uol,
		long assessmentTestId, OrderByComparator orderByComparator,
		boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_UOL_WHERE);

		query.append(_FINDER_COLUMN_ASSESSMENTTESTID_ASSESSMENTTESTID_2);

		if (orderByComparator != null) {
			String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

			if (orderByConditionFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByConditionFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByConditionFields[i]);

				if ((i + 1) < orderByConditionFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			String[] orderByFields = orderByComparator.getOrderByFields();

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		else {
			query.append(UolModelImpl.ORDER_BY_JPQL);
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(assessmentTestId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByConditionValues(uol);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<Uol> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Returns all the uols.
	 *
	 * @return the uols
	 * @throws SystemException if a system exception occurred
	 */
	public List<Uol> findAll() throws SystemException {
		return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the uols.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of uols
	 * @param end the upper bound of the range of uols (not inclusive)
	 * @return the range of uols
	 * @throws SystemException if a system exception occurred
	 */
	public List<Uol> findAll(int start, int end) throws SystemException {
		return findAll(start, end, null);
	}

	/**
	 * Returns an ordered range of all the uols.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of uols
	 * @param end the upper bound of the range of uols (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of uols
	 * @throws SystemException if a system exception occurred
	 */
	public List<Uol> findAll(int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		FinderPath finderPath = null;
		Object[] finderArgs = new Object[] { start, end, orderByComparator };

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL;
			finderArgs = FINDER_ARGS_EMPTY;
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_ALL;
			finderArgs = new Object[] { start, end, orderByComparator };
		}

		List<Uol> list = (List<Uol>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;
			String sql = null;

			if (orderByComparator != null) {
				query = new StringBundler(2 +
						(orderByComparator.getOrderByFields().length * 3));

				query.append(_SQL_SELECT_UOL);

				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);

				sql = query.toString();
			}
			else {
				sql = _SQL_SELECT_UOL.concat(UolModelImpl.ORDER_BY_JPQL);
			}

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				if (orderByComparator == null) {
					list = (List<Uol>)QueryUtil.list(q, getDialect(), start,
							end, false);

					Collections.sort(list);
				}
				else {
					list = (List<Uol>)QueryUtil.list(q, getDialect(), start, end);
				}
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(finderPath, finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(finderPath, finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Removes all the uols where classRoomId = &#63; from the database.
	 *
	 * @param classRoomId the class room ID
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByClassRoomId(long classRoomId) throws SystemException {
		for (Uol uol : findByClassRoomId(classRoomId)) {
			remove(uol);
		}
	}

	/**
	 * Removes all the uols where assessmentTestId = &#63; from the database.
	 *
	 * @param assessmentTestId the assessment test ID
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByAssessmentTestId(long assessmentTestId)
		throws SystemException {
		for (Uol uol : findByAssessmentTestId(assessmentTestId)) {
			remove(uol);
		}
	}

	/**
	 * Removes all the uols from the database.
	 *
	 * @throws SystemException if a system exception occurred
	 */
	public void removeAll() throws SystemException {
		for (Uol uol : findAll()) {
			remove(uol);
		}
	}

	/**
	 * Returns the number of uols where classRoomId = &#63;.
	 *
	 * @param classRoomId the class room ID
	 * @return the number of matching uols
	 * @throws SystemException if a system exception occurred
	 */
	public int countByClassRoomId(long classRoomId) throws SystemException {
		Object[] finderArgs = new Object[] { classRoomId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_CLASSROOMID,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_UOL_WHERE);

			query.append(_FINDER_COLUMN_CLASSROOMID_CLASSROOMID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(classRoomId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_CLASSROOMID,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Returns the number of uols where assessmentTestId = &#63;.
	 *
	 * @param assessmentTestId the assessment test ID
	 * @return the number of matching uols
	 * @throws SystemException if a system exception occurred
	 */
	public int countByAssessmentTestId(long assessmentTestId)
		throws SystemException {
		Object[] finderArgs = new Object[] { assessmentTestId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_ASSESSMENTTESTID,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_UOL_WHERE);

			query.append(_FINDER_COLUMN_ASSESSMENTTESTID_ASSESSMENTTESTID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(assessmentTestId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_ASSESSMENTTESTID,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Returns the number of uols.
	 *
	 * @return the number of uols
	 * @throws SystemException if a system exception occurred
	 */
	public int countAll() throws SystemException {
		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
				FINDER_ARGS_EMPTY, this);

		if (count == null) {
			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(_SQL_COUNT_UOL);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL,
					FINDER_ARGS_EMPTY, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Initializes the uol persistence.
	 */
	public void afterPropertiesSet() {
		String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
					com.liferay.util.service.ServiceProps.get(
						"value.object.listener.com.qti.slayer.model.Uol")));

		if (listenerClassNames.length > 0) {
			try {
				List<ModelListener<Uol>> listenersList = new ArrayList<ModelListener<Uol>>();

				for (String listenerClassName : listenerClassNames) {
					listenersList.add((ModelListener<Uol>)InstanceFactory.newInstance(
							listenerClassName));
				}

				listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
			}
			catch (Exception e) {
				_log.error(e);
			}
		}
	}

	public void destroy() {
		EntityCacheUtil.removeCache(UolImpl.class.getName());
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	@BeanReference(type = AssignmentPersistence.class)
	protected AssignmentPersistence assignmentPersistence;
	@BeanReference(type = TestResultPersistence.class)
	protected TestResultPersistence testResultPersistence;
	@BeanReference(type = UolPersistence.class)
	protected UolPersistence uolPersistence;
	@BeanReference(type = ResourcePersistence.class)
	protected ResourcePersistence resourcePersistence;
	@BeanReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
	private static final String _SQL_SELECT_UOL = "SELECT uol FROM Uol uol";
	private static final String _SQL_SELECT_UOL_WHERE = "SELECT uol FROM Uol uol WHERE ";
	private static final String _SQL_COUNT_UOL = "SELECT COUNT(uol) FROM Uol uol";
	private static final String _SQL_COUNT_UOL_WHERE = "SELECT COUNT(uol) FROM Uol uol WHERE ";
	private static final String _FINDER_COLUMN_CLASSROOMID_CLASSROOMID_2 = "uol.classRoomId = ?";
	private static final String _FINDER_COLUMN_ASSESSMENTTESTID_ASSESSMENTTESTID_2 =
		"uol.assessmentTestId = ?";
	private static final String _ORDER_BY_ENTITY_ALIAS = "uol.";
	private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No Uol exists with the primary key ";
	private static final String _NO_SUCH_ENTITY_WITH_KEY = "No Uol exists with the key {";
	private static final boolean _HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE = GetterUtil.getBoolean(PropsUtil.get(
				PropsKeys.HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE));
	private static Log _log = LogFactoryUtil.getLog(UolPersistenceImpl.class);
	private static Uol _nullUol = new UolImpl() {
			@Override
			public Object clone() {
				return this;
			}

			@Override
			public CacheModel<Uol> toCacheModel() {
				return _nullUolCacheModel;
			}
		};

	private static CacheModel<Uol> _nullUolCacheModel = new CacheModel<Uol>() {
			public Uol toEntityModel() {
				return _nullUol;
			}
		};
}