/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.portlet.assessment.beans.controller;

import java.util.List;

import org.tencompetence.generated.model.LevelValue;
import org.tencompetence.portlet.common.components.RatingComponentController;

/**
 * Enter the class documentation here.
 *
 * @author Harrie Martens
 * @author Hubert Vogten
 * 
 * @version $Revision: 1.6 $, $Date: 2009/11/05 10:43:18 $
 */
public class RatingController extends RatingComponentController {

	/**
	 * Instantiates a new rating controller.
	 * 
	 * @param levels the levels
	 * @param assignedLevel the assigned level
	 * @param requiredLevelId the required level id
	 */
	public RatingController(final List<LevelValue> levels, final LevelValue assignedLevel, final long requiredLevelId) {
		super(levels, assignedLevel, requiredLevelId, false, false, true);
	}

	/** {@inheritDoc} */
	@Override
	public void ratingComponentClicked() {
		//do nothing as we use this controller as read only controller

	}

}
