/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.portlet.common.components;

import javax.faces.event.ActionListener;

import com.icesoft.faces.component.menubar.MenuItem;
import com.liferay.portal.model.BaseModel;

/**
 * The Class ActionsMenuItem.
 * 
 * @param <T> the entity class
 * 
 * @version $Revision: 1.3 $, $Date: 2009/11/24 14:10:06 $
 */
public class ActionsMenuItem<T extends BaseModel<T>> extends MenuItem {
	
	/** The data. */
	private T data;

	/**
	 * Instantiates a new actions menu item.
	 */
	public ActionsMenuItem() {
		super();
	}

	/**
	 * Instantiates a new actions menu item.
	 * 
	 * @param label the label
	 * @param icon the icon
	 * @param al the al
	 * @param data the data
	 */
	public ActionsMenuItem(final String label, final String icon, final ActionListener al, final T data) {
		this();
		super.setValue(label);
		super.setIcon(icon);
		this.data = data;
		this.addActionListener(al);

	}

	/**
	 * Gets the data.
	 * 
	 * @return the data
	 */
	public T getData() {
		return data;
	}

	/**
	 * Sets the data.
	 * 
	 * @param data the new data
	 */
	public void setData(final T data) {
		this.data = data;
	}

}
