/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.portlet.common.constants;

import java.awt.Color;

/**
 * The Class with some constants defined.
 * 
 * @author sheyenrath
 * @version $Revision: 1.7 $, $Date: 2009/11/24 14:10:06 $
 */
public final class Defines {

	/**
	 * Instantiates a new defines.
	 */
	private Defines() {
		// Private constructor
	}

	/** The Constant FIRST_VERSION. */
	public static final String FIRST_VERSION = "1";

	/** Tag separator. */
	public static final String TAG_SEPARATOR = ",";

	/** The portal src. */
	public static final String PORTAL_SRC = "/org.tencompetence.all-portlet";

	/** The Constant EDITOR_INPUT_PARAM_NAME. */
	public static final String EDITOR_INPUT_PARAM_NAME = "editor.input";

	/** The Constant INIT_FIELDS. */
	public static final String INIT_FIELDS = "init.fields";

	/** The Constant TENCC_BACKGROUND_COLOR. */
	public static final Color TENCC_BACKGROUND_COLOR = Color.WHITE; //new Color(227, 237, 245);

	/** The Constant PROGRESS_IND_ATTAINED_COLOR. */
	public static final Color PROGRESS_IND_ATTAINED_COLOR = Color.green;

	/** The Constant PROGRESS_IND_PLANNED_COLOR. */
	public static final Color PROGRESS_IND_PLANNED_COLOR = Color.blue;

	/** The Constant PROGRESS_IND_NOT_PLANNED_COLOR. */
	public static final Color PROGRESS_IND_NOT_PLANNED_COLOR = Color.red;

	/** The Constant NORMAL_VIEW. */
	public static final String NORMAL_VIEW = "small.view";

}
