/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.portlet.common.constants;

/**
 * The Class Outcomes which defines constants.
 * @version $Revision: 1.11 $, $Date: 2009/11/24 14:10:06 $
 */
public final class Outcomes {

	private Outcomes() {
		// Empty constructor
	}

	/** The Constant ADD. */
	public static final String BACK = "BACK";

	/** The Constant ADD. */
	public static final String ADD = "ADD";

	/** The Constant EDIT. */
	public static final String EDIT = "EDIT";

	/** The Constant VIEW. */
	public static final String VIEW = "VIEW";

	/** The Constant ADD_VIEW_EDIT. */
	public static final String ADD_VIEW_EDIT = "ADD_VIEW_EDIT";
	
	/** The Constant ADD_EDIT. */
	public static final String ADD_EDIT = "ADD_EDIT";

	
	/** The Constant DELETE. */
	public static final String DELETE = "DELETE";

	/** The Constant PERMISSIONS. */
	public static final String PERMISSIONS = "PERMISSIONS";

	/** The Constant LIST_PROFILES. */
	public static final String LIST_PROFILES = "/views/modeleditor/competenceProfileList.jspx";

	/** The Constant LIST_COMPETENCES. */
	public static final String LIST_COMPETENCES = "/views/modeleditor/competenceList.jspx";

	/** The Constant LIST_SUBCOMPETENCELEVELS. */
	public static final String LIST_SUBCOMPETENCELEVELS = "LIST_SUBCOMPETENCELEVELS";

	/** The Constant LIST_METACOMPETENCELEVELS. */
	public static final String LIST_METACOMPETENCELEVELS = "LIST_METACOMPETENCELEVELS";

	/** The Constant ID_SMALL_VIEW. */
	public static final String ID_SMALL_VIEW = "/views/modeleditor/smallView.jspx";
	
	/** The Constant GOAL_SMALL_VIEW. */
	public static final String GOAL_SMALL_VIEW = "/views/goaleditor/goalSmallView.jspx";

	/** The Constant PORTFOLIO_SMALL_VIEW. */
	public static final String PORTFOLIO_SMALL_VIEW = "/views/portfolio/portfolioSmallView.jspx";
	
	/** The Constant LIST_ASSESSMENT_TESTS. */
	public static final String LIST_ASSESSMENT_TESTS = "/views/qtieditor/assessmentTestList.jspx";
	
	/** The Constant LEARNINGPATH_EDIT. */
	public static final String LEARNINGPATH_EDIT = "/views/lpe/learningPathEdit.jspx";
	
	/** The Constant LEARNINGPATH_OVERVIEW. */
	public static final String LEARNINGPATH_OVERVIEW = "/views/lpe/learningPathOverview.jspx";
	
	/** The Constant LEARNINGPATH_DESIGN. */
	public static final String LEARNINGPATH_DESIGN = "/views/lpe/learningPathDesign.jspx";

	/** The Constant EVIDENCE_OVERVIEW. */
	public static final String EVIDENCE_OVERVIEW = "/views/evidence/evidenceOverview.jspx";
	
	/** The Constant EDIT_PORTFOLIO_COMPETENCE. */
	public static final String VIEW_PORTFOLIO_COMPETENCE = "/views/portfolio/portfolioCompetenceView.jspx";
	
	/** The Constant EDIT_PORTFOLIO_GOAL. */
	public static final String VIEW_PORTFOLIO_GOAL = "/views/portfolio/portfolioGoalView.jspx";
	
	/** The Constant EDIT_PORTFOLIO_EVIDENCE. */
	public static final String VIEW_PORTFOLIO_EVIDENCE = "/views/portfolio/portfolioEvidenceView.jspx";

	/** The Constant EDIT_PORTFOLIO_ACTIVITY. */
	public static final String VIEW_PORTFOLIO_ACTIVITY = "/views/portfolio/portfolioActivityView.jspx";
	
	/** The Constant EDIT_PORTFOLIO_PATH. */
	public static final String VIEW_PORTFOLIO_LEARNINGPATH = "/views/portfolio/portfolioLearningPathView.jspx";
	
	/** The Constant EDIT_PORTFOLIO_PLAN. */
	public static final String VIEW_PORTFOLIO_LEARNINGPLAN = "/views/portfolio/portfolioLearningPlanView.jspx";
	
	/** The Constant EDIT_PORTFOLIO_PROFILELEVEL. */
	public static final String VIEW_PORTFOLIO_PROFILELEVEL = "/views/portfolio/portfolioCompetenceProfileLevelView.jspx";

}
