/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.portlet.common.utils;

/**
 * @author Anton Finders
 * @version $Revision: 1.2 $, $Date: 2009/11/24 14:10:06 $
 */
public enum TENCActionKey {

	/** The constant Undefined. */
	UNDEFINED(null),
	
	/** The constant View. */
	VIEW("VIEW"),
	
	/** The constant Update. */
	UPDATE("UPDATE"),
	
	/** The constant Delete. */
	DELETE("DELETE"),
	
	/** The constant Permissions. */
	PERMISSIONS("PERMISSIONS"),
	
	/** The constant Addmap. */
	ADD_MAP("ADD_MAP"),
	
	/** The constant AddCompetence. */
	ADD_COMPETENCE("ADD_COMPETENCE"),
	
	/** The constant AddCompetenceProfile. */
	ADD_COMPETENCEPROFILE("ADD_COMPETENCE_PROFILE"),
	
	/** The constant AddCompetenceProfilelevels. */
	ADD_COMPETENCEPROFILE_LEVELS("ADD_COMPETENCE_PROFILE_LEVELS"),
	
	/** The constant ADD_LEARNINGPATH. */
	ADD_LEARNINGPATH("ADD_LEARNINGPATH"),

	/** The constant Addevidence. */
	ADD_EVIDENCE("ADD_EVIDENCE"),
	
	/** The constant Addassessmenttest. */
	ADD_ASSESSMENT_TEST("ADD_ASSESSMENT_TEST"),

	/** The constant Editassessmenttest. */
	EDIT_ASSESSMENT_TEST("EDIT_ASSESSMENT_TEST"),

	/** The constant Deleteassessmenttest. */
	DELETE_ASSESSMENT_TEST("DELETE_ASSESSMENT_TEST"),

	/** The constant Addassessmentitem. */
	ADD_ASSESSMENT_ITEM("ADD_ASSESSMENT_ITEM"),

	/** The constant Editassessmentitem. */
	EDIT_ASSESSMENT_ITEM("EDIT_ASSESSMENT_ITEM"),

	/** The constant Deleteassessmentitem. */
	DELETE_ASSESSMENT_ITEM("DELETE_ASSESSMENT_ITEM"),

	/** The constant ADD_GOAL. */
	ADD_GOAL("ADD_GOAL"),
	
	/** The constant SELECT_GOAL. */
	SELECT_GOAL("SELECT_GOAL");
	
	
	/** The action. */
	private final String action;

	/**
	 * Instantiates a new TENCActionKey.
	 * 
	 * @param value
	 *            the value
	 */
	TENCActionKey(final String value) {
		this.action = value;
	}

	/**
	 * Gets the action.
	 * 
	 * @return the action
	 */
	public String getAction() {
		return action;
	}
}