/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.portlet.modeleditor.beans;

import org.tencompetence.generated.model.CompetenceMap;
import org.tencompetence.portlet.common.components.BaseEditorBean;
import org.tencompetence.portlet.common.components.NavigationDataHolder;
import org.tencompetence.portlet.common.constants.Outcomes;
import org.tencompetence.portlet.common.utils.PortletUtils;

/**
 * The Class MainModelTabbarNavigation.
 * @version $Revision: 1.5 $, $Date: 2009/11/24 14:10:06 $
 */
public class CompetenceLevelEditNavigation {

	/**
	 * Goto profile list.
	 * 
	 * @return the string
	 */
	public String gotoSubCompetenceLevels() {
		/*  this should fill the subcompetencelevels section of the competenceleveledit.jspx*/
		setBaseEditorInput();
		resetBreadCrumbPath();
		return Outcomes.LIST_SUBCOMPETENCELEVELS;
	}

	/**
	 * Goto competence list.
	 * 
	 * @return the string
	 */
	public String gotoMetaCompetenceLevels() {
		setBaseEditorInput();
		resetBreadCrumbPath();
		return Outcomes.LIST_METACOMPETENCELEVELS;
	}

	private void setBaseEditorInput() {
		final CompetenceMap map = PortletUtils.getCompetenceMapByCurrentCommunity();
		BaseEditorBean.passEditorInput(map);
	}

	private void resetBreadCrumbPath() {
		final NavigationDataHolder nav = NavigationDataHolder.getInstance();
		nav.clear();
	}
}
