/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.portlet.modeleditor.common;

import java.util.List;

import org.tencompetence.generated.model.LevelValue;
import org.tencompetence.portlet.common.components.RatingComponentController;

/**
 * The Class ModelEditorRatingComponentController.
 * @version $Revision: 1.5 $, $Date: 2009/11/24 14:10:05 $
 */
public class ModelEditorRatingComponentController extends RatingComponentController {

	/**
	 * Instantiates a new model editor rating component controller.
	 * 
	 * @param levels
	 *            the levels
	 * @param assignedLevel
	 *            the assigned level
	 * @param requiredLevelId
	 *            the required level id
	 * @param editable
	 *            the editable
	 * @param large
	 *            the large
	 */
	public ModelEditorRatingComponentController(final List<LevelValue> levels, final LevelValue assignedLevel,
			final long requiredLevelId, final boolean editable, final boolean large) {
		super(levels, assignedLevel, requiredLevelId, editable, large, true);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.tencompetence.portlet.common.components.RatingComponentController#ratingComponentClicked()
	 */
	@Override
	public void ratingComponentClicked() {
	}

}
