/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.business.constants;


/**
 * Enumeration for EventType.
 * 
 * @author sheyenrath
 * @version $Revision: 1.13 $, $Date: 2009/11/27 16:19:59 $
 * @since Danube
 */
public enum EventType {

	/** The constant CREATE. */
	CREATE,

	/** The constant UPDATE. */
	UPDATE,

	/** The constant DELETE. */
	DELETE,
	
	/** The constant GOAL_SELECTED. */
	GOAL_SELECTED,

	/** The constant CREATE_VERSION. */
	CREATE_VERSION,

	/** The constant ATTAINED_COMPETENCE_LEVEL. */
	ATTAINED_COMPETENCE_LEVEL,

	/** The constant ATTAINED_TEST. */
	ATTAINED_TEST,
	
	/** The constant SUBSCRIBE. */
	SUBSCRIBE,
	
	/** The constant UNSUBSCRIBE. */
	UNSUBSCRIBE,
	
	/** The constant COMPLETE. */
	COMPLETE,
	
	/** The constant GOAL_LINKED. */
	GOAL_LINKED,

	/** The constant FILTER_OPTIONS. */
	FILTER_OPTIONS,
	
	/** The current Learning plan cursor. */
	LEARNING_PLAN_CURSOR;

}