/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.business.exceptions;

import com.liferay.portal.SystemException;

/**
 * Signals an exception of some sort has occurred while handling a service request.
 * 
 * @author Stef Heyenrath
 * @version $Id: AssessmentTestException.java,v 1.1 2009/10/28 12:59:26 sheyenrath Exp $
 * @since Danube
 */
public class AssessmentTestException extends SystemException {

	private static final long serialVersionUID = 1L;

	/**
	 * @param message
	 *            The message of the exception
	 * @param cause
	 *            The cause of the exception
	 */
	public AssessmentTestException(final String message, final Throwable cause) {
		super(message, cause);
	}

	/**
	 * @param cause
	 *            The cause of the exception
	 */
	public AssessmentTestException(final Throwable cause) {
		super(cause);
	}

	/**
	 * Constructs a <code>ServiceException</code> with <code>null</code> as its error detail message.
	 */
	public AssessmentTestException() {
		super();
	}

	/**
	 * Constructs a <code>ServiceException</code> with the specified detail message. The error message string
	 * <code>s</code> can later be retrieved by the <code>{@link java.lang.Throwable#getMessage}</code> method of class
	 * <code>java.lang.Throwable</code>.
	 * 
	 * @param s
	 *            the detail message.
	 */
	public AssessmentTestException(final String s) {
		super(s);
	}
}
