/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.business.facade;

/**
 * The Class with all constants in it.
 * 
 * @author sheyenrath
 * @version $Revision: 1.4 $, $Date: 2009/11/24 14:18:19 $
 */
public final class Constants {

	private Constants() {
		// Private constructor
	}

	/** The Constant DEFAULT_DESCRIPTION. */
	public static final String DEFAULT_DESCRIPTION = "<p>Please fill in a description.</p>";

	/** The Constant FIRST_VERSION. */
	public static final int FIRST_VERSION = 1;

	/** The Constant FIRST_VERSION_STR. */
	public static final String FIRST_VERSION_STR = "Version - " + FIRST_VERSION;

	/** The Constant SUMMARY_LENGTH. */
	public static final int SUMMARY_LENGTH = 200;

	/** The maximal length of a competence (level) title. */
	public static final int MAX_TITLE_LENGTH = 256;

	/** The Constant MAX_VERSIONTAG_LENGTH. */
	public static final int MAX_VERSIONTAG_LENGTH = 75;
}
