/*
 * Copyright (c) 2009, TENCompetence Foundation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *   - Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *   - Redistributions in binary
 *     form must reproduce the above copyright notice, this list of conditions and
 *     the following disclaimer in the documentation and/or other materials 
 *     provided with the distribution.
 *   - Neither the name of the TENCompetence Foundation nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package org.tencompetence.business.utils;

import java.util.ArrayList;
import java.util.List;

import com.liferay.counter.service.CounterLocalServiceUtil;
//import com.liferay.portal.PortalException;
//import com.liferay.portal.SystemException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.exception.PortalException;

import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.util.PortalUtil;
//import com.liferay.portlet.tags.model.TagsAsset;
//import com.liferay.portlet.tags.model.TagsEntry;
//import com.liferay.portlet.tags.service.TagsAssetLocalServiceUtil;
//import com.liferay.portlet.tags.service.TagsEntryLocalServiceUtil;

import com.liferay.portlet.asset.model.AssetTag;
import com.liferay.portlet.asset.model.AssetEntry;
import com.liferay.portlet.asset.service.AssetTagLocalServiceUtil;
import com.liferay.portlet.asset.service.AssetEntryLocalServiceUtil;

/**
 * TaggingUtils.
 * 
 * @author Teodor Stoev
 * @version $Revision: 1.2 $, $Date: 2009/11/24 14:18:19 $
 */
public final class TaggingUtilsNotYetComplete {
	private static final Log LOG = LogFactoryUtil.getLog(TaggingUtilsNotYetComplete.class);

	private TaggingUtilsNotYetComplete() {
	}

	/**
	 * Adds a string tag to a Liferay model object.
	 * 
	 * @param obj
	 *            the Liferay model object
	 * @param tagValue
	 *            the string tag
	 * 
	 * @return true / false
	 */
	
	/*
	public static boolean addTagToObject(final BaseModel<?> obj, final String tagValue) {
		final List<String> tags = getTagsOfObject(obj);
		final String[] entryNames = new String[tags.size() + 1];
		int i = 0;
		for (String tag : tags) {
			entryNames[i++] = tag;
		}

		TagsEntry newTag = null;
		try {
			newTag = getTag(EntityUtils.getGroupIdFromEntity(obj), tagValue);
		} catch (SystemException e) {
			handleError(e);
		}
		if (newTag == null) {
			newTag = createTag(tagValue);
		}
		entryNames[i] = newTag.getName();

		return updateTagsAsset(obj, entryNames);
	}
	*/

	/**
	 * Removes a string tag from a Liferay model object.
	 * 
	 * @param obj
	 *            the Liferay model object
	 * @param tagValue
	 *            the string tag
	 * 
	 * @return true / false
	 */
	/*
	public static boolean removeTagFromObject(final BaseModel<?> obj, final String tagValue) {
		List<String> tags = getTagsOfObject(obj);
		if (tags.contains(tagValue)) {
			tags.remove(tagValue);
		}
		String[] entryNames = new String[tags.size()];
		int i = 0;
		for (String tag : tags) {
			entryNames[i++] = tag;
		}

		return updateTagsAsset(obj, entryNames);
	}
	*/

	/**
	 * Gets the list of string tags of a Liferay model object.
	 * 
	 * @param obj
	 *            the Liferay model object
	 * 
	 * @return the list of strings
	 */
	/*
	public static List<String> getTagsOfObject(final BaseModel<?> obj) {
		List<String> result = new ArrayList<String>();
		try {
			TagsAsset asset = getTagsAssetForObject(obj);
			if (asset == null) {
				asset = createTagsAsset(obj);
			}
			List<TagsEntry> entries = asset.getEntries();
			for (TagsEntry entry : entries) {
				result.add(entry.getName());
			}

		} catch (SystemException e) {
			return null;
		}
		return result;
	}
	*/
	/**
	 * Handle an error. Create an log entry with the Liferay log mechanism, and throw a RuntimeException.
	 * 
	 * @param e
	 *            the error which should be handled
	 */
	/*
	protected static void handleError(final Exception e) {
		if (LOG.isErrorEnabled()) {
			LOG.error(e);
		}
		throw new RuntimeException(e);
	}
	*/
	
	/*

	private static TagsAsset getTagsAssetForObject(final BaseModel<?> obj) {
		try {

			return TagsAssetLocalServiceUtil.getAsset(obj.getClass().getName(), Long.parseLong(obj.getPrimaryKeyObj()
					.toString()));
		} catch (NumberFormatException e) {
			return null;
		} catch (PortalException e) {
			return null;
		} catch (SystemException e) {
			return null;
		}
	}
*/
	/*
	private static TagsEntry getTag(final long groupId, final String name) {
		TagsEntry result = null;
		try {
			result = TagsEntryLocalServiceUtil.getEntry(groupId, name);
		} catch (PortalException e) {
			return null;
		} catch (SystemException e) {
			return null;
		}
		return result;
	}
	*/

	/*
	private static TagsEntry createTag(final String name) {
		TagsEntry result = null;
		try {
			result = TagsEntryLocalServiceUtil.createTagsEntry(CounterLocalServiceUtil.increment());
			result.setName(name);

			TagsEntryLocalServiceUtil.addTagsEntry(result);
		} catch (SystemException e) {
			return null;
		}
		return result;
	}
	*/

	/*
	private static TagsAsset createTagsAsset(final BaseModel<?> entry) {
		TagsAsset result = null;
		try {
			result = TagsAssetLocalServiceUtil.createTagsAsset(CounterLocalServiceUtil.increment());
			result.setClassNameId(PortalUtil.getClassNameId(entry.getClass()));
			result.setClassPK(Long.parseLong(entry.getPrimaryKeyObj().toString()));

			TagsAssetLocalServiceUtil.addTagsAsset(result);
		} catch (SystemException e) {
			return null;
		}
		return result;
	}
	*/

	/*
	private static boolean updateTagsAsset(final BaseModel<?> entry, final String[] entryNames) {
		boolean result = false;
		try {
			TagsAssetLocalServiceUtil.updateAsset(EntityUtils.getUserIdFromEntity(entry), EntityUtils
					.getGroupIdFromEntity(entry), entry.getClass().getName(), Long.parseLong(entry.getPrimaryKeyObj()
					.toString()), new String[] {}, entryNames);
			result = true;
		} catch (NumberFormatException e) {
			handleError(e);
		} catch (PortalException e) {
			handleError(e);
		} catch (SystemException e) {
			handleError(e);
		}
		return result;
	}
	*/
	
}
