package adapters;

import java.io.StringWriter;
import java.util.Hashtable;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import apis.DAOUserTestCase;
import apis.UserTestCase;

public class ParameterInputAdapter {

	static String JAXP_SCHEMA_LANGUAGE = "http://java.sun.com/xml/jaxp/properties/schemaLanguage";
	static String W3C_XML_SCHEMA = "http://www.w3.org/2001/XMLSchema";

	public ParameterInputAdapter() {
	}

	public String runQtiTestuser(StringWriter result, String xml_location, Hashtable xml_container, String user,
			String form_ans, String language) {

		QtiParser qti_parser = new QtiParser(user, 0, result, xml_location, form_ans, language, xml_container);

		SAXParserFactory factory = SAXParserFactory.newInstance();
		factory.setValidating(false);
		factory.setNamespaceAware(true);

		try {
			SAXParser parser = factory.newSAXParser();
			parser.setProperty(JAXP_SCHEMA_LANGUAGE, W3C_XML_SCHEMA);

			if (xml_container.containsKey(xml_location)) {
				java.io.StringReader reader = new java.io.StringReader((String) xml_container.get(xml_location));
				org.xml.sax.InputSource source = new org.xml.sax.InputSource(reader);
				System.out.println("Initial xml parsed as content");

				parser.parse(source, qti_parser);

			} else {
				System.out
						.println("[ERROR]Initial xml not found in the xml_container Hashtable, if you want to use xml's located in URIs dont use this adapter");
				result
						.write("[ERROR]Initial xml not found in the xml_container Hashtable, if you want to use xml's located in URIs dont use this adapter");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		// OUTPUT
		return lastQuestionDoneResult(qti_parser.getUser());

	}

	public String lastQuestionDoneResult(UserTestCase user) {

		Float score = new Float(0);
		int[] done_state = { -2 };
		try {
			DAOUserTestCase daouser = new DAOUserTestCase();
			int repetition = daouser.getLastTestRepetitionState(user, done_state);

			if (done_state[0] != 1) // if there's a test which is not done and it's not a first login
				return null;

			score = daouser.getFinalScore(user);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return "<outcomeDeclaration identifier=\"SCORE\" cardinality=\"single\"" + "baseType=\"float\">" + score
				+ "</outcomeDeclaration>";
	}
}
