/*
 * Copyright (c) 2008, Consortium Board TENCompetence
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the TENCompetence nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY CONSORTIUM BOARD TENCOMPETENCE ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL CONSORTIUM BOARD TENCOMPETENCE BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package apis;

import java.sql.*;
import java.util.*;
import nb_utils.*;
import java.io.*;
import java.net.URLDecoder;

import javax.swing.text.html.HTMLDocument.Iterator;

import apis.UserTestCase.ItemStruct;
import apis.UserTestCase.ItemStructVector;

public class DAOUserTestCase extends DAO {

	private float finalScore = 0;

	/** Creates a new instance of DAOUser */
	public DAOUserTestCase() {
	}

	/* Method to save User into database */

	public void setLoginTestCase(UserTestCase user) {

		String command = "o";
		ResultSet res;
		int[] done_state = { -2 };
		int lang = getLanguageKey(user);
		int repetition = getLastTestRepetitionState(user, done_state);
		int testkey = getTestKey(user);

		if (done_state[0] == 0) // if there's a test which is not done and it's not a first login
			return;

		if (repetition == -2) // -2 means the user had never done logins before
			repetition = 0;
		else
			repetition++;

		try {
			command = "INSERT INTO login_test_case(user,test_key,run,repetition,done,uolid,language) Values ('"
					+ user.getName() + "'," + testkey + "," + user.getRun() + "," + repetition + ",'-1','"
					+ user.getUolID() + "'," + lang + ")";
			// done: [-1 = not done & never rendered] [0 = not done but rendered at least one time] [1 = done]
			setConnectionFromDAO(user.getConnectedDao());
			stmt.executeUpdate(command);
		} catch (SQLException e) {
			System.out.println("SQL Error___________ :" + command);
			e.printStackTrace();
		} finally {
			// closeConnection();
		}

	}

	public int getTestKey(UserTestCase user) {
		DAOAssessmentTest daotest = new DAOAssessmentTest();
		return daotest.getTestKey(user.getTest(), user);
	}

	public int getPage(UserTestCase user) {

		int[] done_state = { -2 };
		int repetition = this.getLastTestRepetitionState(user, done_state);

		try {
			ResultSet res;
			setConnectionFromDAO(user.getConnectedDao());
			String command = "SELECT page FROM login_test_case where test_key ='" + getTestKey(user) + "' AND user='"
					+ user.getName() + "' AND run=" + user.getRun() + " AND repetition='" + repetition + "'";
			res = stmt.executeQuery(command);
			if (res.next()) {
				return res.getInt("page");
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// closeConnection();
		}
		return 0;
	}

	public int getLanguageKey(UserTestCase user) {
		try {
			ResultSet res;
			setConnectionFromDAO(user.getConnectedDao());
			String command = "SELECT language_id FROM language where language ='" + user.language + "'";
			res = stmt.executeQuery(command);
			if (res.next())
				return res.getInt("language_id");
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// closeConnection();
		}
		return -1;
	}

	public int getLanguage(UserTestCase user) {
		int[] done_state = { -2 };
		int repetition = this.getLastTestRepetitionState(user, done_state);

		try {
			ResultSet res;
			setConnectionFromDAO(user.getConnectedDao());
			String command = "SELECT language FROM login_test_case where test_key ='" + getTestKey(user)
					+ "' AND user='" + user.getName() + "' AND run=" + user.getRun() + " AND repetition=" + repetition + ";";
			System.out.println(" ----- " + command);
			res = stmt.executeQuery(command);
			if (res.next()) {
				return res.getInt("language");
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// closeConnection();
		}
		return -1;
	}

	// select * from test_feedback_text where variable='correct'

	/*
	 * 
	 * INSERT INTO test_feedback_text (variable,text) values('final','Final score:')
	 */
	public String getTFtitle(UserTestCase user) {

		int lang = getLanguage(user);
		if (lang == -1)
			lang = getLanguageKey(user);
		try {
			ResultSet res;
			setConnectionFromDAO(user.getConnectedDao());
			String command = "select text from test_feedback_text where variable='title'and language='" + lang + "'";
			res = stmt.executeQuery(command);
			if (res.next()) {
				return res.getString("text");
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// closeConnection();
		}
		return "--test feedback text not found in db-getTFtitle-";
	}

	public String getTFcorrect(UserTestCase user) {
		int lang = getLanguage(user);
		if (lang == -1)
			lang = getLanguageKey(user);
		try {
			ResultSet res;
			setConnectionFromDAO(user.getConnectedDao());
			String command = "select text from test_feedback_text where variable='correct' and language='" + lang + "'";
			res = stmt.executeQuery(command);
			if (res.next()) {
				return res.getString("text");
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// closeConnection();
		}
		return "--test feedback text not found in db-getTFcorrect-";
	}

	public String getTFincorrect(UserTestCase user) {
		int lang = getLanguage(user);
		if (lang == -1)
			lang = getLanguageKey(user);
		try {
			ResultSet res;
			setConnectionFromDAO(user.getConnectedDao());
			String command = "select text from test_feedback_text where variable='incorrect'and language='" + lang
					+ "'";
			res = stmt.executeQuery(command);
			if (res.next()) {
				return res.getString("text");
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// closeConnection();
		}
		return "--test feedback text not found in db-getTFincorrect-";
	}

	public String getTFpresented(UserTestCase user) {
		int lang = getLanguage(user);
		if (lang == -1)
			lang = getLanguageKey(user);
		try {
			ResultSet res;
			setConnectionFromDAO(user.getConnectedDao());
			String command = "select text from test_feedback_text where variable='presented'and language='" + lang
					+ "'";
			res = stmt.executeQuery(command);

			if (res.next()) {
				return res.getString("text");
			}

		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// closeConnection();
		}
		return "--test feedback text not found in db-getTFpresented-";
	}

	public String getTFresponded(UserTestCase user) {
		int lang = getLanguage(user);
		if (lang == -1)
			lang = getLanguageKey(user);
		try {
			ResultSet res;
			setConnectionFromDAO(user.getConnectedDao());
			String command = "select text from test_feedback_text where variable='responded'and language='" + lang
					+ "'";
			res = stmt.executeQuery(command);
			if (res.next()) {
				return res.getString("text");
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// closeConnection();
		}
		return "--test feedback text not found in db-getTFresponded-";
	}

	public String getTFselected(UserTestCase user) {
		int lang = getLanguage(user);
		if (lang == -1)
			lang = getLanguageKey(user);
		try {
			ResultSet res;
			setConnectionFromDAO(user.getConnectedDao());
			String command = "select text from test_feedback_text where variable='selected'and language='" + lang + "'";
			res = stmt.executeQuery(command);
			if (res.next()) {
				return res.getString("text");
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// closeConnection();
		}
		return "--test feedback text not found in db-getTFselected-";
	}

	public String getTFpercentage(UserTestCase user) {
		int lang = getLanguage(user);
		if (lang == -1)
			lang = getLanguageKey(user);
		try {
			ResultSet res;
			setConnectionFromDAO(user.getConnectedDao());
			String command = "select text from test_feedback_text where variable='percentage'and language='" + lang
					+ "'";
			res = stmt.executeQuery(command);
			if (res.next()) {
				return res.getString("text");
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// closeConnection();
		}
		return "--test feedback text not found in db-getTFselected-";
	}

	public int getLastTestRepetitionState(UserTestCase user, int[] state) {
		ResultSet res;
		String mysql = "";
		Float rep_done = new Float(-1);
		Float rep_beeing_done = new Float(-1);
		Float rep_to_do = new Float(-1);
		int testkey = getTestKey(user);

		if (testkey == -1)
			return -1;

		try {

			mysql = "SELECT max(repetition) as maxi,done FROM login_test_case WHERE test_key=" + testkey
					+ " AND user='" + user.getName() + "' AND run=" + user.getRun() + " GROUP BY done";
			setConnectionFromDAO(user.getConnectedDao());
			res = stmt.executeQuery(mysql); // execute Query in database
			if (!res.next())
				return -2;

			do {
				if (1 == res.getInt("done"))
					rep_done = Float.parseFloat(res.getString("maxi"));
				if (0 == res.getInt("done"))
					rep_beeing_done = Float.parseFloat(res.getString("maxi"));
				if (-1 == res.getInt("done"))
					rep_to_do = Float.parseFloat(res.getString("maxi"));

			} while (res.next());

			if (rep_done > rep_beeing_done && rep_done > rep_to_do) { // ( presenting results)
				state[0] = 1;
				return rep_done.intValue();
			}

			if (rep_beeing_done > rep_done && rep_beeing_done > rep_to_do) { // ( first test || between done and
				// beeing_done
				state[0] = 0;
				return rep_beeing_done.intValue();
			}

			if (rep_to_do > rep_beeing_done && rep_to_do > rep_done) { // ( first test || between done and beeing_done
				state[0] = -1;
				return rep_to_do.intValue();
			}

			System.out.println("Error getting state rep_to_do:"+rep_to_do+"  rep_beeing_done:"+rep_beeing_done+"  rep_done:"+rep_done );
			Exception e = new Exception();
			throw (e);

		} catch (Exception e) {
			System.out.println("Error getMaxLoginRepetition : " + mysql);
			e.printStackTrace();
			return -1;
		} finally {
			// closeConnection();
		}
	}

	public boolean setItemsToDb(UserTestCase user) {
		String mysql = "";
		int[] done_state = { -2 };
		int maxrepetition = getLastTestRepetitionState(user, done_state);
		int testkey = getTestKey(user);

		try {

			Vector processedItems = user.getItems();
			// if(testid.length()>11)testid = user.getTest().substring(user.getTest().length()-10);
			// if(itemid.length()>11)itemid = user.getItem().substring(user.getItem().length()-10);
			for (int i = 0; i < processedItems.size(); i++) {
				ItemStruct tmp = (ItemStruct) processedItems.get(i);
				if (tmp.toStore) {

					if (tmp.answer_id.size() == 1) {

						mysql = "INSERT INTO item_case(test_case,item_key,answer_key,result)\n" + "Values ( \n"
								+ "	(SELECT test_case_id FROM login_test_case WHERE user = '" + user.getName()
								+ "' AND test_key = " + testkey + " AND run = " + user.getRun() + " AND repetition= "
								+ maxrepetition + "),\n" + "	(SELECT item_key FROM assessmentitem WHERE item_id = '"
								+ tmp.item_id + "'),\n"
								+ "	(SELECT closeanswer_key FROM closeanswer WHERE closeanswer_id = '"
								+ tmp.answer_id.firstElement() + "'),\n" + "	" + tmp.score + ")\n";
						setConnectionFromDAO(user.getConnectedDao());
						stmt.executeUpdate(mysql);
					}
					if (tmp.answer_id.size() > 1) {

						mysql = "INSERT INTO item_case(test_case,item_key,result)\n" + "Values ( \n"
								+ "	(SELECT test_case_id FROM login_test_case WHERE user = '" + user.getName()
								+ "' AND test_key = " + testkey + " AND run = " + user.getRun() + " AND repetition= "
								+ maxrepetition + "),\n" + "	(SELECT item_key FROM assessmentitem WHERE item_id = '"
								+ tmp.item_id + "'),\n" + "	" + tmp.score + ")\n";

						setConnectionFromDAO(user.getConnectedDao());
						stmt.executeUpdate(mysql);

						int set_id;

						String mysql_key = "SELECT item_case_id FROM item_case \n" + "where ( \n"
								+ "	item_case.test_case = (SELECT test_case_id FROM login_test_case WHERE user = '"
								+ user.getName() + "' AND test_key = " + testkey + " AND run = " + user.getRun()
								+ " AND repetition= " + maxrepetition + ") AND \n"
								+ "	item_case.item_key = (SELECT item_key FROM assessmentitem WHERE item_id = '"
								+ tmp.item_id + "'))\n";

						ResultSet res = stmt.executeQuery(mysql_key); // execute Query in database
						res.next();

						if (res.getString("item_case_id") == null) {
							System.out.println("error obtaining primary key");
							return false;
						}

						int key = (int) Float.parseFloat(res.getString("item_case_id"));

						for (int j = 0; j < tmp.answer_id.size(); j++) {

							mysql = "INSERT INTO answer_set(set_num,answer)\n" + "Values ( \n" + "	" + key + ","
									+ "	(SELECT closeanswer_key FROM closeanswer WHERE closeanswer_id = '"
									+ tmp.answer_id.get(j) + "'))";

							stmt.executeUpdate(mysql);

						}

					}

					setLoginTestCase(user);
				}tmp.toStore = false;
			}

			return true;
		} catch (SQLException e) {
			System.out.println("Error in setUser :" + mysql);
			e.printStackTrace();
			return false;
		} finally {
			// closeConnection();
		}
	}

	public boolean checkUserTestCaseNotDone(UserTestCase user) {
		String mysql = "";
		int[] done_state = { -2 };
		int repetition = getLastTestRepetitionState(user, done_state);
		int testkey = getTestKey(user);

		if (done_state[0] != -1)
			return false;
		try {

			mysql = "UPDATE login_test_case SET done=0 WHERE user='" + user.getName() + "' AND run='" + user.getRun()
					+ "' AND repetition =" + repetition + " AND test_key=" + testkey;
			setConnectionFromDAO(user.getConnectedDao());
			stmt.executeUpdate(mysql);
			return true;

		} catch (SQLException e) {
			System.out.println("[SQL error] setUser :" + mysql);
			e.printStackTrace();
			return false;
		} finally {
			// closeConnection();
		}
	}

	public boolean setUserTestCaseDone(UserTestCase user) {
		String mysql = "";
		int[] done_state = { -2 };
		int repetition = getLastTestRepetitionState(user, done_state);
		int testkey = getTestKey(user);

		if (done_state[0] != 0) // this avoids setting a new test
			return false;
		try {

			mysql = "UPDATE login_test_case SET done=1 WHERE user='" + user.getName() + "' AND run='" + user.getRun()
					+ "' AND repetition =" + repetition + " AND test_key=" + testkey;
			setConnectionFromDAO(user.getConnectedDao());
			stmt.executeUpdate(mysql);
			return true;

		} catch (SQLException e) {
			System.out.println("[SQL error] setUser :" + mysql);
			e.printStackTrace();
			return false;
		} finally {
			// closeConnection();
		}
	}

	public boolean setUserTestCasePage(UserTestCase user, int page) {
		String mysql = "";
		int[] done_state = { -2 };
		int repetition = getLastTestRepetitionState(user, done_state);
		int testkey = getTestKey(user);

		try {

			mysql = "UPDATE login_test_case SET page='" + page + "' WHERE user='" + user.getName() + "' AND run='"
					+ user.getRun() + "' AND repetition =" + repetition + " AND test_key=" + testkey;
			setConnectionFromDAO(user.getConnectedDao());
			stmt.executeUpdate(mysql);
			return true;

		} catch (SQLException e) {
			System.out.println("[SQL error] setUser :" + mysql);
			e.printStackTrace();
			return false;
		} finally {
			// closeConnection();
		}
	}

	public int getMaxRepetition(UserTestCase user) {
		ResultSet res;
		String query = "";
		int testkey = getTestKey(user);

		int max;
		try {
			query = "SELECT max(repetition) as maxi FROM  login_test_case WHERE test_key='" + testkey + "' AND user='"
					+ user.getName() + "' AND run='" + user.getRun() + "'";
			setConnectionFromDAO(user.getConnectedDao());
			res = stmt.executeQuery(query); // execute Query in database
			res.next();

			if (res.getString("maxi") != null)
				max = (int) Float.parseFloat(res.getString("maxi"));
			else
				max = -1;
			return max;

		} catch (SQLException e) {
			System.out.println("Error getMaxRepetition : " + query);
			e.printStackTrace();
			return -1;
		} finally {
			// closeConnection();
		}
	}

	/* Method to get final Score user in one assessment test */
	public float getFinalScore(UserTestCase user) throws SQLException {
		ResultSet res;
		String mysql = "";
		try {
			int testkey = getTestKey(user);
			// mysql = "SELECT sum(Score) as sumresult FROM User WHERE AssessmentTest='"+ user.getTest()
			// +"' AND User_name='"+user.getName()+"' AND Run_id='"+user.getRun()+"' AND Repeat_ID='"+getMaxRepetition(user)+"'";
			mysql = " select sum(result) as sumresult from  item_case, login_test_case "
					+ "WHERE "
					+ // item_case.answer_key = closeanswer.closeanswer_key "+
					// "item_case.item_key = assessmentitem.item_key "+
					"item_case.test_case = login_test_case.test_case_id " + " AND login_test_case.user = '"
					+ user.getName() + "' " + "AND login_test_case.repetition = " + getMaxRepetition(user) + " "
					+ " AND login_test_case.run = " + user.getRun() + " " + " AND login_test_case.test_key = " + testkey
					+ " ";

			setConnectionFromDAO(user.getConnectedDao());
			res = stmt.executeQuery(mysql); // execute Query in database
			res.next();

			/*
			 * Paul bugfix - hypersonic has problem with returning column names with sum(*) so we assign an alias to the
			 * result - sumresult
			 */
			if (res.getString("sumresult") != null)
				finalScore = Float.parseFloat(res.getString("sumresult"));
			else
				finalScore = 0;

			return finalScore;
		} catch (SQLException e) {

			System.out.println("Error in getFinalScore: " + mysql);
			throw e;
		} finally {
			// closeConnection();
		}
	}

	public ItemStructVector getItems(UserTestCase user) throws SQLException {
		ItemStructVector vector = user.new ItemStructVector();
		ItemStruct struct;
		int testkey = getTestKey(user);
		// TODO: getMaxRepetition(user), can be optimized by beign an atrribute of user and checked only once, this
		// improve wont be necesary since there are going to be separate tables and a exam_id
		String mysql = "SELECT item_id, closeanswer_id, result "
				+ "FROM item_case, assessmentitem, closeanswer, login_test_case "
				+ "WHERE item_case.answer_key = closeanswer.closeanswer_key "
				+ "AND item_case.item_key = assessmentitem.item_key "
				+ "AND item_case.test_case = login_test_case.test_case_id " + "AND login_test_case.user = '"
				+ user.getName() + "' " + "AND login_test_case.repetition = " + getMaxRepetition(user) + " "
				+ "AND login_test_case.run = " + user.getRun() + " " + "AND login_test_case.test_key = " + testkey
				+ " ";

		try {
			setConnectionFromDAO(user.getConnectedDao());
			ResultSet res = stmt.executeQuery(mysql);
			// WHERE User_Name='"+user.getName()+"' AND Run_ID='"+user.getRun()+"'");
			Vector ans;
			while (res.next()) // resultset while
			{
				ans = new Vector();
				ans.add(res.getString("closeanswer_id"));
				struct = user.new ItemStruct(res.getString("item_id"), Float.parseFloat(res.getString("result")), ans,
						false);
				vector.add(struct);
			}
			// TODO why is the reqource closed here?
			// res.close(); // close resultset

			mysql = "SELECT item_id, closeanswer_id, result "
					+ "FROM item_case, assessmentitem, closeanswer, login_test_case, answer_set "
					+ "WHERE item_case.answer_key is NULL " + "AND item_case.item_key = assessmentitem.item_key "
					+ "AND item_case.test_case = login_test_case.test_case_id " + "AND login_test_case.user = '"
					+ user.getName() + "' " + "AND login_test_case.repetition = " + getMaxRepetition(user) + " "
					+ "AND login_test_case.run = " + user.getRun() + " " + "AND login_test_case.test_key = " + testkey
					+ " " + "AND answer_set.set_num = item_case.item_case_id "
					+ "AND answer_set.answer = closeanswer.closeanswer_key ";

			setConnectionFromDAO(user.getConnectedDao());
			ResultSet res1 = stmt.executeQuery(mysql);

			while (res1.next()) // resultset while
			{
				ans = new Vector();
				ans.add(res1.getString("closeanswer_id"));
				struct = user.new ItemStruct(res1.getString("item_id"), Float.parseFloat(res1.getString("result")),
						ans, false);
				vector.add(struct);
			}
			res1.close(); // close resultset

			return vector;
		} catch (SQLException e) {
			System.out.println("Error getItems : " + mysql);
			e.printStackTrace();
			throw e;
		} finally {
			// closeConnection();
		}

	}

}
