package apis;
import nb_utils.NBEasyXML;

/**
 * Class : Ordering 
 * 
 * Description: Specifies the rules used to arrange the child elements  of a section following selection. If no ordering
 * 				given, elements are to be ordered in the order in which they are defined.
 *	
 * Attributes : * shuffle
 * 				If true causes the order of the child elements to be randomized, if false uses 
 * 				the order in which the child elements are defined.
 * 				
 */

public class QTIv21ordering
{   
    protected QTIv2structuredBodyPart prompt;
    protected QTIv21test theTest;
    
    //--  Attributes
    protected boolean shuffle;		// shuffle [1] : boolean = false       	
    
    // CONSTRUCTOR
    public QTIv21ordering(QTIv21test owner)
    {
    	theTest = owner;
        shuffle = false;
    }
    
    // -- parse: ordering tag parsing
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {     
    	
    	//ATTRIBUTES
        if(itemXML.getAttribute(idx,"shuffle")!= null && itemXML.getAttribute(idx,"shuffle").equals("true"))
        {
        	shuffle = true;
        }
        return itemXML.findNextPeer(idx);
    }

    // -- render: renders ordering content
    public String render()
    {
        String out = "";
        return out;
    }
}
