package apis;

import java.util.Vector;
import nb_utils.NBEasyXML;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class QTIv21outcomeCondition implements QTIv2variableAction
{
    QTIv21test theTest;

    Vector ifElseParts;

    public QTIv21outcomeCondition(QTIv21test owner)
    {
        theTest = owner;
    }

    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        // outcomeCondition has no attributes
        int cidx = itemXML.findChildElement(idx);
        ifElseParts = new Vector();
        while(cidx != -1)
        {
            QTIv21outcomeIfPart ifPart = new QTIv21outcomeIfPart(theTest);
            cidx = ifPart.parse(itemXML, cidx);
            ifElseParts.add(ifPart);
        }
        return itemXML.findNextPeer(idx);  // -1 if no more peers, needs to be handled.
    }

    public boolean run() throws InvalidQTIv2Exception
    {
        boolean satisfied = false;
        int count = 0;
        while((count < ifElseParts.size())&&(!satisfied))
        {
            satisfied = ((QTIv21outcomeIfPart)ifElseParts.get(count)).doIt();
            count++;
        }
        if(satisfied)
        {
        	return false;
        }
        return true; //# is this right?
    }

}
