package apis;

import nb_utils.NBEasyXML;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class QTIv21outcomeIfPart
{
    QTIv21test theTest;

    QTIv2expression logic;
    QTIv21outcomeProcessing outActions;

    public QTIv21outcomeIfPart(QTIv21test owner)
    {
        theTest = owner;
    }

    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        int ifType = QTIv2define.identify(itemXML.getName(idx));
        assert((ifType==QTIv2define.QTIv21_outcomeIf)||(ifType==QTIv2define.QTIv21_outcomeElseIf)||(ifType==QTIv2define.QTIv21_outcomeElse));
        int cidx = itemXML.findChildElement(idx);
        
        if(ifType != QTIv2define.QTIv21_outcomeElse)
        {
            logic = QTIv2expression.parseNew(theTest, itemXML, cidx);
            cidx = itemXML.findNextPeer(cidx);
        }
        // after the expression are zero or more actions
        if(cidx != -1)
        {
            outActions= new QTIv21outcomeProcessing(theTest);
            outActions.parse(itemXML, cidx);
        }
        return itemXML.findNextPeer(idx);  // -1 if no more peers
    }

    public boolean doIt() throws InvalidQTIv2Exception
    {
        if((logic == null)||(logic.resolve().isTrue()))
        {
            if(outActions != null)
            	outActions.run();
            return true;
        }
        return false;
    }

}