package apis;

import java.util.*;

import nb_utils.NBEasyXML;

public class QTIv21outcomeProcessing {

	    QTIv21test theTest;
	    Vector outActions;

	    public QTIv21outcomeProcessing(QTIv21test owner)
	    {
	        theTest = owner;
	    }

	    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
	    {
	        outActions = new Vector();
	       
	       /* int  a = itemXML.findNextPeer(idx);
	        int b = */
	        
            int cidx =itemXML.findChildElement(idx);
      
            
	        while(cidx != -1)
	        {
	            int id = QTIv2define.identify(itemXML.getName(cidx));
	            switch(id)
	            {
	                case QTIv2define.QTIv21_outcomeCondition:
	                	QTIv21outcomeCondition oc = new QTIv21outcomeCondition(theTest);
	                    cidx = oc.parse(itemXML, cidx);
	                    outActions.add(oc);
	                    break;
	                case QTIv2define.QTIv2_setOutcomeValue:
	                	outActions.add(new QTIv2setOutcomeValue(theTest, itemXML, cidx));
	                	cidx = itemXML.findNextPeer(cidx);
	                    break;
	                case QTIv2define.QTIv21_lookupOutcomeValue:
	                	outActions.add(new QTIv21lookupOutcomeValue(theTest, itemXML, cidx));
	                	cidx = itemXML.findNextPeer(cidx);
	                    break;
	                case QTIv2define.QTIv21_exitTest:
	                	outActions.add(new ExitTest());
	                	cidx = itemXML.findNextPeer(cidx);
	                    break;
	                case QTIv2define.QTIv2_externalResponseProcessing:
	                    throw new InvalidQTIv2Exception("externalResponseProcessing is not supported by APIS.");
	                default:
	                    throw new InvalidQTIv2Exception("Unexpected "+itemXML.getName(cidx)+" in response processing.");
	            }
	        }

	        return itemXML.findNextPeer(idx);
	    }

	    public boolean run() throws InvalidQTIv2Exception
	    {
	        boolean result = true;
	        int pos = 0;
	        
	        while((pos < outActions.size())&&(result))
	        {	
	        	result=((QTIv2variableAction)outActions.get(pos)).run();     
	        	if(((QTIv2variableAction)outActions.get(pos)).getClass().getCanonicalName().equals("apis.ExitTest"))
	        	{	if(!result) theTest.continueTest=false;
	        		theTest.finishingReason = "EXIT TEST CONDITION ACCOMPLISHED";}
	        	pos++;
	        }
	        
	        return result;
	    }
	}	
