package apis;

import nb_utils.NBEasyXML;
import java.util.Vector;


public class QTIv22XHTMLBlockquote extends QTIv2structuredBodyPart
{
    String nm;
    String identifier;
 	QTIv2variableDeclaration var;
    QTIv2bodyPart tmp;
    protected int respCount;
    protected String content;
    
    protected Vector phraseOrder;
    Vector myParts;
    
    public QTIv22XHTMLBlockquote(QTIv2item owner, String id, QTIv2variableDeclaration nvar) throws
          InvalidQTIv2Exception
    {
        super(owner);    
        respCount=0;
        identifier=id;
        var=nvar;
    }
    
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
    	phraseOrder=new Vector();
    	
    	int cidx = itemXML.findChildElement(idx);
    	 
    	int depth = itemXML.getDepth(idx);
    	
    	 while(cidx != -1 && (itemXML.getDepth(cidx) > depth))
         { 
    	   int id = QTIv2define.identify(itemXML.getName(cidx));
   
           if(id == QTIv2define.QTIv2_inlineChoice)
           { 
        	      if(myParts== null)
        	    	  myParts= new Vector();
                  QTIv2bodyPart g = new QTIv22inline(theItem, itemXML.getAttribute(cidx,"identifier"), var);
                  cidx = g.parse(itemXML, cidx);
                  myParts.add(g);
                  phraseOrder.add("g");
           }else 
           {
        	   if(myParts== null)
        		   myParts= new Vector();
        	   tmp = new XHTMLPart(itemXML.getAsString(cidx), theItem);
        	   myParts.add(tmp);
        	   cidx++;
               phraseOrder.add("x");
           }
         }     
    	return super.parse( itemXML,  idx);
    }
    
 public String render(Vector partsGap) throws InvalidQTIv2Exception
 {
	    String out="";
        respCount=0;
        out+="<blockquote>";
        for(int i=0; i<phraseOrder.size();i++)
	    {
        	//render gap options
	    	if(phraseOrder.get(i).equals("g"))
	    	{
	    		out+="<select name = \""+((QTIv22inline)myParts.get(i)).nm+"_"+respCount+"\">";
	    		respCount++; // for proper response 
	    		out+=((QTIv22inline)myParts.get(i)).render();
	    	}
	    	else{ //render xhtml parts
	    		out+=((QTIv2bodyPart)myParts.get(i)).render();
	    	}
	    }	    
	            
	    return out;
    }    	
}