package apis;

import nb_utils.*;


import java.util.*;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 */

/*HeLeNa*/

public class QTIv22inlineChoiceInteraction extends QTIv2structuredBodyPart implements QTIv2responseVariableUpdate
{
    protected QTIv2structuredBodyPart prompt;
    protected Vector formNames,partsGap; // 
    protected QTIv2variableDeclaration var;

    protected String shuffleName; // variable name for persistance data.
    protected String optionList="";
    protected boolean shuffle;
    protected int respCount;
    
    QTIv2bodyPart tmp;
    protected Vector myParts;
    
    public QTIv22inlineChoiceInteraction(QTIv2item owner)
    {
        super(owner);
        owner.registerVarUpdate(this);
        shuffle = false;
        respCount=0;
    }

    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        formNames = new Vector();
        
        // is it to be shuffled?
        if(itemXML.getAttribute(idx,"shuffle").equals("true"))
        {
            shuffle = true;
        }
        var = (QTIv2variableDeclaration)(theItem.getResponseVariable(itemXML.getAttribute(idx,"responseIdentifier")));
       
        if(var==null)
            throw new InvalidQTIv2Exception("responseIdentifier "+itemXML.getAttribute(idx,"responseIdentifier")+" does not match a variable.");

        // check for a prompt, then run through the simpleChoices
     /*   int cidx = itemXML.findChildElement(idx);
        while(cidx != -1)
        { 
            int id = QTIv2define.identify(itemXML.getName(cidx));    
            switch(id)
            {
            case QTIv2define.QTIv2_prompt:	
                if(prompt != null)
                    throw new InvalidQTIv2Exception("Multiple prompts in choiceInteraction");
               
                prompt = new QTIv2structuredBodyPart(theItem);
                cidx = prompt.parse(itemXML, cidx);
                
                if(cidx==-1)
                    throw new InvalidQTIv2Exception("No gapChoice following prompt gapMatchInteractionInteraction");
                break;
            /*case QTIv2define.QTIv2_gapImg :
               if(partsGap == null)
                    partsGap = new Vector();
                QTIv2gapImage gi= new QTIv2gapImage (theItem, itemXML.getAttribute(cidx,"identifier"), var);
                cidx = gi.parse(itemXML, cidx);
                if((formNames.size()==0)||(var.cardinality!=QTIv2variableDeclaration.CARD_single))
                     formNames.add(gi.nm);
                partsGap.add(gi);
            	throw new InvalidQTIv2Exception("gap IMage not tested");

          // case QTIv2define.QTIv2_gapText:
             //  if(partsGap == null)
            //	   partsGap= new Vector();
               //QTIv2gapText gt = new QTIv2gapText(theItem, itemXML.getAttribute(cidx,"identifier"), var);
               //cidx = gt.parse(itemXML, cidx);
               //partsGap.add(gt);
               //formNames.add(gt.nm+"_"+respCount);
               //respCount++;
               //break;
            case QTIv2define.XHTML_blockquote:
               if(parts == null)
                   parts = new Vector();
               QTIv22XHTMLBlockquote b = new QTIv22XHTMLBlockquote (theItem, itemXML.getAttribute(cidx,"identifier"), var);
               cidx = b.parse(itemXML, cidx);
               parts.add(b);
               break;
            default:
            	System.out.println("Gap match not implemented for id:"+ itemXML.getName(cidx) +" identified as: "+id );
            	return itemXML.findNextPeer(idx+1);
            }           		
        }*/
     
    	partsGap = new Vector();

        formNames.add(getSafeFormID(var.identifier));
  
    	int cidx = itemXML.findChildElement(idx);
    	 
    	int depth = itemXML.getDepth(idx);
    	
    	 while(cidx != -1 && (itemXML.getDepth(cidx) > depth))
         { 

    	   int id = QTIv2define.identify(itemXML.getName(cidx));
      	 	 
					          /* if(id == QTIv2define.QTIv2_gapText)
					           {
					        	   System.out.println("Insanciant inlineChoice dins blockquote");
					        	      if(myParts== null)
					        	    	  myParts= new Vector();
					                  QTIv2bodyPart g = new QTIv2gap(theItem, itemXML.getAttribute(cidx,"identifier"), var);
					                  cidx = g.parse(itemXML, cidx);
					                  myParts.add(g);
					                  phraseOrder.add("g");
					           }else if( id ==  QTIv2define.QTIv2_gapText ){
					               if(partsGap == null)
					            	   partsGap= new Vector();
						           QTIv2gapText gt = new QTIv2gapText(theItem, itemXML.getAttribute(cidx,"identifier"), var);
						           cidx = gt.parse(itemXML, cidx);
						           partsGap.add(gt);
						           formNames.add(gt.nm+"_"+respCount);
						           respCount++;
					          }else{
					        	   if(myParts== null)
					        		   myParts= new Vector();
					        	   tmp = new XHTMLPart(itemXML.getAsString(cidx), theItem);
					        	   myParts.add(tmp);
					        	   cidx++;
					               phraseOrder.add("x");
					           }*/
					        	   
        	   if(id == QTIv2define.QTIv2_inlineChoice)
               {
            	      if(myParts== null)
            	    	  myParts= new Vector();
            	      QTIv22inline g = new QTIv22inline(theItem, itemXML.getAttribute(cidx,"identifier"), var);
                      cidx = g.parse(itemXML, cidx);
                      myParts.add(g);
                    //  phraseOrder.add("g");
               }/*else // There won't be nothing else but QTIv2_inlineChoice
               {
            	   if(myParts== null)
            		   myParts= new Vector();
            	   tmp = new XHTMLPart(itemXML.getAsString(cidx), theItem);
            	   myParts.add(tmp);
            	   cidx++;
                   phraseOrder.add("x");
               }*/
        	   
         }
    	 
    	 // in order to allow printing of strings between xml elements like implementation exepects, it's types are switched to 2
    	
    	// itemXML.setType(67, 1);
    	 
    	 return super.parse( itemXML,  idx);
    }
   
    public String render() throws InvalidQTIv2Exception
    {	
      
      /*  String out = "";
        //render if prompt
        if (prompt != null){
        	out += prompt.render();}
        
        //render blockquote  with gaps & response options 
        for(int n=0; n < myParts.size(); n++)
        {
        	out+=((QTIv2bodyPart)myParts.get(n)).render();  	
        }

        return out;*/
    	
    	  String out="";
         // respCount=0;
         // out+="<blockquote>";
    	  
    		out+="<select name = \""+((QTIv22inline)myParts.get(0)).nm+"\"";
    		if(theItem.answered)          	
    			out += " disabled='on'";
    		out+=">"; 
    		//        

          for(int i=0; i<myParts.size();i++)
  	    {
          	//render gap options
  	    	/*if(phraseOrder.get(i).equals("g")) // g's and x's  wont exist because there wont be text inside an inline choiceInteractions 
  	    	{*/
  	    
  	    	
  	    		//respCount++; // for proper response 
  	    		out+=((QTIv22inline)myParts.get(i)).render();
  	    	/*}
  	    	else{ //render xhtml parts
  	    		out+=((QTIv2bodyPart)myParts.get(i)).render();
  	    	}*/
  	    }	    
          out+="</select>";
          return out;
    }

    public boolean updateFromFormData()
    {
    	for (int n = 0; n < formNames.size(); n++)
        {
            String key = (String) formNames.get(n);
            
            if (theItem.formData.containsKey(key))
                try
                {
                	var.setValue((String) theItem.formData.get(key));
                }
                catch (InvalidQTIv2Exception ex)
                {
                	ex.printStackTrace();
                	System.out.printf("Error update from form data");
                }
        }
        return false;
    }

}
   /* 
    public boolean updateFromFormData()
    {
        String key = getSafeFormID(responseIdentifier);
        if (theItem.formData.containsKey(key))
            try
            {
                String value = (String) theItem.formData.get(key);
                responseVar.setValue(value);
                // TODO: Convert to number, correct base, etc.
                if (null != stringVar)
                    stringVar.setValue(value);
            }
            catch (InvalidQTIv2Exception ex)
            {
            }
        return false;
    }*/
