package apis;

import nb_utils.NBEasyXML;
import java.util.Vector;


public class QTIv2XHTMLBlockquote extends QTIv2structuredBodyPart
{
    String nm;
    String identifier;
 	QTIv2variableDeclaration var;
    QTIv2bodyPart tmp;
    protected int respCount;
    protected String content;
    
    protected Vector phraseOrder,partsGap,formNames;
    Vector myParts;
    
    public QTIv2XHTMLBlockquote(QTIv2item owner, String id, QTIv2variableDeclaration nvar) throws
          InvalidQTIv2Exception
    {
        super(owner);    
        respCount=0;
        identifier=id;
        var=nvar;
    }
    
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
    	phraseOrder = new Vector();
    	partsGap = new Vector();
    	formNames = new Vector();
    	
    	int cidx = itemXML.findChildElement(idx);
    	 
    	int depth = itemXML.getDepth(idx);
    	
    	 while(cidx != -1 && (itemXML.getDepth(cidx) > depth))
         { 

    	   int id = QTIv2define.identify(itemXML.getName(cidx));

	 
           if(id == QTIv2define.QTIv2_gapText)
           {
        	      if(myParts== null)
        	    	  myParts= new Vector();
                  QTIv2bodyPart g = new QTIv2gap(theItem, itemXML.getAttribute(cidx,"identifier"), var);
                  cidx = g.parse(itemXML, cidx);
                  myParts.add(g);
                  phraseOrder.add("g");
           }else if( id ==  QTIv2define.QTIv2_gapText ){
               if(partsGap == null)
            	   partsGap= new Vector();
	           QTIv2gapText gt = new QTIv2gapText(theItem, itemXML.getAttribute(cidx,"identifier"), var);
	           cidx = gt.parse(itemXML, cidx);
	           partsGap.add(gt);
	           formNames.add(gt.nm+"_"+respCount);
	           respCount++;
          }else{
        	   if(myParts== null)
        		   myParts= new Vector();
        	   tmp = new XHTMLPart(itemXML.getAsString(cidx), theItem);
        	   myParts.add(tmp);
        	   cidx++;
               phraseOrder.add("x");
           }
         }     
    	return super.parse( itemXML,  idx);
    }
    
 public String render() throws InvalidQTIv2Exception
 {
	    String out="";
        respCount=0;
        out+="<blockquote>";
        for(int i=0; i<phraseOrder.size();i++)
	    {
        	//render gap options
	    	if(phraseOrder.get(i).equals("g"))
	    	{

	    		out+="<select name = \""+((QTIv2gap)myParts.get(i)).nm+"_"+respCount+"\">";
	    		respCount++; // for proper response 
	    		out+=((QTIv2gap)myParts.get(i)).render(partsGap);
	    	}
	    	else //render xhtml parts
	    		out+=((QTIv2bodyPart)myParts.get(i)).render();
	    }	    
	            
	    return out;
    }    	
}