package apis;

import nb_utils.*;
import java.util.Vector;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class QTIv2extendedTextInteraction extends QTIv2stringInteraction
{
    int maxStrings;
    protected QTIv2structuredBodyPart prompt;

    public QTIv2extendedTextInteraction(QTIv2item owner)
    {
        super(owner);
    }

    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        maxStrings = itemXML.getIntegerAttribute(idx, "maxStrings", 1);

        // Look for a prompt.  Taken from choiceInteraction.java.
        int cidx = itemXML.findChildElement(idx);
        int id = QTIv2define.identify(itemXML.getName(cidx));
        if(id == QTIv2define.QTIv2_prompt)
        {
            if(prompt != null)
                throw new InvalidQTIv2Exception("Multiple prompts in extendedTextInteraction");
            prompt = new QTIv2structuredBodyPart(theItem);
            cidx = prompt.parse(itemXML, cidx);
        }

        return super.parse(itemXML, idx);
    }
    
    public int parseLikert(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        maxStrings = itemXML.getIntegerAttribute(idx, "maxStrings", 1);

        // Look for a prompt.  Taken from choiceInteraction.java.
        int cidx = itemXML.findChildElement(idx);
        int id = QTIv2define.identify(itemXML.getName(cidx));
        if(id == QTIv2define.QTIv2_prompt)
        {
            if(prompt != null)
                throw new InvalidQTIv2Exception("Multiple prompts in extendedTextInteraction");
            prompt = new QTIv2structuredBodyPart(theItem);
            cidx = prompt.parse(itemXML, cidx);
        }

        return super.parse(itemXML, idx);
    }

    public String render() throws InvalidQTIv2Exception
    {
        String out = "";
        if (prompt != null)
            out += "<div class=\"prompt\">" + prompt.render() + "</div>";
        out += "<textarea cols=\"58\" rows=\"5\" name='" + getSafeFormID(responseIdentifier) + "'></textarea>";
        return out;
    }

}
