package apis;

import nb_utils.*;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class QTIv2feedbackSection extends QTIv2structuredBodyPart
{
    private QTIv2variableDeclaration outcome;
    private String triggerID;
    private boolean show;
    private boolean block;

    public QTIv2feedbackSection(QTIv2item owner)
    {
        super(owner);
    }     

    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        //assert((itemXML.getName(idx).equals("feedbackBlock")) ||
        //       (itemXML.getName(idx).equals("feedbackInline"))||
        //       (itemXML.getName(idx).equals("modalFeedback")));
        if(itemXML.getName(idx).equals("feedbackInline"))
            block=false;
        else
            block=true;
        //# read in attributes, and store
        triggerID = itemXML.getAttribute(idx, "identifier");
        String outID = itemXML.getAttribute(idx,"outcomeIdentifier");
        if(outID.length()==0)
            throw new InvalidQTIv2Exception("feedback section does not have an outcomeIdentifier");
        outcome = (QTIv2variableDeclaration)theItem.getOutcomeVariable(outID);
        if(outcome == null)
            throw new InvalidQTIv2Exception("outcomeVariable "+outID+" does not exist (for feedback sect.)");
        if(outcome.type != QTIv2variableDeclaration.VTYPE_identifier)
             throw new InvalidQTIv2Exception("outcomeVariable "+outID+" is wrong type for feedback sect.");
         if(itemXML.getAttribute(idx,"showHide").equals("show"))
            show = true;
        else
            show = false;
        return super.parse(itemXML, idx);
    }

    public String render() throws InvalidQTIv2Exception
    {
       String out = "";
       String rend="";
       if(block)
           rend = "<p>";
       rend += super.render();
       if(block)
           rend += "</p>";
       
        if(outcome.containsIdentifier(triggerID))
        {
            if (show)
                out = rend;
        }
       /* else
        {
            if (!show)
                out = rend;
       // }*/
        return out;
    }
    
    //LAU - UPF 

    public String getResponseId(){
    	return triggerID;
    }
    
    public boolean getShow(){
    	return show;
    }
 
}
