package apis;

import nb_utils.NBEasyXML;

//Classe Abstracte
public abstract class QTIv2gapChoice extends QTIv2structuredBodyPart 
{
    protected String nm;
    protected int matchMax;
    protected String identifier;
    QTIv2variableDeclaration var;
   
    protected QTIv2gapChoice(QTIv2item owner, String id, QTIv2variableDeclaration nvar) throws
    InvalidQTIv2Exception
    {
        super(owner);
        var = nvar;
        identifier = id;
        nm = getSafeFormID(var.identifier);
        
    }

    /** Note that subclasses must call this in their own parse methods. **/
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        //# read in attributes from the element
    	matchMax= Integer.parseInt(itemXML.getAttribute(idx, "matchMax"));

    	return super.parse(itemXML, idx);
    }   
}

class QTIv2gapText extends QTIv2gapChoice 
{
	  public QTIv2gapText (QTIv2item owner, String id, QTIv2variableDeclaration nvar)throws
	    InvalidQTIv2Exception
	   {
	        super(owner, id, nvar);
	   }
	  	//renders list options 
	    public String render()  throws InvalidQTIv2Exception
	    {
	    	 String out = "";
	    	 //nm: apisa_RESPONSE value: W/Sp....(identifiers)
	         out+=super.render();
	    	 //out += "name='" + nm + "' value='" + getSafeIdent(identifier) + "'\">"+super.render();
	         return out;
	    }
}

///// NOT TESTED!
class QTIv2gapImage extends QTIv2gapChoice
{
	  public QTIv2gapImage (QTIv2item owner, String id, QTIv2variableDeclaration nvar)throws
	    InvalidQTIv2Exception
	   {
	        super(owner, id, nvar);
	   }
	  
	    public String render()  throws InvalidQTIv2Exception
	    {
	        return  super.render();
	    }    
}
