package apis;

import nb_utils.*;


import java.util.*;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 */

/*HeLeNa*/

public class QTIv2gapMatchInteraction extends QTIv2structuredBodyPart implements QTIv2responseVariableUpdate
{
    protected QTIv2structuredBodyPart prompt;
    protected Vector formNames,partsGap; // 
    protected QTIv2variableDeclaration var;

    protected String shuffleName; // variable name for persistance data.
    protected String optionList="";
    protected boolean shuffle;
    protected int respCount;
    
    QTIv2bodyPart tmp;
    protected Vector phraseOrder,myParts;
    
    
    public QTIv2gapMatchInteraction(QTIv2item owner)
    {
        super(owner);
        owner.registerVarUpdate(this);
        shuffle = false;
        respCount=0;
    }

    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        formNames = new Vector();
        
        // is it to be shuffled?
        if(itemXML.getAttribute(idx,"shuffle").equals("true"))
        {
            shuffle = true;
        }
        
        System.out.printf("RESP IDENFTIFIE: "+itemXML.getAttribute(idx,"responseIdentifier"));
        var = (QTIv2variableDeclaration)(theItem.getResponseVariable(itemXML.getAttribute(idx,"responseIdentifier")));
       
        if(var==null)
            throw new InvalidQTIv2Exception("responseIdentifier "+itemXML.getAttribute(idx,"responseIdentifier")+" does not match a variable.");

        // check for a prompt, then run through the simpleChoices
        int cidx = itemXML.findChildElement(idx);
      //  while(cidx != -1)
       // { 
           /* int id = QTIv2define.identify(itemXML.getName(cidx));    
        	System.out.println("parsing gapmatch:"+itemXML.getName(cidx)+" id:"+id);
           switch(id)
            {
            case QTIv2define.QTIv2_prompt:	
                if(prompt != null)
                    throw new InvalidQTIv2Exception("Multiple prompts in choiceInteraction");
               
                prompt = new QTIv2structuredBodyPart(theItem);
                cidx = prompt.parse(itemXML, cidx);
                
                if(cidx==-1)
                    throw new InvalidQTIv2Exception("No gapChoice following prompt gapMatchInteractionInteraction");
                break;
            case QTIv2define.QTIv2_gapImg :
               if(partsGap == null)
                    partsGap = new Vector();
                QTIv2gapImage gi= new QTIv2gapImage (theItem, itemXML.getAttribute(cidx,"identifier"), var);
                cidx = gi.parse(itemXML, cidx);
                if((formNames.size()==0)||(var.cardinality!=QTIv2variableDeclaration.CARD_single))
                     formNames.add(gi.nm);
                partsGap.add(gi);
            	throw new InvalidQTIv2Exception("gap IMage not tested");

           case QTIv2define.QTIv2_gapText:
               if(partsGap == null)
            	   partsGap= new Vector();
               QTIv2gapText gt = new QTIv2gapText(theItem, itemXML.getAttribute(cidx,"identifier"), var);
               cidx = gt.parse(itemXML, cidx);
               partsGap.add(gt);
               formNames.add(gt.nm+"_"+respCount);
               respCount++;
               break;
            case QTIv2define.XHTML_blockquote:
             /*  if(parts == null)
                   parts = new Vector();
               //System.out.println("[LAU] blockquote: "+itemXML.getAttribute(cidx,"identifier"));
               QTIv2XHTMLBlockquote b = new QTIv2XHTMLBlockquote (theItem, itemXML.getAttribute(cidx,"identifier"), var);
               cidx = b.parse(itemXML, cidx);
               parts.add(b);
            /*   break;
            default:
            	System.out.println("Gap match not implemented for id:"+ itemXML.getName(cidx) +" identified as: "+id );
            	return itemXML.findNextPeer(idx+1);
            }           		
        }*/
        //return itemXML.findNextPeer(idx);
    	
    	
       	phraseOrder = new Vector();
    	partsGap = new Vector();
    	formNames = new Vector();
    	
    	 
    	int depth = itemXML.getDepth(idx);
    	
    	 while(cidx != -1 && (itemXML.getDepth(cidx) > depth))
         { 

    	   int id = QTIv2define.identify(itemXML.getName(cidx));
      	   //System.out.println("[LAU] Block id:"+ itemXML.getName(cidx)+ " __ " + QTIv2define.QTIv2_inlineChoice );
        	 
           if(id == QTIv2define.QTIv2_gapText)
           {
        	   System.out.println("Insanciant inlineChoice dins blockquote");
        	      if(myParts== null)
        	    	  myParts= new Vector();
                  QTIv2bodyPart g = new QTIv2gap(theItem, itemXML.getAttribute(cidx,"identifier"), var);
                  cidx = g.parse(itemXML, cidx);
                  myParts.add(g);
                  phraseOrder.add("g");
           }else if( id ==  QTIv2define.QTIv2_gapText ){
               if(partsGap == null)
            	   partsGap= new Vector();
	           QTIv2gapText gt = new QTIv2gapText(theItem, itemXML.getAttribute(cidx,"identifier"), var);
	           cidx = gt.parse(itemXML, cidx);
	           partsGap.add(gt);
	           formNames.add(gt.nm+"_"+respCount);
	           respCount++;
          }else{
        	   if(myParts== null)
        		   myParts= new Vector();
        	   tmp = new XHTMLPart(itemXML.getAsString(cidx), theItem);
        	   myParts.add(tmp);
        	   cidx++;
               phraseOrder.add("x");
           }
         }     
    	return super.parse( itemXML,  idx);
    	
    }
   
    public String render() throws InvalidQTIv2Exception
    {	
    	/*	String out ="";
    	//render if prompt
        if (prompt != null){
        	out += prompt.render();}
        
        //render blockquote  with gaps & response options 
        for(int n=0; n < parts.size(); n++)
        {
        	out+=((QTIv2XHTMLBlockquote)parts.get(n)).render();  	
        }

        return out;*/
        
        String out="";
        respCount=0;
        out+="<blockquote>";
        for(int i=0; i<phraseOrder.size();i++)
	    {
        	//render gap options
	    	if(phraseOrder.get(i).equals("g"))
	    	{
	    		out+="<select name = \""+((QTIv2gap)myParts.get(i)).nm+"_"+respCount+"\">";
	    		respCount++; // for proper response 
	    		out+=((QTIv2gap)myParts.get(i)).render(partsGap);
	    	}
	    	else //render xhtml parts
	    		out+=((QTIv2bodyPart)myParts.get(i)).render();
	    }	    
	            
	    return out;
    }

    public boolean updateFromFormData()
    {
    	
    	for (int n = 0; n < formNames.size(); n++)
        {
            String key = (String) formNames.get(n);
          
            if (theItem.formData.containsKey(key))
                try
                {
                  var.setValue((String) theItem.formData.get(key));
                }
                catch (InvalidQTIv2Exception ex)
                {
                }
        }
        return false;
    }

}
