package apis;


import nb_utils.*;
import java.util.Vector;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2itemBody extends QTIv2structuredBodyPart
{
    QTIv2item owner; //# to be removed, BodyPart::theItem replaces it now

    public QTIv2itemBody(QTIv2item item)
    {
        super(item);
        owner = item;
    }

    public String render() throws InvalidQTIv2Exception
    {
        //assert(parts != null);
        //if(!(parts != null)) throw new InvalidQTIv2Exception("assert failure");
        String out = "";
        QTIv2bodyPart tmp;
        for(int n=0; n < parts.size(); n++)
        {
            tmp = (QTIv2bodyPart)parts.get(n);
            out += tmp.render();
        }
        return out;
    }

    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
    	String classType = itemXML.getAttribute(idx, "class");
    	if (classType != null)
    	{
    		if (classType.equals("likert"))
    		{
    			return super.parseLikert(itemXML, idx);
    		}
    		else
    		{
    			return super.parse(itemXML, idx);
    		}
    	}
    	else
    	{
    		return super.parse(itemXML, idx);
    	}
    }
}

