
package apis;

import nb_utils.*;
import java.util.Vector;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Company: Universitat Pompeu Fabra/JISC</p>
 * @author Helena Batlle Delgado
 * @version 1.0
 */

public class QTIv2rubricBlock 
{
	protected Vector views = new Vector();
	protected Vector user= new Vector();
	protected String viewer;
	
	protected QTIv21test theTest;
	protected QTIv2item theItem21;
	protected QTIv2item theItem;
	protected Vector parts;
	protected String content;

	public QTIv2rubricBlock(QTIv2item owner)
	{		
		theItem = owner;
		views.add("author");
		views.add("candidate");
		views.add("proctor");
		views.add("invigilator");
		views.add("scorer");
		views.add("tutor");
		user.add("candidate");
		user.add ("author");
		content="";
	}	

	public QTIv2rubricBlock(QTIv21test owner)
	{		
		theTest = owner;
		views.add("author");
		views.add("candidate");
		views.add("proctor");
		views.add("invigilator");
		views.add("scorer");
		views.add("tutor");
		user.add("candidate");
		user.add ("author");
		content="";
	}
	
	public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
	{
		int i=0;
		
		viewer=itemXML.getAttribute(idx,"view");	    	    
		
		//proving that it's a valid view value   
		for (i=0; i< views.size();i++){
			if(((views.get(i)).equals(viewer)))
					break; }
		
		//if there is no match -> throw an Exception
		if(i==views.size())
			throw new InvalidQTIv2Exception(viewer+" it's not a correct type of 'user' ");
			
	   int position = idx +1;
	   
	   int id = QTIv2define.identify(itemXML.getName(position));
	   while(id ==-1)
	   {
		   content+=itemXML.getAsString(position);
		   position++;
		   id = QTIv2define.identify(itemXML.getName(position));
	   }
	   
	   return itemXML.findNextPeer(idx);
 	}

	public String render()
	{
		//	to render something, we must be sure that the user is  allowed to see it.
		String out="";

		for (int j=0;j<user.size();j++)   
		{
			if(user.get(j).equals(viewer))
			{	
				out+=content;
				break;
			}
	    }
	    return out;
	}
}

