package apis;

import nb_utils.NBEasyXML;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class QTIv2setOutcomeValue
      implements QTIv2variableAction
{
    QTIv2item theItem;
    QTIv21test theTest;
    QTIv2expression expr;
    String identifier;

    public QTIv2setOutcomeValue(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        
    	theItem = owner;
        identifier = itemXML.getAttribute(idx,"identifier");
        int exidx =  itemXML.findChildElement(idx);
        if(exidx==-1)
            throw new InvalidQTIv2Exception("setOutcomeValue must contain an expression.");
        expr = QTIv2expression.parseNew(theItem, itemXML, exidx);
        if(expr==null)
              throw new InvalidQTIv2Exception("setOutcomeValue must contain an expression.");

    }

    public QTIv2setOutcomeValue(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        theTest = owner;
        identifier = itemXML.getAttribute(idx,"identifier");
        int exidx =  itemXML.findChildElement(idx);
        if(exidx==-1)
            throw new InvalidQTIv2Exception("setOutcomeValue must contain an expression.");
        expr = QTIv2expression.parseNew(theTest, itemXML, exidx);
        if(expr==null)
              throw new InvalidQTIv2Exception("setOutcomeValue must contain an expression.");

    }

    public boolean run() throws InvalidQTIv2Exception
    {
    	if(theItem==null)
    		theTest.setOutcomeVariable(identifier, expr.resolve());
    	else if (theTest == null)
    		theItem.setOutcomeVariable(identifier, expr.resolve());
        return true;
    }

}
