package apis;

import nb_utils.NBEasyXML;
import java.sql.*;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class QTIv2simpleChoice extends QTIv2structuredBodyPart
{
    String nm;
    String identifier;
    int card;
 	QTIv2variableDeclaration var;
    protected boolean fixed;
    protected boolean isLikert;
    
    public QTIv2simpleChoice(QTIv2item owner, String id, QTIv2variableDeclaration nvar) throws
          InvalidQTIv2Exception
    {
        super(owner);
        
        var = nvar;
        card = var.cardinality;
        identifier = id;
        nm = getSafeFormID(var.identifier); 
        isLikert = false;
    }
    
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
    	isLikert = false;
    	
    	   if((itemXML.getAttribute(idx,"fixed")!= null )&&(itemXML.getAttribute(idx,"fixed").equals("true")))
           {
    		   fixed=true;
           }
    	   return super.parse(itemXML, idx);
    }
    
    public int parseLikert(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
    	isLikert = true;
    	
    	   if((itemXML.getAttribute(idx,"fixed")!= null )&&(itemXML.getAttribute(idx,"fixed").equals("true")))
           {
    		   fixed=true;
           }
    	   return super.parse(itemXML, idx);
    }
    
    public String render(int respCount) throws InvalidQTIv2Exception
    {
        //LAU - UPF
        try{
          DAOCloseAnswer daocloseanswer = new DAOCloseAnswer();
        
        	//[refactor]tmpdao.setResponseContext( getSafeIdent(identifier),context);
        	daocloseanswer.setCloseAnswer( getSafeIdent(identifier),super.render(),this.theItem.theTest.getUser());
        }catch(SQLException e){
        	e.printStackTrace();
        }
        
        if (isLikert)
        {
        	return renderLikert(respCount);
        }
        else
        {
        	return renderChoice(respCount);
        }
    }
    
    public String renderChoice(int respCount) throws InvalidQTIv2Exception
    {
   
        String out = "<p>";
        if (card == QTIv2variableDeclaration.CARD_single)
        {
        	out += "<input type='radio' ";
        	out += "name='" + nm+"_0" + "' value='" + getSafeIdent(identifier) + "'";
        }
        else if(card == QTIv2variableDeclaration.CARD_multiple)
        {
        	out += "<input type='checkbox' ";
        	out += "name='" + nm+"_"+ respCount+ "' value='" + getSafeIdent(identifier) + "'";
        }
        else if(card == QTIv2variableDeclaration.CARD_ordered)
        { 	
        	return super.render();
        }
        if(theItem.answered)
        	out += " disabled='on'";

        if(var.containsIdentifier(identifier))
            out += " checked='on'";
        out += "/>";
        
        out += super.render();
        out += "</p>";
        return out;
    }
    
    public String renderLikert(int respCount) throws InvalidQTIv2Exception
    {
   
        String out = "";
        if (card == QTIv2variableDeclaration.CARD_single)
        {
        	out += "<input type='radio' ";
        	out += "name='" + nm+"_0" + "' value='" + getSafeIdent(identifier) + "'";
        }
        else if(card == QTIv2variableDeclaration.CARD_multiple)
        {
        	out += "<input type='checkbox' ";
        	out += "name='" + nm+"_"+ respCount+ "' value='" + getSafeIdent(identifier) + "'";
        }
        else if(card == QTIv2variableDeclaration.CARD_ordered)
        { 	
        	return super.render();
        }
        
        if(var.containsIdentifier(identifier))
            out += " checked='on'";
        
        if(theItem.answered)
        	out += " disabled='on'";
        
        out += "/>";
        out += super.render();
        
        return out;
    }

}
