package apis;

import java.util.Vector;

import nb_utils.NBEasyXML;


/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class QTIv2simpleMatchSet extends QTIv2structuredBodyPart
{
    String nm;
    String identifier;
    int card;
    int count;
 	QTIv2variableDeclaration var;
    
    
    public QTIv2simpleMatchSet (QTIv2item owner, String id, QTIv2variableDeclaration nvar) throws
          InvalidQTIv2Exception
    {
        super(owner);
        var = nvar;
        identifier = id;
        nm = getSafeFormID(var.identifier);  
        count=0;
    }
    
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        
    	int cidx = itemXML.findChildElement(idx);
        
        while(cidx != -1)
        {
   
    	   int id = QTIv2define.identify(itemXML.getName(cidx));  
    	   
    	   if(id == QTIv2define.QTIv2_simpleAssociableChoice)
           {
    	       if(parts == null)
                   parts = new Vector();
        
    		   QTIv2simpleAssociableChoice sac=new QTIv2simpleAssociableChoice(theItem, itemXML.getAttribute(cidx,"identifier"), var);
    		   cidx = sac.parse(itemXML, cidx);
    		   parts.add(sac); 
           }
        }
       return itemXML.findNextPeer(idx);
    }
      
    public String renderSource() throws InvalidQTIv2Exception
    {
        String out = "<p>";
        
        for(int n=0; n < parts.size(); n++)
        {
            out += "<td>"+((QTIv2simpleAssociableChoice)parts.get(n)).render()+"</td>";
        }
        
        out += "</p>";
        	
        return out;
    }
    public String renderDest(QTIv2simpleMatchSet partSource) throws InvalidQTIv2Exception
    {
    	QTIv2simpleAssociableChoice auxDest ;
    	QTIv2simpleAssociableChoice auxSource ;
    	
    	
        String out = "<p>";
        for(int i=0; i < parts.size(); i++)
        {
           auxDest=((QTIv2simpleAssociableChoice)parts.get(i));
           out += "<tr><td>"+auxDest.render()+"</td>";
           
 
           for(int j=0;j<(partSource.parts).size();j++ )
        	{ 
        	   // creem valor i nom de cadascun dels checkboxes per despres poder identificar la resposta correctament 
        	   auxSource=((QTIv2simpleAssociableChoice)partSource.parts.get(j));
        	   out+="<td><input type=\"radio\" name='" + auxSource.nm+"_"+j+"' value='" + auxSource.identifier+" "+ auxDest.identifier+"'/></td>";
        	}
        	out+="</tr>";
        }
        out+="</p>";
        return out;
    }


}