package apis;

import nb_utils.*;
//import java.util.Vector;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Company: Universitat Pompeu Fabra</p>
 * @author Helena Batlle Delgado
 * @version 1.0
 */



public class QTIv2sliderInteraction extends QTIv2structuredBodyPart implements QTIv2responseVariableUpdate
{   
   
    protected QTIv2structuredBodyPart prompt;
    protected QTIv2variableDeclaration var;

    //--  Attributes
    protected int lowerBound=0; //limit inferior. Si Float -> rounded a int
    protected int upperBound=0; //limit superior. Si Float -> rounded a int	
    protected int step=1; 	//salt entre opcio o opcio, per defecte = 1 
    protected String orientation= "horizontal"; //orientacio de l'slider , per defecte horitzontal
    protected boolean stepLabel=false;
    protected boolean reverse=false;
    
    public QTIv2sliderInteraction(QTIv2item owner)
    {
        super(owner);
        owner.registerVarUpdate(this);
        stepLabel = false;
        reverse = false;
    }
    
    // <sliderInteraction responseIdentifier="RESPONSE" lowerBound="0" upperBound="100" step="1" stepLabel="false">
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {     
        //lowerBound (fem arrodoniment en cas que sigui float) [1]
        lowerBound = (int)Math.round(Float.parseFloat(itemXML.getAttribute(idx,"lowerBound")));
        
        //upperBound (fem arrodoniment en cas que sigui float) [1]
        upperBound = (int)Math.round(Float.parseFloat(itemXML.getAttribute(idx,"upperBound")));
        
        //stepLabel? [0..1]
        if((itemXML.getAttribute(idx,"stepLabel")!=null ) && (itemXML.getAttribute(idx,"stepLabel").equals("true")))
        {
            stepLabel= true;
        }
        
        //reverse ? [0..1]
        if((itemXML.getAttribute(idx,"reverse")!=null)&& (itemXML.getAttribute(idx,"reverse").equals("true")))
        {
        		reverse=true;
        }
        //orientation [0..1]
        if((itemXML.getAttribute(idx,"orientation")!=null)&& (itemXML.getAttribute(idx,"orientation").equals("vertical")))
        {
        	orientation="vertical";
        }
        
        //step [0..1]
        if(itemXML.getAttribute(idx,"step")!=null)
        {
        	step= Integer.parseInt(itemXML.getAttribute(idx,"step"));
        }
        
        //reponseIdentifier i variable relacionada
        var = (QTIv2variableDeclaration)(theItem.getResponseVariable(itemXML.getAttribute(idx,"responseIdentifier")));
      
        if(var==null)
            throw new InvalidQTIv2Exception("responseIdentifier "+itemXML.getAttribute(idx,"responseIdentifier")+" does not match a variable.");
     
        // Prompt?
        int cidx = itemXML.findChildElement(idx);
        while(cidx != -1)
        {
            int id = QTIv2define.identify(itemXML.getName(cidx));
            if(id == QTIv2define.QTIv2_prompt)
            {
                if(prompt != null)
                    throw new InvalidQTIv2Exception("Multiple prompts in choiceInteraction");
                prompt = new QTIv2structuredBodyPart(theItem);
                cidx = prompt.parse(itemXML, cidx);
                }
        }
        
        return itemXML.findNextPeer(idx);
    }

    public String render() throws InvalidQTIv2Exception
    {
        String out = "";
       
        if (prompt != null)
            out += prompt.render();

        // Slider FROM http://carpe.ambiprospect.com/slider/
        //Horitzontal
        out+=("<link href=\"includes/default.css\" rel=\"stylesheet\" type=\"text/css\"/>\r\n");
        out+=("<script type=\"text/javascript\" src=\"includes/js/slider.js\"></script>\r\n");
        
       // out+="<br><br><br><table width='90%' align=\"center\"><tr><td>";
                        
       /* if(orientation.equals("horizontal"))
        {
        out+="<div class=\"carpe_horizontal_slider_display_combo\">" +
        	 " <div class=\"carpe_horizontal_slider_track\" style=\"background-color: #bdb; border-color: #ded #9a9 #9a9 #ded;\">" +
        			" <div class=\"carpe_slider_slit\" style=\"background-color: #232; border-color: #9a9 #ded #ded #9a9;\">&nbsp;</div>" +
        			" <!-- Default position: 50px -->" +
        			"<div class=\"carpe_slider\" " +
        				"id=\"slider4\" " +
        				" display=\"display4\" " +
        				"style=\"left: 50px; background-color: #696; border-color: #9c9 #363 #363 #9c9;\">&nbsp;" +
        		    "</div>" +
        	    "</div>" +
        		"<div class=\"carpe_slider_display_holder\" style=\"background-color: #bdb; border-color: #ded #9a9 #9a9 #ded;\">" +
        		" <!-- Default value:lowerBound -->" +
        			" <input class=\"carpe_slider_display\" " +
        				" id=\"display4\" " +
        				"style=\"background-color: #bdb; color: #363;\"" +
        				" type=\"text\" from=\""+lowerBound+"\" to=\""+upperBound+"\" " +
        				"valuecount=\""+upperBound/step+"\" " +
        				"decimals=\"1\" " +
        				"value=\""+lowerBound+"\" />" + // q comenci amb l'indicador posat al lowerBound
        		"</div>" +
        	"</div>" +
        "</td></tr><tr><td><b> <div align=\"center\">range ["+ lowerBound +" -"+ upperBound+"]</div></b></td></tr></table></br></br></br>";
        }
        else if(orientation.equals("vertical"))
        {//vertical
        out+="<div  class=\"carpe_slider_group\" > " +
        		"<div class=\"carpe_vertical_slider_display_combo\">" +
        		" <div class=\"carpe_vertical_slider_track\" style=\"background-color: #bdb; border-color: #ded #9a9 #9a9 #ded;\">" +
        			"<div class=\"carpe_slider_slit\" style=\"background-color: #232; border-color: #9a9 #ded #ded #9a9;\">&nbsp;</div>" +
        			"<!-- Default position: 67px (33px from the bottom) -->" +
        			"<div" +
        				"	class=\"carpe_slider\"" +
        				"	id=\"slider5\"" +
        				" 	orientation=\"vertical\"" +
        				" 	display=\"display5\"" +
        				"   style=\"top: 67px; background-color: #696; border-color: #9c9 #363 #363 #9c9;\">&nbsp;</div>" +
        			"</div>" +
        		"</div>" +
        		"<div class=\"carpe_slider_display_holder\" style=\"background-color: #bdb; border-color: #ded #9a9 #9a9 #ded;\">" +
        			"<!-- Default value:lowerBound -->" +
        				"<input class=\"carpe_slider_display\" " +
        				"id=\"display5\"" +
        				" style=\"background-color: #bdb; color: #363;\"" +
        				" type=\"text\" from=\""+lowerBound+"\" to=\""+upperBound+"\" valuecount=\""+upperBound/step+"\" decimals=\"1\" value=\""+lowerBound+"\" typelock=\"off\" />" +
        		"</div>" +
        	"</div>" +
        "</td></tr><tr><td><div>range ["+lowerBound+"-"+upperBound+"]</div></td></tr></table></br></br></br>";       
        }*/
        out+="<div class=\"carpe_horizontal_slider_track\">"+
        "   <div class=\"carpe_slider_slit\">&nbsp;</div>"+
        "  <div class=\"carpe_slider\""+
         "    id=\"your_slider_id\""+
          "    orientation=\"horizontal\""+
           "   distance=\"100\""+
            "  display=\"your_display_id\""+
             " style=\"left: 0px;\">&nbsp;</div>"+
      "</div>\"\"";
        return out;
    }

    public boolean updateFromFormData()
    {
    	
        return false;
    }
}
