package apis;

import nb_utils.*;
import java.util.*;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class QTIv2structuredBodyPart
      extends QTIv2bodyPart
{
    Vector parts;

    public QTIv2structuredBodyPart(QTIv2item owner)
    {
        super(owner);
    }

    // this was originally copied from QTIv2ItemBody - refactored now to make QTIv2ItemBody inherit from this
    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        QTIv2bodyPart tmp;

    	QTIv2rubricBlock rb;
    	boolean inXHTML = false;
        String tmpXHTML = "";
        int depth = itemXML.getDepth(idx);
        
        parts = new Vector();
        int position = idx + 1; 
      /*  if(idx == 50){
        	System.out.println("Structured body part:");
        	for(int k=51;k<103;k++){
        		System.out.println("["+k+"]"+itemXML.getAsString(k));
        	}
        	System.out.println("----------------------");
        }
        
        if(idx == 50) System.out.println("------TRACE---------");*/
        
        while ((position != -1) && (itemXML.getDepth(position) > depth))
        {
           int op = position; // just for checking. Should go eventually.
       /*    if(idx == 50){
        	   System.out.println("p:["+position+"]:"+itemXML.getAsString(position));
           }*/
            switch (itemXML.getType(position))
            {
                case 1:
                    int id = QTIv2define.identify(itemXML.getName(position));
                    if (id == -1) // it's XHTML (or an error in the item)
                    {
                        if (inXHTML)
                        {
                            tmpXHTML += itemXML.getAsString(position);
                            position++;
                        }
                        else
                        {
                            inXHTML = true;
                            tmpXHTML = itemXML.getAsString(position);
                            position++;
                        }
                    }
                    else
                    {
                        if (inXHTML)
                        {
                            tmp = new XHTMLPart(tmpXHTML, theItem);
                            parts.add(tmp);
                            inXHTML = false;
                        }
                        switch (id)
                        {
                            case QTIv2define.QTIv2_textEntryInteraction:
                                tmp = new QTIv2textEntryInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_choiceInteraction:
                            	tmp = new QTIv2choiceInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_extendedTextInteraction:
                            	tmp = new QTIv2extendedTextInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_feedbackInline:
                            case QTIv2define.QTIv2_feedbackBlock:
                            	tmp = new QTIv2feedbackSection(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_sliderInteraction:
                            	tmp = new QTIv2sliderInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_associateInteraction:
                            	tmp = new QTIv2associateInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            /*
                             * UPF - Javi
                             * case QTIv2define.QTIv2_rubricBlock:
                            	rb = new QTIv2rubricBlock(theItem);
                                position = rb.parse(itemXML, position);
                                parts.add(rb);
                                break;*/
                            case QTIv2define.QTIv2_orderInteraction:
                            	tmp = new QTIv2orderInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);               
                                break;
                            case QTIv2define.QTIv2_matchInteraction:
                            	tmp = new QTIv2matchInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);               
                                break;
                            case QTIv2define.QTIv2_gapMatchInteraction:
                            	tmp = new QTIv2gapMatchInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);            
                                break;
                            case QTIv2define.QTIv2_inlineChoiceInteraction:
                            	tmp = new QTIv22inlineChoiceInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);            
                                break;
                            case QTIv2define.QTIv2_customInteraction: // NOT DOCUMENTED!
                            case QTIv2define.QTIv2_drawingInteraction:
                            case QTIv2define.QTIv2_graphicAssociateInteraction:
                            case QTIv2define.QTIv2_graphicGapMatchInteraction:
                            case QTIv2define.QTIv2_graphicOrderInteraction:
                            case QTIv2define.QTIv2_hotspotInteraction:
                            case QTIv2define.QTIv2_hottextInteraction:
                            case QTIv2define.QTIv2_positionObjectStage:
                            case QTIv2define.QTIv2_selectPointInteraction:
                            case QTIv2define.QTIv2_uploadInteraction:
                            	System.out.println(" *******not implemented structured body part *****");
                                tmp = new InfoPart(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.XHTML_img:
                            case QTIv2define.XHTML_object:
                            	tmp = new QTIv2XHTMLobject(theItem, id);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            }
                    }
                    break;
                case 2:
                    id = QTIv2define.identify(itemXML.getName(position));
                    if (id == -1)
                    {
                        if (inXHTML)
                        {
                            tmpXHTML += itemXML.getAsString(position);
                            position++;
                        }
                        else
                        {
                            inXHTML = true;
                            tmpXHTML = itemXML.getAsString(position);
                            position++;
                        }
                    }
                    else
                    {
                        if (inXHTML)
                        {
                            tmp = new XHTMLPart(tmpXHTML, theItem);
                            parts.add(tmp);
                            inXHTML = false;
                        }
                    }
                    break;
                case 4: // to cope with mixed content
                    if (inXHTML)
                    {
                        tmpXHTML += itemXML.getAsString(position);
                        position++;
                    }
                    else
                    {
                        tmp = new TextPart(theItem);
                        position = tmp.parse(itemXML, position);
                        parts.add(tmp);
                    }
                    break;
                default:
                    if (inXHTML)
                    {
                        tmpXHTML += itemXML.getAsString(position);
                        position++;
                    }
            }
            if (position == op) position++; // just for checking. Should go eventually.
           // if(idx == 50) System.out.print(":e:["+position+"]");
        }
        if (inXHTML)
        {
            tmp = new XHTMLPart(tmpXHTML, theItem);
            parts.add(tmp);
            inXHTML = false;
        }
        return itemXML.findNextPeer(idx); // -1 if no more peers, needs to be handled.
    }
    
 // this was originally copied from QTIv2ItemBody - refactored now to make QTIv2ItemBody inherit from this
    public int parseLikert(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        QTIv2bodyPart tmp;

    	QTIv2rubricBlock rb;
    	
        boolean inXHTML = false;
        String tmpXHTML = "";
        int depth = itemXML.getDepth(idx);
        
        parts = new Vector();
        int position = idx + 1;   
        while ((position != -1) && (itemXML.getDepth(position) > depth))
        {
           int op = position; // just for checking. Should go eventually.
            switch (itemXML.getType(position))
            {
                case 1:
                    int id = QTIv2define.identify(itemXML.getName(position));
                    if (id == -1) // it's XHTML (or an error in the item)
                    {
                        if (inXHTML)
                        {
                            tmpXHTML += itemXML.getAsString(position);
                            position++;
                        }
                        else
                        {
                            inXHTML = true;
                            tmpXHTML = itemXML.getAsString(position);
                            position++;
                        }
                    }
                    else
                    {
                        if (inXHTML)
                        {
                            tmp = new XHTMLPart(tmpXHTML, theItem);
                            parts.add(tmp);
                            inXHTML = false;
                        }
                        switch (id)
                        {
                            case QTIv2define.QTIv2_textEntryInteraction:
                                tmp = new QTIv2textEntryInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_choiceInteraction:
                            	tmp = new QTIv2choiceInteraction(theItem);
                                position = tmp.parseLikert(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_extendedTextInteraction:
                            	tmp = new QTIv2extendedTextInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_feedbackInline:
                            case QTIv2define.QTIv2_feedbackBlock:
                            	tmp = new QTIv2feedbackSection(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_sliderInteraction:
                            	tmp = new QTIv2sliderInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_associateInteraction:
                            	tmp = new QTIv2associateInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.QTIv2_rubricBlock:
                            	rb = new QTIv2rubricBlock(theItem);
                                position = rb.parse(itemXML, position);
                                parts.add(rb);
                                break;
                            case QTIv2define.QTIv2_orderInteraction:
                            	tmp = new QTIv2orderInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);               
                                break;
                            case QTIv2define.QTIv2_matchInteraction:
                            	tmp = new QTIv2matchInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);               
                                break;
                            case QTIv2define.QTIv2_gapMatchInteraction:
                            	tmp = new QTIv2gapMatchInteraction(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);            
                                break;
                            case QTIv2define.QTIv2_customInteraction: // NOT DOCUMENTED!
                            case QTIv2define.QTIv2_drawingInteraction:
                            case QTIv2define.QTIv2_graphicAssociateInteraction:
                            case QTIv2define.QTIv2_graphicGapMatchInteraction:
                            case QTIv2define.QTIv2_graphicOrderInteraction:
                            case QTIv2define.QTIv2_hotspotInteraction:
                            case QTIv2define.QTIv2_hottextInteraction:
                            case QTIv2define.QTIv2_positionObjectStage:
                            case QTIv2define.QTIv2_selectPointInteraction:
                            case QTIv2define.QTIv2_uploadInteraction:
                            	System.out.println(" *******not implemented structured body part *****");
                                tmp = new InfoPart(theItem);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            case QTIv2define.XHTML_img:
                            case QTIv2define.XHTML_object:
                            	tmp = new QTIv2XHTMLobject(theItem, id);
                                position = tmp.parse(itemXML, position);
                                parts.add(tmp);
                                break;
                            }
                    }
                    break;
                case 2:
                    id = QTIv2define.identify(itemXML.getName(position));
                    if (id == -1)
                    {
                        if (inXHTML)
                        {
                            tmpXHTML += itemXML.getAsString(position);
                            position++;
                        }
                        else
                        {
                            inXHTML = true;
                            tmpXHTML = itemXML.getAsString(position);
                            position++;
                        }
                    }
                    else
                    {
                        if (inXHTML)
                        {
                            tmp = new XHTMLPart(tmpXHTML, theItem);
                            parts.add(tmp);
                            inXHTML = false;
                        }
                    }
                    break;
                case 4: // to cope with mixed content
                    if (inXHTML)
                    {
                        tmpXHTML += itemXML.getAsString(position);
                        position++;
                    }
                    else
                    {
                        tmp = new TextPart(theItem);
                        position = tmp.parse(itemXML, position);
                        parts.add(tmp);
                    }
                    break;
                default:
                    if (inXHTML)
                    {
                        tmpXHTML += itemXML.getAsString(position);
                        position++;
                    }
            }
            if (position == op) position++; // just for checking. Should go eventually.
        }
        if (inXHTML)
        {
            tmp = new XHTMLPart(tmpXHTML, theItem);
            parts.add(tmp);
            inXHTML = false;
        }
        return itemXML.findNextPeer(idx); // -1 if no more peers, needs to be handled.
    }
    
    public void doShuffle(Vector v, Random rgen)
    {
	    int sizev = v.size();  // size of the input vector
	    // dispose of the trivial cases first
	    if (sizev <= 1)
	        return;
	
	    Vector TempCopy = new Vector(sizev);
	    int i, j;    
	    
	    // Invariant: i elements have been selected from v
	    // and moved to TempCopy, and sizev>1
	    for (i = 0;  i < sizev - 1; i++) 
	    {
	    		
    		// generate a random integer in the range [0, sizev-i)
    		j = (int)((sizev - i) * rgen.nextFloat());
    		// nextFloat() returns a float in [0, 1]
    		if ((j >= (sizev - i)) ) // rather unlikely, but...
    			j = sizev - i - 1;
    	
	    	// so add v[j] to TempCopy, then remove it from v
	    	TempCopy.addElement(v.elementAt(j));
	    	v.removeElementAt(j);
	    }
	    // there is exactly one element left in v at this point
	    TempCopy.addElement(v.elementAt(0));
	    v.removeAllElements();
	
	    
	    // now copy the shuffled objects back to the original
	    for (i = 0; i < sizev; i++)
	        v.addElement(TempCopy.elementAt(i));
	    
    }
 
    public String render() throws InvalidQTIv2Exception
    {
    	String out = "";
        for (int n = 0; n < parts.size(); n++)
        	out += ((QTIv2bodyPart) parts.get(n)).render();	       
        return out;
    }
}
