package apis;
import java.util.Vector;
import java.net.URLEncoder;
import java.net.URLDecoder;
import java.io.*;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class apisPersistanceData
{
    Vector alldata;
    int idCounter, getCounter;

    public apisPersistanceData()
    {
        alldata = new Vector();
        idCounter = 0;
        getCounter = 0;
    }

    public String serialize()
    {
        try
        {
            String raw = "";
            for (int n = 0; n < alldata.size(); n++)
            {
                raw += ((apisPersistancePart) alldata.get(n)).name + "=";
                String tmp = ((apisPersistancePart) alldata.get(n)).data;
                tmp = URLEncoder.encode(tmp, "ISO-8859-1");
                raw += tmp;
            }
            String enc;
            enc = URLEncoder.encode(raw, "ISO-8859-1");
            return enc;
        }
        catch (UnsupportedEncodingException ex)
        {
        }
        return null;
    }

    public void serialize(String input)
    {
        try
        {
            String raw = URLDecoder.decode(input, "ISO-8859-1");
            String r[] = raw.split("&");
            for(int n=0; n < r.length; n++)
            {
                String r2[] = r[n].split("=",2);
                apisPersistancePart tmp = new apisPersistancePart(r2[0],URLDecoder.decode(r2[1], "ISO-8859-1"));
                alldata.add(tmp);
            }
        }
        catch (UnsupportedEncodingException ex)
        {
        }
   }

// This must be called during parsing, so that the order is always the same. Allowing names
// to be allocated this way during rendering would cause problems with adaptive items where
// rendering may not always be done in the same order.
    public String getNextName()
    {
        String name = "apisvar_" + String.valueOf(getCounter);
        getCounter++;
        return name;
    }

    public String get(String name)
    {
        for (int n = 0; n < alldata.size(); n++)
        {
             if(((apisPersistancePart)alldata.get(n)).name.equals(name))
             {
                 return ((apisPersistancePart)alldata.get(n)).data;
             }
        }
        return null;
    }

    public void add(String name, String data)
    {
        //assert(name!=null);
        apisPersistancePart tmp = new apisPersistancePart(name,data);
        alldata.add(tmp);
    }
}

class apisPersistancePart
{
    String name;
    String data;

    public apisPersistancePart(String nName, String nData)
    {
        name = nName;
        data = nData;
    }
}
