package apis.expression;

import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2variableDeclaration;

/**
 * This expression, which can only be used in outcomes processing, calculates the number of items in a given ub-set that
 * have been attempted (at least once). In other words, items with which the user has interacted, whether or not they
 * provided a response. The result is an integer with single cardinality.
 * 
 * **/
public class QTIv21Expr_numberPresented extends QTIv2expression {
	String sectionIdentifier;

	public QTIv21Expr_numberPresented(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		if (itemXML.getAttribute(idx, "sectionIdentifier") != null) {
			sectionIdentifier = itemXML.getAttribute(idx, "sectionIdentifier");
		} else
			sectionIdentifier = null;

		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		QTIv2variableDeclaration c2 = theTest.getNumberPresented(sectionIdentifier);

		if (c2 == null)
			throw new InvalidQTIv2Exception("something horrible has gone wrong resolving variable numberResponded");
		return ((QTIv2variableDeclaration) c2).getDuplicate();
	}

}
