package apis.expression;

//import java.util.Vector;
import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_baseValue extends QTIv2expression {
	QTIv2variableDeclaration content;

	public QTIv2Expr_baseValue(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_baseValue(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		int type = QTIv2variableDeclaration.identifyType(itemXML.getAttribute(idx, "baseType"));
		content = new QTIv2variableDeclaration(null, QTIv2variableDeclaration.CARD_single, type);
		String strcontent = itemXML.getContent(idx);
		content.setValue(strcontent);
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		return content;
	}

}
