package apis.expression;

//import java.util.Vector;
import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2responseDeclaration;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_correct extends QTIv2expression {
	String identifier;

	public QTIv2Expr_correct(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_correct(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		identifier = itemXML.getAttribute(idx, "identifier");
		assert (identifier != "");
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		QTIv2variableDeclaration var = theItem.getVariable(identifier);
		if (var == null)
			throw new InvalidQTIv2Exception("something horrible has gone wrong resolving variable " + identifier);

		// UPF - Javi
		QTIv2variableDeclaration cor = ((QTIv2responseDeclaration) var).getCorrect();

		if (cor == null)
			throw new InvalidQTIv2Exception("Failed to get correct value for variable " + identifier);
		return cor;
	}
}
