package apis.expression;

//import java.util.Vector;
import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_delete extends QTIv2expression {
	QTIv2expression needle;
	QTIv2expression haystack;

	public QTIv2Expr_delete(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_delete(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		int cidx = itemXML.findChildElement(idx);
		if (cidx != -1) {
			needle = QTIv2expression.parseNew(theItem, itemXML, cidx);
			cidx = itemXML.findNextPeer(cidx);
		} else
			throw new InvalidQTIv2Exception("'needle' expression missing in delete expression.");
		if (cidx != -1) {
			haystack = QTIv2expression.parseNew(theItem, itemXML, cidx);
		} else
			throw new InvalidQTIv2Exception("'haystack' expression missing in delete expression.");
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		QTIv2variableDeclaration del = needle.resolve();
		QTIv2variableDeclaration out = haystack.resolve();
		if ((del == null) || (out == null))
			throw new InvalidQTIv2Exception("null pointer in delete - a nasty unexpected error!");
		if (del.getType() != out.getType())
			throw new InvalidQTIv2Exception("delete element with different types");
		if (!del.isNull())
			out.deleteParts(del);
		return out;
	}

}
