package apis.expression;

import java.util.Vector;

import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2responseDeclaration;
import apis.QTIv2variableDeclaration;

public class QTIv2Expr_divide extends QTIv2expression {
	Vector contents;

	public QTIv2Expr_divide(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_divide(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception

	{
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {

		contents = new Vector();
		QTIv2expression expr = null;
		int cidx = itemXML.findChildElement(idx);
		while (cidx != -1) {
			if (theItem == null)
				expr = QTIv2expression.parseNew(theTest, itemXML, cidx);
			else if (theTest == null)
				expr = QTIv2expression.parseNew(theItem, itemXML, cidx);
			contents.add(expr);
			cidx = itemXML.findNextPeer(cidx);
		}
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		float out = 0;
		QTIv2variableDeclaration outvar;

		QTIv2variableDeclaration dividend = ((QTIv2expression) contents.get(0)).resolve();
		QTIv2variableDeclaration divisor = ((QTIv2expression) contents.get(1)).resolve();

		if (dividend == null || divisor == null)
			throw new InvalidQTIv2Exception("Null QTIv2Variable while resolving divide");

		Float tmpfloat1 = dividend.toFloat();
		Float tmpfloat2 = divisor.toFloat();

		if (tmpfloat1 == null || tmpfloat2 == null)
			return new QTIv2responseDeclaration(null, QTIv2variableDeclaration.CARD_single,
					QTIv2variableDeclaration.VTYPE_float);
		else
			out = tmpfloat1.floatValue() / tmpfloat2.floatValue();

		outvar = new QTIv2responseDeclaration(null, QTIv2variableDeclaration.CARD_single,
				QTIv2variableDeclaration.VTYPE_float);
		outvar.setValue(out);
		return outvar;
	}

}
