package apis.expression;

import java.util.Vector;

import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_lte extends QTIv2expression {
	Vector contents; // probably a list of QTIv2expression

	public QTIv2Expr_lte(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_lte(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		contents = new Vector();
		QTIv2expression expr = null;
		int cidx = itemXML.findChildElement(idx);
		while (cidx != -1) {
			if (theItem == null)
				expr = QTIv2expression.parseNew(theTest, itemXML, cidx);
			else if (theTest == null)
				expr = QTIv2expression.parseNew(theItem, itemXML, cidx);
			contents.add(expr);
			cidx = itemXML.findNextPeer(cidx);
		}

		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		// CALCULAR EL LTE
		boolean out = false;

		if (contents.size() == 2) {
			QTIv2variableDeclaration var1 = ((QTIv2expression) contents.get(0)).resolve();
			QTIv2variableDeclaration var2 = ((QTIv2expression) contents.get(1)).resolve();

			Float f1 = var1.toFloat();
			Float f2 = var2.toFloat();
			System.out.println("f1 : " + f1.floatValue());
			System.out.println("f2 : " + f2.floatValue());

			if (f1.floatValue() <= f2.floatValue())
				out = true;
		} else
			throw new InvalidQTIv2Exception("can't resolve lt with less then two elements or with just one element");

		return QTIv2variableDeclaration.newBooleanVar(out);
	}

}
