package apis.expression;

//import java.util.Vector;
import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2responseDeclaration;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_mapResponse extends QTIv2expression {
	// # Vector contents; // probably a list of QTIv2expression
	String identifier;

	public QTIv2Expr_mapResponse(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_mapResponse(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		if (itemXML.getName(idx).equals("mapResponse")) {
			identifier = itemXML.getAttribute(idx, "identifier");
			if (identifier.length() == 0)
				throw new InvalidQTIv2Exception("Invalid or no identifier in mapResponse");
		} else
			throw new InvalidQTIv2Exception("Something went wrong reading mapResponse");
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		QTIv2variableDeclaration c2 = theItem.getVariable(identifier);
		if (c2 == null)
			throw new InvalidQTIv2Exception("Something horrible has gone wrong resolving variable " + identifier);

		// UPF - Javi
		// return c2.mapResponse();
		return ((QTIv2responseDeclaration) c2).mapResponse();
	}

}
