package apis.expression;

import java.util.Vector;

import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_match extends QTIv2expression {
	Vector contents; // probably a list of QTIv2expression

	public QTIv2Expr_match(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_match(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		contents = new Vector();
		QTIv2expression expr;
		int cidx = itemXML.findChildElement(idx);
		while (cidx != -1) {
			expr = QTIv2expression.parseNew(theItem, itemXML, cidx);
			contents.add(expr);
			cidx = itemXML.findNextPeer(cidx);
		}
		if (contents.size() != 2)
			throw new InvalidQTIv2Exception("match expression does not contain two expressions.");
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		QTIv2variableDeclaration a, b;
		assert (contents.size() == 2);

		b = ((QTIv2expression) contents.get(1)).resolve();
		a = ((QTIv2expression) contents.get(0)).resolve();

		if (a.match(b)) {

			return QTIv2variableDeclaration.newBooleanVar(true);
		} else {
			// System.out.println("not equals");

			return QTIv2variableDeclaration.newBooleanVar(false);
		}
	}

}
