package apis.expression;

import java.util.Vector;

import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2responseDeclaration;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_multiple extends QTIv2expression {
	Vector contents; // they will be aggrigated into a multiple card var in resolve

	public QTIv2Expr_multiple(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_multiple(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		contents = new Vector();
		QTIv2expression expr;
		int cidx = itemXML.findChildElement(idx);
		while (cidx != -1) {
			expr = QTIv2expression.parseNew(theItem, itemXML, cidx);
			contents.add(expr);
			cidx = itemXML.findNextPeer(cidx);
		}
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		if ((contents == null) || (contents.size() == 0))
			throw new InvalidQTIv2Exception("empty multiple element");

		QTIv2variableDeclaration out;
		QTIv2variableDeclaration tmp = ((QTIv2expression) contents.get(0)).resolve();
		out = new QTIv2responseDeclaration(null, QTIv2variableDeclaration.CARD_multiple, tmp.getType());

		out.setValue(tmp);
		for (int n = 1; n < contents.size(); n++) {
			out.setValue(((QTIv2expression) contents.get(n)).resolve());
		}
		return out;
	}

}
