package apis.expression;

//import java.util.Vector;
import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_not extends QTIv2expression {
	QTIv2expression content;

	public QTIv2Expr_not(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_not(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		int cidx = itemXML.findChildElement(idx);
		if (cidx != -1) {
			content = QTIv2expression.parseNew(theItem, itemXML, cidx);
		} else
			throw new InvalidQTIv2Exception("empty not expression.");
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		if (content.resolve().isTrue())
			return QTIv2variableDeclaration.newBooleanVar(false);
		else
			return QTIv2variableDeclaration.newBooleanVar(true);
	}

}
