package apis.expression;

import java.util.Vector;

import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_or extends QTIv2expression {
	Vector contents; // probably a list of QTIv2expression

	public QTIv2Expr_or(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_or(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		// # fill in the parse stuff here (likely to use QTIv2expression::parseNew)
		// # return true if it works
		contents = new Vector();
		QTIv2expression expr;
		int cidx = itemXML.findChildElement(idx);
		while (cidx != -1) {
			expr = QTIv2expression.parseNew(theItem, itemXML, cidx);
			contents.add(expr);
			cidx = itemXML.findNextPeer(cidx);
		}
		// if(contents.size()<2)
		// throw new InvalidQTIv2Exception("and expression contains less than two expressions.");
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		boolean out = true;
		for (int n = 0; n < contents.size(); n++) {
			out |= ((QTIv2expression) contents.get(n)).resolve().isTrue();
		}
		return QTIv2variableDeclaration.newBooleanVar(out);
	}

}
