package apis.expression;

//import java.util.Vector;
import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2responseDeclaration;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_random extends QTIv2expression {
	QTIv2expression content;

	public QTIv2Expr_random(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_random(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		int cidx = itemXML.findChildElement(idx);
		if (cidx != -1) {
			content = QTIv2expression.parseNew(theItem, itemXML, cidx);
		} else
			throw new InvalidQTIv2Exception("empty random expression.");
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		QTIv2variableDeclaration in = content.resolve();
		QTIv2variableDeclaration out = new QTIv2responseDeclaration(null, QTIv2variableDeclaration.CARD_single, in
				.getType());

		int sz = in.getSize();
		double rnd = Math.random();
		int ch = (int) Math.floor(rnd * sz);
		if (ch == sz)
			ch--;
		out.setValue(in.getStringValue(ch));
		return out;
	}

}
