package apis.expression;

import java.util.Vector;

import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2responseDeclaration;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_sum extends QTIv2expression {
	Vector contentItem; // probably a list of QTIv2expression
	Vector contentTest;
	Vector contents;

	public QTIv2Expr_sum(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_sum(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		contents = new Vector();
		QTIv2expression expr = null;
		int cidx = itemXML.findChildElement(idx);
		while (cidx != -1) {
			if (theItem == null) {
				expr = QTIv2expression.parseNew(theTest, itemXML, cidx);
			} else if (theTest == null) {
				expr = QTIv2expression.parseNew(theItem, itemXML, cidx);
			}
			contents.add(expr);
			cidx = itemXML.findNextPeer(cidx);
		}
		return true;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		float out = 0;

		QTIv2variableDeclaration outvar = null;

		boolean isInt = true;

		for (int n = 0; n < contents.size(); n++) {
			QTIv2variableDeclaration tmpvar = ((QTIv2expression) contents.get(n)).resolve();

			if (tmpvar == null)
				throw new InvalidQTIv2Exception("Null QTIv2Variable while resolving sum");

			if (tmpvar.getType() != QTIv2variableDeclaration.VTYPE_integer)
				isInt = false;

			// suma testVariables
			if (tmpvar.getRelatedItemsVarDec().size() > 0) // hem d'agafar les variable guardades dins variable
															// Declaration
			{
				QTIv2variableDeclaration aux = null;

				Vector related = tmpvar.getRelatedItemsVarDec();

				for (int i = 0; i < tmpvar.getRelatedItemsVarDec().size(); i++) {
					aux = (QTIv2variableDeclaration) related.get(i);
					Float tmpfloat = aux.toFloat();

					if (tmpfloat == null)
						return new QTIv2responseDeclaration(null, QTIv2variableDeclaration.CARD_single,
								QTIv2variableDeclaration.VTYPE_float);
					else
						out += tmpfloat.floatValue();
				}
			} else {

				Float tmpfloat = tmpvar.toFloat();

				if (tmpfloat == null)
					return new QTIv2responseDeclaration(null, QTIv2variableDeclaration.CARD_single,
							QTIv2variableDeclaration.VTYPE_float);
				else
					out += tmpfloat.floatValue();
			}
		}
		if (isInt)
			outvar = new QTIv2variableDeclaration(null, QTIv2variableDeclaration.CARD_single,
					QTIv2variableDeclaration.VTYPE_integer);
		else
			outvar = new QTIv2variableDeclaration(null, QTIv2variableDeclaration.CARD_single,
					QTIv2variableDeclaration.VTYPE_float);

		// System.out.println("sum result is:"+out);

		outvar.setValue(out);
		return outvar;
	}
}
