package apis.expression;

//import java.util.Vector;
import java.util.Vector;

import nb_utils.NBEasyXML;
import apis.InvalidQTIv2Exception;
import apis.QTIv21test;
import apis.QTIv2expression;
import apis.QTIv2item;
import apis.QTIv2variableDeclaration;

/**
 * <p>
 * Title: APIS (expression)
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class QTIv2Expr_variable extends QTIv2expression {
	String identifier;
	String itemIdentifier;
	String outcomeIdentifier;
	String weightIdentifier;
	float weight = 0;
	Vector weighted = new Vector();
	boolean initExec = true;

	public QTIv2Expr_variable(QTIv2item owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	public QTIv2Expr_variable(QTIv21test owner, NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		super(owner, itemXML, idx);
	}

	protected boolean parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception {
		// s'ha de mirar si la variable te un _ perque llavors hem d'accedir a la "SCORE" de dins l'item especificat

		if (itemXML.getAttribute(idx, "identifier") != null)
			identifier = itemXML.getAttribute(idx, "identifier");
		else
			throw new InvalidQTIv2Exception("identifier needed ");

		if (itemXML.getAttribute(idx, "weightIdentifier") != null)
			weightIdentifier = itemXML.getAttribute(idx, "weightIdentifier");
		else
			weightIdentifier = null;

		if (identifier.contains("_")) {

			String[] values = identifier.split("_"); // public String[] split(String regex,int limit) divideix segons un
														// caracter
			itemIdentifier = values[0];
			outcomeIdentifier = values[1];
		} else {
			itemIdentifier = null;
			outcomeIdentifier = null;
		}

		return true;
	}

	public boolean checkWeighted(QTIv2item searchedItem) {
		for (int index = 0; index < weighted.size(); index++)
			if (weighted.get(index).equals(searchedItem.getIdentifier()))
				return true;
		return false;
	}

	public QTIv2variableDeclaration resolve() throws InvalidQTIv2Exception {
		QTIv2variableDeclaration c2 = null;
		QTIv2item searchedItem;
		weight = 0;

		if (itemIdentifier == null && outcomeIdentifier == null) {
			if (theItem == null)
				c2 = theTest.getOutcomeVariable(identifier);
			if (theTest == null)
				c2 = theItem.getVariable(identifier);
			if (weightIdentifier != null)
				theItem.setWeightIdentifier(weightIdentifier);
		}
		// identifier = itemIdentifier_outcomeIdentifier
		else if (theItem == null) {
			// firstly search the item
			Vector searchedItems = new Vector();
			theTest.findItem(itemIdentifier, searchedItems);
			searchedItem = (QTIv2item) searchedItems.get(0);
			// secondly search in this item the specified variable
			c2 = searchedItem.getVariable(outcomeIdentifier);
			if (weightIdentifier != null)
				searchedItem.setWeightIdentifier(weightIdentifier);
		}
		/*
		 * if(c2.getValue().firstElement() instanceof )
		 */

		if (c2 == null)
			throw new InvalidQTIv2Exception("something horrible has gone wrong resolving variable " + identifier);
		return ((QTIv2variableDeclaration) c2).getDuplicate();
	}

}
