package apis;

import nb_utils.NBEasyXML;

/**
 * <p>Title: APIS test wrapper</p>
 * <p>Description: A very very simple HTTP server</p>
 * <p>Copyright: Copyright (c) 2004, University of Strathclyde</p>
 * <p>Company: University of Strathclyde/JISC</p>
 * @author not attributable
 * @version 1.0
 */

public class responseIfPart
{
    QTIv2item theItem;

    QTIv2expression logic;
    QTIv2responseActionCollection actions;

    public responseIfPart(QTIv2item owner)
    {
        theItem = owner;
    }

    public int parse(NBEasyXML itemXML, int idx) throws InvalidQTIv2Exception
    {
        // responseIf etc. have no attributes
        // responseIf and responseElseIf start with an expression (which should resolve to a boolean)
        int ifType = QTIv2define.identify(itemXML.getName(idx));
        //assert((ifType==QTIv2Define.QTIv2_responseIf)||(ifType==QTIv2Define.QTIv2_responseElseIf)||(ifType==QTIv2Define.QTIv2_responseElse));
        int cidx = itemXML.findChildElement(idx);
        if(ifType != QTIv2define.QTIv2_responseElse)
        {
            logic = QTIv2expression.parseNew(theItem, itemXML, cidx);
            cidx = itemXML.findNextPeer(cidx);
        }
        // after the expression are zero or more actions
        if(cidx != -1)
        {
            actions = new QTIv2responseActionCollection(theItem);
            actions.parse(itemXML, cidx);
        }
        return itemXML.findNextPeer(idx);  // -1 if no more peers
    }

    public boolean doIt() throws InvalidQTIv2Exception
    {
        if((logic == null)||(logic.resolve().isTrue()))
        {
            if(actions != null)
                actions.run();
            return true;
        }
        return false;
    }

}
