package apistesthost;

import java.net.ServerSocket;
import java.net.Socket;
import java.util.Vector;

import apis.QTIv21test;

/**
 * <p>
 * Title: APIS test wrapper
 * </p>
 * <p>
 * Description: A very very simple HTTP server
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 * 
 *          <p>
 *          <b>Non-original code notes.</b><br/>
 *          There are bits of code derived from HttpMirror.java (Java Examples in a Nutshell p192) in the
 *          SimplisticHTTPd class and a line of code from Reload (www.reload.ac.uk) is used to launch the browser. I
 *          also looked at http://www.soi.city.ac.uk/~till/ooj/slides203/node79.html to find out how to do a very simple
 *          form of multi-threading.
 *          </p>
 */

class SimplisticHTTPd implements Runnable {
	public String itemDir;
	int port;
	boolean started;
	String testDir = "";
	String mediaDir = "";
	String appletDir = "";
	boolean debugMode = false;
	boolean initExecution = true;
	Vector processedItems = new Vector();
	QTIv21test theTest;
	String testXML;

	public int getPort() {
		return port;
	}

	public void run() {
		try {
			port = 1234;
			ServerSocket ss = null;
			while (ss == null) {
				try {
					ss = new ServerSocket(port);
				} catch (Exception e) {
					e.printStackTrace();

					port++;
				}
			}
			started = true;

			// now the infinite loop, waiting for connections and handling them
			for (;;) {
				// blocking connection

				Socket client = ss.accept();
				Connection now;
				Thread current = new Thread(now = new Connection(client));
				current.setDaemon(true);
				current.start(); // start the user's thread
			}

		} catch (Exception e) {
			System.err.println(e);
			e.printStackTrace();
		}
	}
}