package nb_utils;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Serializable;
import java.net.URI;
import java.net.URL;
import java.util.Hashtable;
import java.util.Vector;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.InputSource;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.AttributesImpl;
import org.xml.sax.helpers.DefaultHandler;

/**
 * <p>
 * Title: APIS test wrapper
 * </p>
 * <p>
 * Description: A very very simple HTTP server
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004, University of Strathclyde
 * </p>
 * <p>
 * Company: University of Strathclyde/JISC
 * </p>
 * 
 * @author Niall S F Barr
 * @version 1.0
 */

public class NBEasyXML extends DefaultHandler implements ContentHandler, Serializable {
	private int depth, parseMode;

	protected Vector data;

	public String tmpmsg;

	public NBEasyXML(String theXML) {

		System.out.println("[***] NBEasyXML instantiated with an content String : \n\t [" + theXML.substring(0, 30)
				+ "]\n");

		data = new Vector();

		// Yahoo search for "converting a String to an  InputSource" threw up
		// this -
		// http://saloon.javaranch.com/cgi-bin/ubb/ultimatebb.cgi?ubb=get_topic&f=31&t=000027
		// converting the string data into InputSource form to pass it to the
		// parser
		java.io.StringReader reader = new java.io.StringReader(theXML);
		org.xml.sax.InputSource source = new org.xml.sax.InputSource(reader);
		// end of bit from Yahoo search result
		SAXParserFactory factory = SAXParserFactory.newInstance();
		try {
			// Parse the input
			factory.setValidating(false);
			SAXParser parser = factory.newSAXParser();
			depth = 0;
			parser.parse(source, this);
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}

	public NBEasyXML(URI uri, Hashtable xml_container) {

		System.out.println("NBEasyXML instantiated with a Hashtable and uri:" + uri);

		if (xml_container.containsKey(uri.toString())) {
			data = new Vector();
			System.out.println("\t instantiated with a Hashtable string content");
			// Yahoo search for "converting a String to an  InputSource" threw up
			// this -
			// http://saloon.javaranch.com/cgi-bin/ubb/ultimatebb.cgi?ubb=get_topic&f=31&t=000027
			// converting the string data into InputSource form to pass it to the
			// parser
			java.io.StringReader reader = new java.io.StringReader((String) xml_container.get(uri.toString()));
			org.xml.sax.InputSource source = new org.xml.sax.InputSource(reader);
			// end of bit from Yahoo search result
			SAXParserFactory factory = SAXParserFactory.newInstance();
			try {
				// Parse the input
				factory.setValidating(false);
				SAXParser parser = factory.newSAXParser();
				depth = 0;
				parser.parse(source, this);
			} catch (Throwable t) {
				t.printStackTrace();
			}
		} else {
			System.out.println("\t  instantiated with a URI");
			data = new Vector();
			SAXParserFactory factory = SAXParserFactory.newInstance();
			try {
				// Parse the input
				factory.setValidating(false);
				SAXParser parser = factory.newSAXParser();
				depth = 0;
				//13-07-13 Convertimos el contenido a formato UTF-8
				// encode the xml to UTF -8
				InputStream input = new URL(uri.toString()).openStream(); // getContentResolver().openInputStream(uri);
				InputSource inputSource = new InputSource(new InputStreamReader(input));
				InputSource is = new InputSource(uri.toString());
				System.out.println("File Encoding: "+System.getProperty("file.encoding"));
				is.setEncoding("UTF-8");
				

                //ByteArrayInputStream encXML = new  ByteArrayInputStream(xml.getBytes("UTF8"));
				
				//Linea comentada i nova linea
				//parser.parse(uri.toString(), this);
				
				//parser.parse(is, this);
				parser.parse(inputSource, this);
				
			} catch (Throwable t) {
				t.printStackTrace();
			}
		}

	}

	// TODO modify the authors of this source file
	public NBEasyXML(URI uri) {
		data = new Vector();
		SAXParserFactory factory = SAXParserFactory.newInstance();
		try {
			// Parse the input
			factory.setValidating(false);
			SAXParser parser = factory.newSAXParser();
			depth = 0;

			System.out.println("[***][ ! ATENTION ! ] NBEasyXML instantiated with an uri:" + uri);

			parser.parse(uri.toString(), this);
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}

	// start of changed code 20050602 Harrie Martens and Hubert Vogten
	public void startElement(String namespaceURI, String localName, String qName, Attributes atts) throws SAXException {
		NBEasyXMLElement tmp = new NBEasyXMLElement(qName, atts);
		tmp.depth = depth;
		data.add(tmp);
		// IndexElement(data.size()-1, localName, depth); // this didn't work
		// :-(
		depth++;
	}

	void IndexElement(int index, String name, int depth) {

	}

	public void endElement(String namespaceURI, String localName, String qName) throws SAXException {
		NBEasyXMLEndElement tmp = new NBEasyXMLEndElement(qName);
		tmp.depth = depth;
		data.add(tmp);
		// IndexEndElement(data.size()-1, localName, depth);
		depth--;
	}

	void IndexEndElement(int index, String name, int depth) {

	}

	public void characters(char[] ch, int start, int length) throws SAXException {
		String st = "";
		for (int n = start; n < length + start; n++)
			st += ch[n];
		NBEasyXMLContent tmp = new NBEasyXMLContent(st);
		tmp.depth = depth;
		data.add(tmp);
	}

	// This is the EasyXML interface stuff
	public String ExportBlock(int startIdx) {
		String out = "";
		if (startIdx < 0)
			startIdx = 0; // should really be an ASSERT
		NBEasyXMLPart tmp = (NBEasyXMLPart) data.get(startIdx);
		if (tmp.type == 1) {
			int startDepth = tmp.depth;
			int idx = startIdx;
			do {
				out += tmp.getAsString();
				idx++;
				if (idx >= data.size())
					return out; // probably an error, maybe should catch it....
				tmp = (NBEasyXMLPart) data.get(idx);
			} while (tmp.depth > startDepth);
		} else if (tmp.type == 4) {
			out = tmp.getAsString();
		}
		return out;
	}

	public String ExportSection(int startIdx, int endIdx) {
		String out = "";
		NBEasyXMLPart tmp;
		int idx;
		if (startIdx < 0)
			startIdx = 0; // should really be an ASSERT
		if (endIdx < startIdx)
			endIdx = startIdx; // should really be an ASSERT
		for (idx = startIdx; idx <= endIdx; idx++)
			;
		{
			if (idx >= data.size())
				return out; // probably an error, maybe should catch it....
			tmp = (NBEasyXMLPart) data.get(idx);
			out += tmp.getAsString();
		}
		return out;
	}

	public int findNextPeer(int startIdx) {
		// # possibly this should really return -1 if it starts with an end
		// element or is out of range.
		// # or it could just throw an exception...
		NBEasyXMLPart tmp = (NBEasyXMLPart) data.get(startIdx);
		if (tmp.type == 1) {
			int startDepth = tmp.depth;
			int idx = startIdx;
			do {
				idx++;
				if (idx >= data.size())
					return -1; // probably an error, maybe should catch it....
				tmp = (NBEasyXMLPart) data.get(idx);
			} while ((tmp.depth > startDepth) || (tmp.type != 1));
			String s = tmp.getAsString();
			if (tmp.depth == startDepth)
				return idx;
			else
				return -1;
		} else
			return -1;
	}

	public int findEnd(int idx) {
		NBEasyXMLPart tmp = (NBEasyXMLPart) data.get(idx);
		// assert(tmp.type == 1);
		String nm = getName(idx);
		int depth = tmp.depth;
		int cidx = idx;
		do {
			cidx++;
			tmp = (NBEasyXMLPart) data.get(cidx);
		} while (tmp.depth > depth);
		// assert((((NBEasyXMLPart) data.get(cidx-1)).depth ==
		// depth+1)&&(getName(cidx-1).equals(nm)));
		return cidx - 1;
	}

	public int findChildElement(int idx) {
		NBEasyXMLPart tmp = (NBEasyXMLPart) data.get(idx);
		if (tmp.type == 1) {
			int depth = tmp.depth + 1;
			int cidx = idx;
			do {
				cidx++;
				if (cidx >= data.size())
					return -1; // probably an error, maybe should catch it....
				tmp = (NBEasyXMLPart) data.get(cidx);
				if ((tmp.depth == depth) && (tmp.type == 1))
					return cidx;
			} while (tmp.depth >= depth);
			return -1; // if it has got this far there is no next peer
		} else
			return -1;

	}

	public int root() {
		NBEasyXMLPart tmp;
		int cidx = 0;
		while (cidx < data.size()) {
			tmp = (NBEasyXMLPart) data.get(cidx);
			if (tmp.type == 1)
				return cidx;
			cidx++;
		}
		return -1;
	}

	public int getType(int idx) {
		NBEasyXMLPart tmp = (NBEasyXMLPart) data.get(idx);
		return tmp.type;
	}

	public int getDepth(int idx) {
		NBEasyXMLPart tmp = (NBEasyXMLPart) data.get(idx);
		return tmp.depth;
	}

	public String getName(int idx) {
		NBEasyXMLPart tmp = (NBEasyXMLPart) data.get(idx);
		switch (tmp.type) {
		case 1:
			NBEasyXMLElement t2 = (NBEasyXMLElement) tmp;
			return t2.localName;
		case 2:
			NBEasyXMLEndElement t3 = (NBEasyXMLEndElement) tmp;
			return t3.localName;
		default:
			return null;
		}
	}

	public int size() {
		return data.size();
	}

	public String getAttribute(int idx, String attName) {
		NBEasyXMLPart tmp = (NBEasyXMLPart) data.get(idx);
		if (tmp.type == 1) {
			NBEasyXMLElement elm = (NBEasyXMLElement) tmp;
			return elm.atts.getValue(attName);
		} else
			return null; // actually an error.
	}

	// # only for unmixed content (stops at the first element;
	public String getContent(int idx) {
		String out = "";
		NBEasyXMLPart tmp = (NBEasyXMLPart) data.get(idx);
		if (tmp.type == 1) {
			int cidx = idx + 1;
			tmp = (NBEasyXMLPart) data.get(cidx);
			while (tmp.type == 4) {
				out += tmp.getAsString();
				cidx++;
				tmp = (NBEasyXMLPart) data.get(cidx);
			}
		}
		return out;
	}

	public int getIntegerAttribute(int idx, String attName, int defval) {
		String tmp = getAttribute(idx, attName);
		if (tmp == null)
			return defval;
		else {
			int out;
			try {
				out = Integer.parseInt(tmp);
			} catch (NumberFormatException e) {
				return defval;
			}
			return out;
		}
	}

	public String getAsString(int idx) {
		NBEasyXMLPart tmp = (NBEasyXMLPart) data.get(idx);
		return tmp.getAsString();
	}

	// following methods are required by the ContentHandler interface, but
	// unused...
	public void startDocument() throws SAXException {
	}

	public void endDocument() throws SAXException {
	}

	public void setDocumentLocator(Locator locator) {
	}

	public void startPrefixMapping(String prefix, String uri) throws SAXException {
	}

	public void endPrefixMapping(String prefix) throws SAXException {
	}

	public void ignorableWhitespace(char[] ch, int start, int length) throws SAXException {
	}

	public void processingInstruction(String target, String data) throws SAXException {
	}

	public void skippedEntity(String name) throws SAXException {
	}

}

abstract class NBEasyXMLPart {
	int type;
	int depth;

	abstract String getAsString();
}

class NBEasyXMLElement extends NBEasyXMLPart {
	String localName;
	AttributesImpl atts;

	NBEasyXMLElement(String name, Attributes nAtts) {
		type = 1; // in C++ ver this would be EXML_START_TAG, probably should
		// make it a const var....
		localName = new String(name);
		atts = new AttributesImpl(nAtts);
	}

	String getAsString() {
		String out = "";
		out += "<" + localName;
		for (int n = 0; n < atts.getLength(); n++) {
			if (atts.getValue(n).indexOf("\"") == -1)
				out += " " + atts.getQName(n) + "=\"" + atts.getValue(n) + "\"";
			else
				out += " " + atts.getQName(n) + "='" + atts.getValue(n) + "'";
		}
		out += ">";
		return out;
	}

	String getAsWebString() {
		String out = "";
		out += "&lt;" + localName;
		for (int n = 0; n < atts.getLength(); n++) {
			if (atts.getValue(n).indexOf("\"") == -1)
				out += " " + atts.getQName(n) + "=\"" + atts.getValue(n) + "\"";
			else
				out += " " + atts.getQName(n) + "='" + atts.getValue(n) + "'";
		}
		out += "&gt;";
		return out;
	}
}

class NBEasyXMLEndElement extends NBEasyXMLPart {
	String localName;

	NBEasyXMLEndElement(String name) {
		type = 2; // in C++ ver this would be EXML_END_TAG, probably should make
		// it a const var....
		localName = new String(name);
	}

	String getAsString() {
		return "</" + localName + ">";
	}

	String getAsWebString() {
		return "&lt;/" + localName + "&gt;";
	}
}

class NBEasyXMLContent extends NBEasyXMLPart {
	String content;

	NBEasyXMLContent(String nContent) {
		type = 4; // in C++ ver this would be EXML_CONTENT, probably should make
		// it a const var....
		content = nContent;
	}

	String getAsString() {
		return content;
	}

	String getAsWebString() {
		// # should really do translation of chars, however for now this will
		// do.
		return content;
	}
}
